package seu.agent.Ambulance;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.EnumSet;
import java.util.List;

import rescuecore2.messages.Command;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUCentre;
import seu.message.MessagePriority;
import seu.message.Type.AgentPositionMessage;
import seu.message.Type.BuildingIsExploredMessage;
import seu.message.Type.BuildingMaybeMessage;
import seu.message.Type.BuildingMaybeMessage_at;
import seu.message.Type.CivilianInformationMessage;
import seu.message.Type.CivilianMaybeMessage;
import seu.message.Type.InformTeamSavingCivilianMessage;
import seu.message.Type.Message;
import seu.message.Type.MessageType;
import seu.object.SEUWorldModel;
import seu.utilities.NumberOfMessageComparator;

public class SEUAmbulanceCentre extends SEUCentre {

	CivilianSaveTaskManager civilianSaveTaskManager;
	List<NumberOfMessage> numOfmessage;           
	List<NumberOfMessage> neibormessage;         //pxq
//	List<NumberOfMessage> mostmessage;        //pxq
	EntityID [] mayinbuildingId;             ///lb
	numcomparator cmp ;//pxq

	public SEUAmbulanceCentre() {
		super();
		 numOfmessage=new ArrayList<NumberOfMessage>(50);
		 neibormessage=new ArrayList<NumberOfMessage>(50);//pxq
//		 mostmessage=new ArrayList<NumberOfMessage>();//pxq
		 mayinbuildingId=new EntityID[50];//lb
		
		  cmp = new numcomparator();//pxq
	}

	@Override
	public String toString() {
		return "SEU Ambulance Center";
	}

	@Override
	protected void postConnect() {
		super.postConnect();

		this.world = (SEUWorldModel) super.model;

		world.indexClass(StandardEntityURN.BUILDING, StandardEntityURN.REFUGE);

		civilianSaveTaskManager = new CivilianSaveTaskManager(world);
		numOfmessage = new ArrayList<NumberOfMessage>();
		 //System.out.println("AC time  "+timeStep+" ac worldmodel "+world);
	}

	@Override
	protected void thinkAndAct() {

	}

	void updata() {
		 
		//System.out.println(numOfmessage);
		try {
			Collections.sort(numOfmessage, new NumberOfMessageComparator());
			//System.out.println("time  " + timeStep+" neibormessage.size() "+neibormessage.size());
			int k=0;
			while((k<neibormessage.size())&&(k<50)){
			//	System.out.println("time  " + timeStep + " k: "+k+" "+neibormessage.get(k).getbuilding());
				
				mayinbuildingId[k]=neibormessage.get(k).getbuilding();
				
				k++;				
			}
	
			if (timeStep % 10 == 1) {
				//System.err.println("BuildingMaybeMessage_at"+Arrays.asList(mayinbuildingId));
				int i = 0;
				for (NumberOfMessage h : numOfmessage) {
					i++;
					if (i > 40)
						break;
					BuildingMaybeMessage message = new BuildingMaybeMessage(
							h.getbuilding());
					sendMessage(message, MessagePriority.High);
 					
					BuildingMaybeMessage_at message1 = new BuildingMaybeMessage_at(h.getbuilding(), mayinbuildingId);///lb
					 
	     			sendMessage(message1, 1);
	     			//System.err.println("send BuildingMaybeMessage_at "+message1.getCivilianMayInBuildingId()[0]+" "+message1.getCivilianMayInBuildingId()[1]+ " "+message1.getCivilianMayInBuildingId()[2]);
 				}
				neibormessage.clear();

			}
		} catch (Exception e) {
			System.err.println("AMBU center err");System.err.println(e.getMessage());
		}
	}

	protected void think(int time, ChangeSet changed, Collection<Command> heard) {
		// System.out.println("AC time  "+timeStep+" ChangeSet "+changed);
		//System.out.println("AC time  "+timeStep+" world "+world.getAllEntities());
		Date decisionEndTime;
		// System.out.println("  time  "+timeStep+"   heard  "+heard);
		decisionStartTime = new Date();

		setTimeStep(time);

		if (time == 1) {

		}
		if (time == startTime) {
			int[] channels;
			setCommunicationCondition();
			channels = getChannelsToSubscribe();
			sendSubscribe(time, channels);
		}
		if (time >= startTime) {
			changeSet = changed;
			if (time == startTime) {
				for (StandardEntity s : world.getAllEntities())
					if (s instanceof Building) {						
						NumberOfMessage h = new NumberOfMessage();
						h.setbuilding(s.getID());						
						 
						numOfmessage.add(h);
					}
			}
			//System.out.println("time  " + timeStep + "world"+world.getAllEntities());
			//System.out.println("time  " + timeStep + " num  " +numOfmessage);
			processHearing(heard);
			// Collections.sort(numOfmessage, new NumberOfMessageComparator());
			//System.out.println("time  " + timeStep + " num  "++ numOfmessage.size() + "   " + numOfmessage);
			updata();
			sendMessagesFromQueue();

		}
		decisionEndTime = new Date();

		double dt = decisionEndTime.getTime() - decisionStartTime.getTime();

		if (dt > agentThinkTime / 2) {
			System.err.println(me() + " Decision Time Needs " + dt + " In "
					+ time);
		}
	}
	@SuppressWarnings({ "rawtypes" })
	void processCivilianMaybeMessage(CivilianMaybeMessage message) {
	
		double dis;
		//System.out.println(message.getSender()+"time+"+this.getTimeStep()+"CivilianMaybeMessage: "+message.getLocationId());
		int largest=0;
		//List<Building> buildinglist=new ArrayList<Building>();//llb
		//buildinglist.addAll(world.findNearBuildings(world.getEntity(message.getLocationId()), 30000));//lb
		
		
		for (NumberOfMessage h : numOfmessage) {
			//System.out.println("numOfmessage"+numOfmessage);
			// EntityID e=new EntityID(message.getLocation());
			dis = world.getDistance(h.getbuilding(), message.getLocationId());			
			if (dis < 30000){
				h.add();
				neibormessage.add(h);	
			}
		}
		neibormessage=removeDuplicate(neibormessage);
		Collections.sort(neibormessage,cmp);
		//System.out.println("neibormessage"+neibormessage);
		/*集合int i=0;
		do{				
				mostmessage.add(neibormessage.get(i));
				i++;
				if(i>=neibormessage.size()) break;
			}while(neibormessage.get(i).num==neibormessage.get(i-1).num);
		System.out.println("mostmessage"+mostmessage);*/
		//for(NumberOfMessage m : neibormessage){			
			//if(m==neibormessage.get(0))
			//	mostmessage = (List<NumberOfMessage>) m;
		//}
		
	}


	public List<NumberOfMessage> removeDuplicate(List<NumberOfMessage> x) {
		List<NumberOfMessage> list = new ArrayList<NumberOfMessage>();
		for (NumberOfMessage i : x) {
			if (!list.contains(i)) {
				list.add(i);
			}
		}
		int length = list.size();
		List<NumberOfMessage> result = new ArrayList<NumberOfMessage>();
		for (int i = 0; i < length; i++) {
			result.add(list.get(i))  ;
		}
		return result;
	}
	
	

	void removeBuilding(EntityID e) {
		int i;
		boolean d = false;
		i = -1;
		for (NumberOfMessage h : numOfmessage) {
			i++;
			if (h.getbuilding().getValue() == e.getValue()) {
				d = true;
				break;
			}
		}
		if (d)
			numOfmessage.remove(i);
	}

	protected void processExplorationMessage(BuildingIsExploredMessage message) {
	//	Exploration<Building> exploration = getExploration();
		EntityID buildingId = message.getBuildingId();

		// 解决类的强制转换问题，伊斯坦布尔地图出现该类问题
		try {
			StandardEntity s = world.getEntity(buildingId);
			if (s instanceof Building) {
		//		Building building = (Building) world.getEntity(buildingId);

				removeBuilding(buildingId);
			}
		} catch (Exception e) {
			System.err.println("There is No Such Building");
		}
	}

	@Override
	protected void processMessage(Message message) {
		if (message instanceof BuildingIsExploredMessage) {
			BuildingIsExploredMessage explorationMessage = (BuildingIsExploredMessage) message;
			processExplorationMessage(explorationMessage);
		}
		if (message instanceof CivilianMaybeMessage) {
			CivilianMaybeMessage civilianmaybeMessage = (CivilianMaybeMessage) message;
			processCivilianMaybeMessage(civilianmaybeMessage);
		}
//		if (message instanceof AgentPositionMessage) {
//			AgentPositionMessage agentPositionMessage = (AgentPositionMessage) message;
//			processAgentPositionMessage(agentPositionMessage);
//		}
		/*
		 * if (message instanceof CivilianInformationMessage) {
		 * CivilianInformationMessage civilianInformationMessage =
		 * (CivilianInformationMessage) message;
		 * processCivilianInformationMessage(civilianInformationMessage); } if
		 * (message instanceof InformTeamSavingCivilianMessage) {
		 * InformTeamSavingCivilianMessage informTeamSavingCivilianMessage =
		 * (InformTeamSavingCivilianMessage) message;
		 * processInformTeamSavingCivilianMessage
		 * (informTeamSavingCivilianMessage); }
		 */
	}

	protected void processCivilianInformationMessage(
			CivilianInformationMessage message) {                      /// 未被调用
		// LOG.info(me() + " received civilianinformationmessage " + message);
		// System.out.println(me() + " received civilianinformationmessage " +
		// message);
		/*
		   Building civilianLocation = (Building) world.getEntity(new EntityID(
		   message.getLocationId()));
		   Civilian civilian = (Civilian)world.getEntity( message .getCivilianId() );
		   civilian.setHP(message.getHp());
		   civilian.setDamage(message.getDamage());
		   civilian.setBuriedness(message.getBuriedness());
		   civilianSaveTaskManager.addBuriedCivilian(civilian,
		   civilianLocation);
		   */
		}

	protected void processInformTeamSavingCivilianMessage(
			InformTeamSavingCivilianMessage message) {             /// 未被调用
		// LOG.info(me() + " received InformTeamSavingCivilianMessage " +
		// message);
		// System.out.println(me() +
		// " received InformTeamSavingCivilianMessage " + message);
	}

	protected EnumSet<StandardEntityURN> getRequestedEntityURNsEnum() {
		return EnumSet.of(StandardEntityURN.AMBULANCE_CENTRE);
	}

	/*public List<MessageType> getMessagesToListen() {
		List<MessageType> types;

		types = new ArrayList<MessageType>();
		types.add(MessageType.CivilianMaybeMessage);
		//types.add(MessageType.AgentPositionMessage);//niu
		return types;
	}*/
}