package seu.agent.BasicTask;

import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.object.SEUWorldModel;
import seu.utilities.Search.AbstractSearch;

public abstract class BasicTask<T extends SEUAgent<? extends StandardEntity>> {

	T agent;
	State state;


	// 返回当前任务状态
	public State getState() {
		
		return state;
	}
	
	public BasicTask(T agent) {
		this.agent = agent;
		state = State.Inactive;
	}

	public abstract void taskDone();

	public abstract boolean shouldExecute();

	public abstract void execute();

	// 获得智能体的World Model
	public SEUWorldModel getModel() {
		return agent.getModel();
	}

	public AbstractSearch getSearch() {
		return agent.getSearch();
	}

	@Override
	public String toString() {
		return getClass().getName() + "(" + state + ")";
	}

}
