package seu.agent.BasicTask;

import java.awt.Point;
import java.util.Collection;
import java.util.Comparator;
import java.util.PriorityQueue;

import javax.swing.text.html.HTMLDocument.HTMLReader.IsindexAction;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.Police.SEUPoliceForce;
import seu.message.Type.ClearPathReason;
import seu.utilities.Path;

public class CheckATAfterShock extends BasicTask<SEUPoliceForce>{//wujie
//	Point lastPosition;
//	Point currentPosition;
//	EntityID des;
	private final Comparator<ClearPath> comparator;
	private final PriorityQueue<ClearPath> clearPathTaskQueue;
	private ClearPath currentClearPathTask;
	
	public CheckATAfterShock(SEUPoliceForce agent, int maxdistance) {
		super(agent);
		comparator = new ClearPathTaskComparator();
		clearPathTaskQueue = new PriorityQueue<ClearPath>(10, comparator);
		addClearPathToAtTask();
	}
	@Override
	public void taskDone() {
		state = State.Inactive;		
	}

	@Override
	public boolean shouldExecute() {
		
		if(agent.getAfterShockTime()==300){	
			return false;
		}
		if(agent.getTimeStep()<agent.getAfterShockTime()){
			return false;
			}
		//System.out.println(agent.getID()+"aftershock!!!!!!!!!!!!!"+agent.getAfterShockTime());
		if(agent.location().equals(agent.targetAT)){
			return false;
			}
		updateCurrentClearPathTask();
		if(currentClearPathTask!=null){
			state=State.ClearingPath;
			return true;
		}else{
			state=State.Inactive;
			return false;
		}
	}
	@Override
	public void execute() {
		if(state==State.ClearingPath){
			
			//System.out.println(agent.getTimeStep()+","+agent.getID()+"ClearToPartition");
			agent.sendClearPath(currentClearPathTask);	
		}
		//lastPosition = currentPosition;
	}
	
	private void updateCurrentClearPathTask() {
		if (currentClearPathTask == null) {
			if (!clearPathTaskQueue.isEmpty()) {
				currentClearPathTask = clearPathTaskQueue.poll();
			}
		} else if (isOnGoalLocation() && currentClearPathTask.isCompleted()) {
			if (!clearPathTaskQueue.isEmpty()) {
				currentClearPathTask = clearPathTaskQueue.poll();
			} else {
				currentClearPathTask = null;
			}
		} 
	}
	
	public void addClearPathTask(ClearPath clearPathTask) {
		if (!clearPathTaskQueue.contains(clearPathTask)) {
			clearPathTaskQueue.add(clearPathTask);

		}
	}
	
	private boolean isOnGoalLocation() {
		return agent.location().getID().getValue() == currentClearPathTask
				.getRoadIdFinish().getValue();
	}
	
	private void addClearPathToAtTask() {
		Collection<StandardEntity> ats = agent.getWorldModel().getEntitiesOfType(StandardEntityURN.AMBULANCE_TEAM);	
		for (StandardEntity next : ats) {
			StandardEntity n =((Human) next).getPosition(getModel());
             if(agent.isInMyPartition(n)||agent.isInNeighborPartition(n)){//wujie
 
				ClearPath checkaftershock = new ClearPath(agent.location().getID(),n.getID(),
						ClearPathReason.AgentIsStuck);
				agent.targetAT =  next;
				addClearPathTask(checkaftershock);
				break;
			}
		}
		
	}
	
}
