package seu.agent.BasicTask;


import java.awt.Point;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.DecisionManager;
import seu.agent.SEUAgent;
import seu.agent.Police.SEUPoliceForce;
import seu.message.CommunicationCondition;
import seu.message.MessagePriority;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.object.Exploration;
import seu.utilities.DistanceComparator;
import seu.utilities.Path;
import seu.utilities.Geometry.PositionLocate;
import seu.utilities.Search.Cost.PathType;


public class CheckAfterShock extends BasicTask<SEUPoliceForce> {
	private Path path;
	private final int maxDistance;
	Point lastPosition;
	Point currentPosition;
	public CheckAfterShock(SEUPoliceForce agent, int distance) {
		super(agent);
		maxDistance = distance;
	}
	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		boolean should = false;
		List<AmbulanceTeam> ats=getATs();
		if(agent.getAfterShockTime()==300){
			should=false;
			return should;
			}else if(agent.getAfterShockTime()<300&&
					agent.getTimeStep()>=agent.getAfterShockTime()){
				if(ats!=null&&(!ats.isEmpty())){
//			//EntityID temp=ats.get(0).getPosition();
//			Path pathTemp = agent.getSearch().getPath(agent.getMeAsHuman(),
//					(Area) agent.getModel().getEntity(temp), PathType.Shortest);
//				if (pathTemp.size() < 20) {
					agent.targetAT =ats.get(0);
			//}
		}
		
		currentPosition = PositionLocate.getPosition(agent.getID(), getModel());
		if (agent.targetAT == null) {
			should = false;
		}
		if (agent.ATisDone) {
			should = false;
		}
		if (agent.targetAT != null&&agent.getMeAsHuman().getPosition().getValue() == agent.targetAT
				.getID().getValue()) {
			agent.ATisDone= true;
			taskDone();
			should = false;
			agent.ClearedAT.add((AmbulanceTeam) agent.targetAT);
			agent.targetAT = null;
			
		}else if(agent.ClearedAT.contains(agent.targetAT)){
			should = false;
		}else{
			should = true;
			state = State.ClearToAT;
		}
		
		if(should){
			return should;
		}else{
			agent.targetAT = null;
			return should;
		}
	}
		return should;
	}

	
	@Override
	public void execute() {
		if (agent.targetAT != null&&state == State.ClearToAT) {
			System.out.println(agent.getTimeStep()+","+agent.getID()+"CleanToAT!");
			ClearPath targetPath=new ClearPath(agent.location().getID(),agent.targetAT.getID(),
					ClearPathReason.AgentIsStuck);
			agent.sendClearPath(targetPath);
			//agent.sendClearArea(agent.targetAT.getID(),true);
		} else{
			System.out.println(agent.getTimeStep()+","+agent.getID()+"NOAT!");
			//System.out.println(agent.getTimeStep()+" time "+agent.getID()+" ClearMainRoadTask "+" Clear"+target.getID());
		}
		lastPosition = currentPosition;
		
	}
	public List<AmbulanceTeam> getATs(){
		List<AmbulanceTeam> targets = new ArrayList<AmbulanceTeam>();
		for (StandardEntity next : agent.getWorldModel()
				.getEntitiesOfType(StandardEntityURN.AMBULANCE_TEAM)) {
			AmbulanceTeam r = (AmbulanceTeam) next;
			
				targets.add(r);
		}
		Collections.sort(targets, new DistanceComparator(agent.location(), agent.getModel()));
		return targets;
		
	}

}
