package seu.agent.BasicTask;

import java.awt.Point;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.PriorityQueue;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.Police.SEUPoliceForce;
import seu.message.Type.ClearPathReason;
import seu.object.Road.MultiBlockDistanceComparator;
import seu.object.Road.PathBlockState;
import seu.object.Road.RoadUtilities;
import seu.utilities.DistanceComparator;

import seu.utilities.Path;
import seu.utilities.Geometry.DistanceUtilities;
import seu.utilities.Geometry.PositionLocate;
import seu.utilities.Search.Cost.PathType;

public class ClearBlockedRoadToRefugeTask extends BasicTask<SEUPoliceForce> {//yuan
	private final Comparator<ClearPath> comparator;
	private final PriorityQueue<ClearPath> clearPathTaskQueue;
	private ClearPath currentClearPathTask=null;
	boolean firstSelect;
	boolean shockSelect;
	Refuge targetRefuge;  //yuan7.9
	public ClearBlockedRoadToRefugeTask(SEUPoliceForce agent, int maxDistance) {
		super(agent);
		comparator = new ClearPathTaskComparator();
		clearPathTaskQueue = new PriorityQueue<ClearPath>(10, comparator);
		//clearPathTaskQueue = new PriorityQueue<ClearPath>(10);
		firstSelect = false;
				//assignRefuge();
		 //System.out.println(agent.getTimeStep()+ "            "+agent.getMeAsHuman().getID()+"              4");

		addClearPathToRefugeTask();
		//PriorityQueue<EntityID> a1 = new PriorityQueue<EntityID>(5,);
	}

	public void assignRefuge() {
		HashSet<StandardEntity> temp;
		temp = (HashSet<StandardEntity>) agent.getWorldModel()
				.getEntitiesOfType(StandardEntityURN.POLICE_FORCE);
		Iterator<StandardEntity> it = temp.iterator();
		agent.numOfPF = temp.size();
		while (it.hasNext()) {
			StandardEntity t = it.next();
			agent.PF.add(t);
			agent.PFSort.add(t.getID().getValue());
		}
		Collections.sort(agent.PFSort, new IntValueComprator());
		temp = (HashSet<StandardEntity>) agent.getWorldModel()
				.getEntitiesOfType(StandardEntityURN.REFUGE);
		agent.numOfRefuge = temp.size();
		it = temp.iterator();
		while (it.hasNext()) {
			StandardEntity t = it.next();
			agent.refuge.add(t);
			agent.refugeSort.add(t.getID().getValue());
		}
		Collections.sort(agent.PFSort, new IntValueComprator());
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		agent.getAfterShockTime();//don't delete
		if(agent.getTimeStep()<agent.getAfterShockTime()){//wujie
//			if(agent.getID().getValue()==327290976)
//			System.out.println(agent.getID()+"   "+agent.getTimeStep()+"    ClearBlockedRoadToRefugeTask  shouldexecute");
//		if (firstSelect == true) {//wujie
//			return false;
//		}
		
//		if (agent.targetRefuge == null) {
//			return false;
//		}
//		if (agent.existPO && !agent.isSelected) {
//			ClearPath clearRefugePathTask = new ClearPath(agent.location().getID(),agent.targetRefuge.getID(),
//					ClearPathReason.RefugeIsBlocked);
//			agent.isSelected = true;
//			addClearPathTask(clearRefugePathTask);
//		}
//		if (agent.isSelected == false) {     //yuan7.9
//			return false;
//		}
//		if (agent.isDone) {
//			return false;
//		}
//		if (agent.getMeAsHuman().getPosition().getValue() == agent.targetRefuge
//				.getID().getValue()) {
//			agent.isDone = true;
//			firstSelect=true;
//			return false;
//		}
		updateCurrentClearPathTask();
		if(currentClearPathTask!=null){
			state=State.ClearingPath;
			//System.out.println(agent.getTimeStep()+"  ,"+agent.getMeAsHuman().getID() +"  ,"+currentClearPathTask.getRoadIdFinish()+"   ClearBlockedRoadToRefugeTask");
			return true;
		}else{
			state=State.Inactive;
			return false;
		}
		}else{
			//System.out.println(agent.getID()+"  "+agent.getTimeStep()+"  aftershock!!!!!!!!!!!!!"+agent.getAfterShockTime());
			try{
			if (shockSelect == false) {           //yuan7.9
			    clearPathTaskQueue.clear();
			    
			    	ClearPath clearRefugePathTask = new ClearPath(agent.location().getID(),agent.getNearestRefuge().getID(),
								ClearPathReason.RefugeIsBlocked);
						addClearPathTask(clearRefugePathTask);
					
				    	
			     
			    shockSelect=true;	
			}	
			}catch(Exception  e){}
//			if (agent.targetRefuge == null) {
//				return false;
//			}
//			if (agent.existPO && !agent.isSelected) {
//				ClearPath clearRefugePathTask = new ClearPath(agent.location().getID(),agent.targetRefuge.getID(),
//						ClearPathReason.RefugeIsBlocked);
//				agent.isSelected = true;
//				addClearPathTask(clearRefugePathTask);
//			}
//			if (agent.isSelected == false) {
//				return false;
//			}
//			if (agent.isDone) {
//				return false;
//			}
//			if (agent.getMeAsHuman().getPosition().getValue() == agent.targetRefuge
//					.getID().getValue()) {
//				agent.isDone = true;
//				shockSelect=true;
//				return false;
//
//			}
			updateCurrentClearPathTask();
			if(currentClearPathTask!=null){
				state=State.ClearingPath;
				return true;
			}else{
				state=State.Inactive;
				return false;
			}
		}
	}

	@Override
	public void execute() {
//		if(agent.getID().getValue()==327290976)
//			System.out.println(agent.getID()+"   "+agent.getTimeStep()+"    ClearBlockedRoadToRefugeTask  execute");
		if (state == State.ClearingPath) {
//			if(agent.getID().getValue()==327290976)
//				System.out.println(agent.getID()+"   "+agent.getTimeStep()+"    ClearBlockedRoadToRefugeTask  execute!!!!!!!!!!!!");
			agent.sendClearPath(currentClearPathTask);
		}
		
	}

	private void updateCurrentClearPathTask() {
		if (currentClearPathTask == null) {
			if (!clearPathTaskQueue.isEmpty()) {
				currentClearPathTask = clearPathTaskQueue.poll();
			}
		} else if (isOnGoalLocation() && currentClearPathTask.isCompleted()) {
			if (!clearPathTaskQueue.isEmpty()) {
				currentClearPathTask = clearPathTaskQueue.poll();
			} else {
				currentClearPathTask = null;
			}
		} 
	}

	

	

	public void addClearPathTask(ClearPath clearPathTask) {
		if (!clearPathTaskQueue.contains(clearPathTask)) {
			clearPathTaskQueue.add(clearPathTask);

		}
	}

	
	private boolean isOnGoalLocation() {
		return agent.location().getID().getValue() == currentClearPathTask
				.getRoadIdFinish().getValue();
	}


	protected void addClearPathToRefugeTask() {
	
//		if (!agent.existPO) {
//			return;
//		}
		
		 List<Refuge> refuges = agent.getAllRefuges();
		 List<Refuge> rs=new ArrayList<Refuge>();
		 for (Refuge next : refuges) {
			 if(agent.isInMyPartition(next)){
				 rs.add(next);
			 } 
		 }

		if (firstSelect == false) {      //wujei  7.9
			
			if (refuges!= null&&!refuges.isEmpty()){
				
				for (Refuge next : refuges) {
					
					 if(agent.isInMyPartition(next)){
//							
						
						 ClearPath clearRefugePathTask = new ClearPath(agent.location().getID(),next.getID(),
									ClearPathReason.RefugeIsBlocked);
						targetRefuge=next;
						//agent.targetRefuge = next;
											
						addClearPathTask(clearRefugePathTask);
						
						//break;
					}else if(rs.isEmpty()&&agent.isInNeighborPartition(next)){
						ClearPath clearRefugePathTask = new ClearPath(agent.location().getID(),next.getID(),
								ClearPathReason.RefugeIsBlocked);
					targetRefuge=next;
					//agent.targetRefuge = next;
										
					addClearPathTask(clearRefugePathTask);	
					break;
					}				 
				}						
			}			
		}
		firstSelect = true;
	}
	
	

	public class IntValueComprator implements Comparator<Object> {

		@Override
		public int compare(Object arg0, Object arg1) {

			int first = ((Integer) arg0).intValue();
			int second = ((Integer) arg0).intValue();

			if (first > second) {
				return 0;
			} else {
				return 1;
			}
		}
	}
}
