package seu.agent.BasicTask;

import java.awt.Point;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.Police.SEUPoliceForce;
import seu.utilities.Geometry.DistanceUtilities;
import seu.utilities.Geometry.PositionLocate;

public class ClearCurrentRoadBlockedTask extends BasicTask<SEUPoliceForce> {

	private Blockade target;
	protected int maxClearDistance;

	public ClearCurrentRoadBlockedTask(SEUPoliceForce agent,
			int maxClearDistance) {
		super(agent);
		this.maxClearDistance = maxClearDistance;

	}

	@Override
	public boolean shouldExecute() {
		if ((state == State.Inactive || state == State.ClearingBlock)) {
			State expectedMove;
			expectedMove = getExpectedMove();
			if (expectedMove == State.ClearingBlock) {
				state = State.ClearingBlock;
				return true;
			}
			return false;
		}
		return false;
	}

	protected State getExpectedMove() {
		target = null;
		StandardEntity e = agent.getWorldModel().getEntity(
				agent.location().getID());
		if (e instanceof Road) {
			Road road = (Road) e;
			target = agent.getClosestBlockadeInRoad(road);
			if (target == null) {
				target = agent.getClosestBlockade();
			}
		}
		if (target == null) {
			return State.Inactive;
		}
		Human human = agent.getMeAsHuman();
		double distance;
		Point agentPoint;

		agentPoint = PositionLocate.getPosition(human, getModel());
		distance = DistanceUtilities.getDistanceToBlock(target, agentPoint);
		if (distance >= maxClearDistance) {
			return State.Inactive;
		}
		if (target != null) {
			return State.ClearingBlock;
		}
		return null;
	}

	@Override
	public void execute() {
		if (state == State.ClearingBlock) {
			//agent.sendClear(target.getID());
			agent.sendClearArea(target.getID());//niu
			 //System.out.println(agent.getTimeStep()+" time "+agent.getID()+" ClearCurrentRoadBlockedTask "+" Clear"+target.getID());

			// System.out.println(agent.getTimeStep()+" "+agent.getID()+"sendClear " +target.getID());
		}
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	protected Area getAreaToClear() {
		return getPoliceAgent().getAreaToClear();
	}

	public SEUPoliceForce getPoliceAgent() {
		return agent;
	}
}
