package seu.agent.BasicTask;

import java.awt.Point;
import java.util.Collection;

import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.agent.Police.SEUPoliceForce;
import seu.utilities.Geometry.DistanceUtilities;
import seu.utilities.Geometry.PositionLocate;

public class ClearEntranceTask extends BasicTask<SEUPoliceForce> {

	protected Blockade target;
	protected int maxClearDistance;

	public ClearEntranceTask(SEUPoliceForce agent, int maxClearDistance) {
		super(agent);
		this.maxClearDistance = maxClearDistance;
	}

	@Override
	public boolean shouldExecute() {
		 
		State expectedMove;

		expectedMove = getExpectedMove();
		state = expectedMove;
		if (expectedMove == State.ClearingBlock) {
			return true;
		} else {
			return false;
		}
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	public SEUAgent<PoliceForce> getPoliceAgent() {
		return agent;
	}

	protected State getExpectedMove() {
		Collection<StandardEntity> entityList = agent.getModel()
				.getObjectsInRange(agent.location(), maxClearDistance * 2);
		if (entityList != null && entityList.size() > 0) {
			for (StandardEntity e : entityList) {
				if (e instanceof Building) {
					Building b = (Building) e;
					Road entrance = agent.getEntranceRoad(b);
					if (entrance != null) {
						Blockade blockadeInEntrance = agent
								.getClosestBlockadeInRoad(entrance);
						if (blockadeInEntrance != null) {
							Human human;
							double distance;
							Point agentPoint;
							human = agent.getMeAsHuman();
							agentPoint = PositionLocate.getPosition(human,
									getModel());
							distance = DistanceUtilities.getDistanceToBlock(
									blockadeInEntrance, agentPoint);
							if (distance > maxClearDistance) {
								continue;
							} else {
								// System.out.println(agent.getID() + "clear"
								// + blockadeInEntrance);
								target = blockadeInEntrance;
								return State.ClearingBlock;
							}
						}
					}
				}
			}
		}
		return State.Inactive;
	}

	@Override
	public void execute() {
//		if(agent.getID().getValue()==327290976)
//			System.out.println(agent.getID()+"   "+agent.getTimeStep()+"    ClearEntranceTask  execute");
		// TODO Auto-generated method stub
		if (state == State.ClearingBlock) {
			//agent.sendClear(target.getID());
			agent.sendClearArea(target.getID());//niu
			if(agent.getID().getValue()==327290976)
			 System.out.println(agent.getTimeStep()+" time "+agent.getID()+" ClearEntranceTask "+" Clear"+target.getID());

		}
	}
}
