package seu.agent.BasicTask;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import seu.agent.Police.SEUPoliceForce;
import seu.object.Road.RoadUtilities;

public class ClearOnBlockadeTask extends BasicTask<SEUPoliceForce> {

	private Blockade target;

	public ClearOnBlockadeTask(SEUPoliceForce agent, int distance) {
		super(agent);
	}

	@Override
	public boolean shouldExecute() {
		
		if ((state == State.Inactive || state == State.ClearingBlock)) {
			State expectedMove;
			expectedMove = getExpectedMove();
			if (expectedMove == State.ClearingBlock) {
				state = State.ClearingBlock;
				return true;
			}
			return false;
		}
		return false;
	}

	protected State getExpectedMove() {
		target = getPoliceAgent().getStuckBlockade(agent.getMeAsHuman(), true);

		if (target != null && RoadUtilities.doesBlockExists(target, getModel())) {
			return State.ClearingBlock;
		}
		return null;
	}

	@Override
	public void execute() {
		 
		if (state == State.ClearingBlock) {
			//agent.sendClear(target.getID());
			agent.sendClearArea(target.getID());//niu
//			if(agent.getID().getValue()==327290976)
//				System.out.println(agent.getID()+"   "+agent.getTimeStep()+"    ClearonBlockadeTask  execute");
		}
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	protected Area getAreaToClear() {
		return getPoliceAgent().getAreaToClear();
	}

	public SEUPoliceForce getPoliceAgent() {
		return agent;
	}
}
