package seu.agent.BasicTask;

import java.awt.Point;
import java.util.Comparator;
import java.util.PriorityQueue;

import javax.swing.text.html.HTMLDocument.HTMLReader.IsindexAction;

import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.worldmodel.EntityID;
import seu.agent.Police.SEUPoliceForce;
import seu.message.Type.ClearPathReason;
import seu.utilities.Path;

public class ClearPathToPartion extends BasicTask<SEUPoliceForce>{//wujie
//	Point lastPosition;
//	Point currentPosition;
//	EntityID des;
	boolean firstSelect;
	private final Comparator<ClearPath> comparator;
	private final PriorityQueue<ClearPath> clearPathTaskQueue;
	private ClearPath currentClearPathTask;
	
	public ClearPathToPartion(SEUPoliceForce agent, int maxdistance) {
		super(agent);
		comparator = new ClearPathTaskComparator();
		clearPathTaskQueue = new PriorityQueue<ClearPath>(10, comparator);
		firstSelect = false;
		addClearPathToPartitionTask();
	}
	@Override
	public void taskDone() {
		state = State.Inactive;		
	}

	@Override
	public boolean shouldExecute() {
		StandardEntity e=agent.location();
		if(firstSelect==true){
			return false;
		}else{ 
			if(agent.isInMyPartition(e)){
//				agent.targetArea = null;
				firstSelect=true;
				return false;
			}
//				else{
//				des=agent.getMyPartitionEntities().get(0).getID();			
//			}
		}
		updateCurrentClearPathTask();
		if(currentClearPathTask!=null){
			state=State.ClearingPath;
			return true;
		}else{
			state=State.Inactive;
			return false;
		}		
	}

	@Override
	public void execute() {
		if(state==State.ClearingPath){
			System.out.println(agent.getTimeStep()+","+agent.getID()+"ClearToPartition");
			agent.sendClearPath(currentClearPathTask);	
		}
		//lastPosition = currentPosition;
	}
	
	private void updateCurrentClearPathTask() {
		if (currentClearPathTask == null) {
			if (!clearPathTaskQueue.isEmpty()) {
				currentClearPathTask = clearPathTaskQueue.poll();
			}
		} else if (isOnGoalLocation() && currentClearPathTask.isCompleted()) {
			if (!clearPathTaskQueue.isEmpty()) {
				currentClearPathTask = clearPathTaskQueue.poll();
			} else {
				currentClearPathTask = null;
			}
		} 
	}
	
	public void addClearPathTask(ClearPath clearPathTask) {
		if (!clearPathTaskQueue.contains(clearPathTask)) {
			clearPathTaskQueue.add(clearPathTask);

		}
	}
	
	private boolean isOnGoalLocation() {
		return agent.location().getID().getValue() == currentClearPathTask
				.getRoadIdFinish().getValue();
	}
	
	private void addClearPathToPartitionTask() {
//		if (agent.existPO) {
//			return;
//		}
		EntityID des=agent.getMyPartitionEntities().get(0).getID();
		ClearPath clearMoveToPartitionTask = new ClearPath(agent.location().getID(),des,
					ClearPathReason.MoveToPartition);
		//agent.targetArea = agent.getMyPartitionEntities().get(0);
		addClearPathTask(clearMoveToPartitionTask);
	}
	
}
