package seu.agent.BasicTask;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

 


import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.DecisionManager;
import seu.agent.SEUAgent;
 
 
import seu.agent.Police.SEUPoliceForce;
import seu.message.MessagePriority;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.object.Exploration;
import seu.object.Partition.EntityInPartition;
import seu.utilities.DistanceComparator;
import seu.utilities.EntityIdComparator;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class ExplorationoutofpartionTask extends
		BasicTask<SEUAgent<? extends StandardEntity>> {

	private static final StandardEntityURN AMBULANCE_TEAM = null;
	private Exploration<Building> exploration;
	Path path;

	public ExplorationoutofpartionTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
	}

	@Override
	public boolean shouldExecute() {
		//System.out.println(agent.getID()+"  ExplorationoutofpartionTask    shouldExecute");
		agent.sendGetTaskAssigmentMessage();
		 
		if (state == State.Inactive || state == State.Exploring) {
			exploration = agent.getExploration();
			
			// List<Building> buildings = exploration.getUnexploredEntities();
			// List<Building> safeBuildings = buildings;
			List<Building> buildings ;
			buildings= new ArrayList<Building>();
			 
		    //	buildings = getnofoundbuildinginOtherPartion() ;
			 buildings =  agent.nofoundbuilding;
//			if (!(agent.getCommCondition() == CommunicationCondition.NoCommunication || agent
//					.getCommCondition() == CommunicationCondition.Limited)) {
//				if (agent.getMeAsHuman().getStandardURN() == StandardEntityURN.FIRE_BRIGADE
//						|| agent.getMeAsHuman().getStandardURN() == StandardEntityURN.AMBULANCE_TEAM) {
//					buildings = agent.maybebu ;// getAgentTasks();
//					// buildings.addAll(agent.nofoundbuilding);
//					if (buildings.size() == 0) {
//						buildings.addAll(agent.nofoundbuilding);
//					}
//
//				} else {
//					buildings = agent.nofoundbuilding;
//
//				}
//				Collections.sort(
//						buildings,
//						new DistanceComparator(agent.location(), agent
//								.getModel()));
//			} else {
//				buildings = exploration.getUnexploredEntities();
//
//			}

			// new
			// BuildingDistanceComparator(agent,
			// agent.getModel());
			// new DistanceComparator(agent.getLocation(agent.getTimeStep()),
			// agent.getModel()));
				Collections.sort(
						buildings,
						new DistanceComparator(agent.location(), agent
								.getModel()));
			List<Building> safeBuildings = DecisionManager
					.ignoreBurningBuildings(buildings);
			 
			if (safeBuildings.isEmpty()) {
			//	System.out.println(agent.getID()+"  ExplorationoutofpartionTask+++safeBuildings.isEmpty()+++shouldExecute");
				return false;
			}
			if (!(agent instanceof SEUPoliceForce)) {
				safeBuildings.removeAll(agent.getTravelMemory()
						.getUnreachableLocations());
				/*safeBuildings = DecisionManager
						.ignoreBlacakedBuildings(safeBuildings,agent);*/  /////
				if (safeBuildings.size() == 0) {
				//	System.out.println(agent.getID()+"  ExplorationoutofpartionTask+++safeBuildings.size() == 0+++shouldExecute");
					        return false;
				}
					 
			} else {
				safeBuildings = DecisionManager
						.ignoreBurnedBuildings(safeBuildings);
			}
                
			if (safeBuildings.isEmpty()) {
				return false;
			}
			PathType pt;
			if (agent instanceof SEUPoliceForce) {
				pt = PathType.Shortest;
			} else {
				pt = PathType.EmptyAndSafe;
			}
			if(getMyBuilding(safeBuildings)==null)   return false; 
			
			
			
			
			Path path=null;
			int i=0;
			for(Building next:safeBuildings){
				
			Path path1=	agent.getSearch().getPath(agent.getMeAsHuman(),
					next, pt);
			if(path==null||!path.isPassable()){
				agent.getTravelMemory().addUnreachableLocations(safeBuildings,
					agent.getTimeStep());
			}
			if(path1!=null&&path1.isPassable()){
				path=path1;
				break;
			}
			if(i++>5) break;	
			}
			
			/*Path path = agent.getSearch().getPath(agent.getMeAsHuman(),
					getMyBuilding(safeBuildings),pt);*/
 			                                        /////wan
//			Path path =    agent.getSearch().getPath(agent.getMeAsHuman(),getMyBuilding(safeBuildings),pt);	  /////wan 

			if (path == null) {
				//System.out.println(agent.getID()+"  ExplorationoutofpartionTask+++path == null++shouldExecute");
//				agent.getTravelMemory().addUnreachableLocations(safeBuildings,
//						agent.getTimeStep());
				return false;
			} else if (path.hasInfiniteCost()) {
				path = agent.getSearch().getPath(agent.getMeAsHuman(),
						safeBuildings, PathType.Shortest);
				if (path != null && path.isPassable()) {
					ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
							path.getStart(), path.getDestination(),
							ClearPathReason.SaveHuman);
					agent.sendMessage(message, MessagePriority.Low);
				}
				//System.out.println(agent.getID()+"  ExplorationoutofpartionTask+++path.hasInfiniteCost()++shouldExecute"+path.getDestination());
				return false;
			} else if (path.isPassable()) {
				this.path = path;
				state = State.Exploring;
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	@Override
	public void execute() {
		//System.out.println(agent.getID()+"  ExplorationoutofpartionTask   Execute");
		agent.sendMove(path);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
		path = null;
	}

	private boolean isExplorationCompeted() {
		// exploration = agent.getExploration();
		// return exploration.isExplorationCompeted();
		if (agent.nofoundbuilding.size() == 0)
			return true;
		return false;
	}
	public List<Building>  getMyBuilding(List<Building>  safeBuildings){  
		List<Building> buildings=new ArrayList<Building>();                              ///////wan
		for(Building next:safeBuildings){
			if(!agent.nofoundbuilding.contains(next))
				safeBuildings.remove(next);
		}
		 List<Human> HereAgents;
		 HereAgents = new ArrayList<Human>(agent.foundAgents);
		 
		for(Human man:agent.foundAgents){
			//double dis=agent.getSEUWorldModel().getDistance(agent.getMeAsHuman().getID(), man.getID());
			//System.out.println(dis);
			if(man.isBuriednessDefined()&&man.isDamageDefined()&&man.isHPDefined()&&(man.getBuriedness()>0
					||man.getHP()==0)  )
				 HereAgents.remove(man);
		}
		if(HereAgents.isEmpty()) {
			 
			buildings.add(safeBuildings.get(0));    /////
			return   buildings;
		}
		List<EntityID> EntityIDs;
		EntityIDs=new ArrayList<EntityID>();
		for(Human human: HereAgents){
			EntityIDs.add(human.getID());
		}
		EntityIDs.add(agent.getMeAsHuman().getID()); 
		//System.out.println("out");
		Collections.sort(
				EntityIDs,
				new EntityIdComparator( ));
		int Myindex=EntityIDs.indexOf(agent.getMeAsHuman().getID());
		if(safeBuildings.size()>=2*EntityIDs.size())   
		 {
		   for(int i=2*Myindex ;i<=2*Myindex+1;i++){
			buildings.add(safeBuildings.get(i));
		    }
		  return  buildings;
		 } 
		if(safeBuildings.size()<2*EntityIDs.size()&&safeBuildings.size()/2>=Myindex+1)
		  {
			 for(int i=2*Myindex ;i<=2*Myindex+1;i++){
					buildings.add(safeBuildings.get(i));
				}
				return   buildings;
		 }
		if(safeBuildings.size()<2*EntityIDs.size()
				&&safeBuildings.size()%2==1
				&&Myindex==safeBuildings.size()/2)
		{
			buildings.add(safeBuildings.get(2*Myindex));
			 return safeBuildings;
		 }
		return null;
		
	}
//	public List<Building> getnofoundbuildinginOtherPartion(){
//	int i=0;	
//	
//	int k=500000000;
//	List<Building> entities;
//	entities = new ArrayList<Building>();
//	List<Building> buildings;
//	buildings = new ArrayList<Building>();
//	List<EntityInPartition> partitions;
// for(;i<=agent.getSEUWorldModel().getTeam().size();i++){
//	 int j=0;
//	 partitions =agent.getSEUWorldModel().getPartitionModel().getPartitionGroups()
//           .get(i).getPartitions();	 
//   for (EntityInPartition region : partitions) {
//	   entities.addAll(region.getBuildings());
//   }
//   if(!buildings.isEmpty()){
//    for(Building next:entities){
//    	if(!agent.nofoundbuilding.contains(next)){ ///发现的房屋
//    		j++;	
//        	entities.remove(next);/////除去分区内发现的房屋
//    	}	 
//    }
//   }else j=500000000;
//      if(j<k)  {
//    	   k=j;
//    	  buildings=entities;
//      }
//	}
//  
//   return buildings;
//		 
//	}
}

 