package seu.agent.BasicTask;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.DecisionManager;
import seu.agent.SEUAgent;
import seu.agent.Police.SEUPoliceForce;
import seu.message.CommunicationCondition;
import seu.message.MessagePriority;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.object.Exploration;
import seu.utilities.DistanceComparator;
import seu.utilities.EntityIdComparator;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class ExploreinpartionTask extends
		BasicTask<SEUAgent<? extends StandardEntity>> {

	private Exploration<Building> exploration;
	Path path;

	public ExploreinpartionTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
	}

	@Override
	public boolean shouldExecute() {
		//System.out.println(agent.getID()+"  ExploreinpartionTask    shouldExecute");
		agent.sendGetTaskAssigmentMessage();
        if(agent.isbuildinginpartiontraversed()) {
        	//System.out.println(agent.getID()+"  ExploreinpartionTask++++isbuildinginpartiontraversed+++++shouldExecute");	
        	return false;        /////wan 14.3
        }
        
		if ((state == State.Inactive || state == State.Exploring) 
				&& !isExplorationCompeted()) {
			exploration = agent.getExploration();
			 
			List<Building> buildings;
			buildings= new ArrayList<Building>();

			buildings = agent.getnofoundbuildinginpartion();
			
			if (buildings.size() == 0) {
				//System.out.println(agent.getID()+"  ExploreinpartionTask++++buildings.size() == 0+++++shouldExecute");
				 return false;
			}
			 
//			if (!(agent.getCommCondition() == CommunicationCondition.NoCommunication || agent
//					.getCommCondition() == CommunicationCondition.Limited)) {
				 

				//}   
				Collections.sort(
						buildings,
						new DistanceComparator(agent.location(), agent
								.getModel()));
			  
			 
			List<Building> safeBuildings = DecisionManager
					.ignoreBurningBuildings(buildings);
			if (safeBuildings.size() == 0) {
				//System.out.println(agent.getID()+"  ExploreinpartionTask++++safeBuildings.size() == 0+++++shouldExecute");
				 return false;
			}
			if (!(agent instanceof SEUPoliceForce)) {
				safeBuildings.removeAll(agent.getTravelMemory()
						.getUnreachableLocations());
			}else{
				safeBuildings = DecisionManager
						.ignoreBlacakedBuildings(safeBuildings,agent);
				
			}
				
			 
			if (safeBuildings.size() == 0) {
				//.out.println(agent.getID()+"  ExploreinpartionTask++++safeBuildings.size() == 000000+++++shouldExecute");
				 return false;
			}
			
			
//			for(Building next:safeBuildings){
//				
//				Road entrance=agent.getEntranceRoad(next);
//				if(entrance!=null&&entrance.isBlockadesDefined()&&entrance.getBlockades().size()>0)
//				safeBuildings.remove(next);
//			}
			 
			PathType pt;
			if (agent instanceof SEUPoliceForce) {
				pt = PathType.Shortest;
			} else {
				pt = PathType.EmptyAndSafe;
			}
			
			if(getMyBuilding(safeBuildings)==null)  {
				//System.out.println(agent.getID()+"  ExploreinpartionTask++++getMyBuilding(safeBuildings)==null+++++shouldExecute");
				return false; 
			}
			Path path=null;
			int i=0;
			for(Building next:safeBuildings){
				
			Path path1=	agent.getSearch().getPath(agent.getMeAsHuman(),
					next, pt);
			if(path==null||!path.isPassable()){
				agent.getTravelMemory().addUnreachableLocations(safeBuildings,
					agent.getTimeStep());
			}
			if(path1!=null&&path1.isPassable()){
				path=path1;
				break;
			}
			
			
			if(i++>5) break;	
			}
			
			
			 
      	                          //////
//			Path path =    agent.getSearch().getPath(agent.getMeAsHuman(),getMyBuilding(safeBuildings),pt);	  /////wan                                                                            

			if (path == null) {
				//System.out.println(agent.getID()+"  ExploreinpartionTask++++ path == null+++++shouldExecute");
				agent.getTravelMemory().addUnreachableLocations(safeBuildings,
						agent.getTimeStep());
				 
				return false;
			} else if (path.hasInfiniteCost()) {
				path = agent.getSearch().getPath(agent.getMeAsHuman(),
						safeBuildings, PathType.Shortest);
				if (path != null && path.isPassable()) {
					ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
							path.getStart(), path.getDestination(),
							ClearPathReason.ExploreBuilding);
					agent.sendMessage(message, MessagePriority.Low);
				}
				//System.out.println(agent.getID()+"  ExploreinpartionTask++++path.hasInfiniteCost()++++shouldExecute"+path.getDestination());
				return false;
			} else if (path.isPassable()) {
				this.path = path;
				state = State.Exploring;
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	@Override
	public void execute() {
		//System.out.println(agent.getID()+"  ExploreinpartionTask    Execute");
		agent.sendMove(path);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
		path = null;
	}

	private boolean isExplorationCompeted() {
		// exploration = agent.getExploration();
		// return exploration.isExplorationCompeted();
		if (agent.nofoundbuilding.size() == 0)
			return true;
		return false;
	}
	public  List<Building>   getMyBuilding(List<Building>  safeBuildings){                        ///////wan
		List<Building> buildings=new ArrayList<Building>();                              ///////wan
		for(Building next:safeBuildings){
			if(!agent.nofoundbuilding.contains(next))
				safeBuildings.remove(next);
		}
		 List<Human> HereAgents;
		 HereAgents = new ArrayList<Human>(agent.foundAgents);
		 
		for(Human man:agent.foundAgents){
			//double dis=agent.getSEUWorldModel().getDistance(agent.getMeAsHuman().getID(), man.getID());
			//System.out.println(dis);
			if(man.isBuriednessDefined()&&man.isDamageDefined()&&man.isHPDefined()&&(man.getBuriedness()>0
					||man.getHP()==0)  )
				 HereAgents.remove(man);
		}
		if(HereAgents.isEmpty()) {
			 
			buildings.add(safeBuildings.get(0));    /////
			return    buildings;
		}
		List<EntityID> EntityIDs;
		EntityIDs=new ArrayList<EntityID>();
		for(Human human: HereAgents){
			EntityIDs.add(human.getID());
		}
		EntityIDs.add(agent.getMeAsHuman().getID()); 
		//System.out.println("out");
		Collections.sort(
				EntityIDs,
				new EntityIdComparator( ));
		int Myindex=EntityIDs.indexOf(agent.getMeAsHuman().getID());
		if(safeBuildings.size()>=2*EntityIDs.size())   
		 {
		    for(int i=2*Myindex ;i<=2*Myindex+1;i++){
			buildings.add(safeBuildings.get(i));
		}
		return  buildings;
		 } 
		if(safeBuildings.size()<2*EntityIDs.size()&&safeBuildings.size()/2>=Myindex+1)
		  {
			 for(int i=2*Myindex ;i<=2*Myindex+1;i++){
					buildings.add(safeBuildings.get(i));
				}
				return   buildings;
		 }
		if(safeBuildings.size()<2*EntityIDs.size()
				&&safeBuildings.size()%2==1
				&&Myindex==safeBuildings.size()/2)
		{
			buildings.add(safeBuildings.get(2*Myindex));
			 return safeBuildings;
		 }
		return null;
	}
	
}

