package seu.agent.BasicTask;

import java.awt.Point;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.swing.text.Position;

import com.sun.org.apache.bcel.internal.generic.BREAKPOINT;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.World;
import rescuecore2.worldmodel.EntityID;
import rescuecore2.worldmodel.WorldModel;
import seu.agent.SEUAgent;
import seu.agent.Firebrigade.SEUFireBrigade;
import seu.agent.Firebrigade.TubaoPoint;
import seu.message.CommunicationCondition;
import seu.message.MessagePriority;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.message.Type.ImportantBuildingsMessage;
import seu.message.Type.Message;
import seu.object.SEUWorldModel;
import seu.object.Building.BuildingFirenessComparator;
import seu.object.Building.BurningBuildingComparator;
import seu.object.Building.SEUBuilding;
import seu.object.Road.RoadGroup;
import seu.utilities.DistanceComparator;
import seu.utilities.FireSite;
import seu.utilities.Path;
import seu.utilities.Geometry.PositionLocate;
import seu.utilities.Search.Cost.PathType;

public class ExtinguishFireTask extends BasicTask<SEUFireBrigade> {
	protected SEUWorldModel model;
	Path path;
	Building building;
	boolean noInferno;
	Building lastBuilding;
	List<Building>importantBuildings;
	public ExtinguishFireTask(SEUFireBrigade agent, boolean noInferno) {
		super(agent);
		this.noInferno = noInferno;
		lastBuilding = null;
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		State state;
		state = getExpectedState();
		if (agent.me().getWater() == 0
				||state == State.MovingToGasStation ){//niu
			return false;
		}
		if (state == null || state == State.Inactive) {
			state = State.Inactive;
			// lastBuilding = null;
			return false;
		} else {
			this.state = state;
			return true;
		}
	}

	@Override
	public void execute() {
		if (state == State.MovingToFire||state == State.MovingToImporBuild) {//niu
			//System.out.println("moving       !!"+"id "+agent.getID()+"   path    " +path.getDestination());
			agent.sendMove(path);
		} else if (state == State.Extinguishing) {
			lastBuilding = building;
			//System.out.println("extinguish        !!"+"id "+agent.getID()+"   b    " +building.getID());
			agent.sendExtinguish(building);
			
		}
	}

	public Building choose() {
		return null;
	}

	public FireSite getFireSite(Building b) {
		for (FireSite f : agent.getFire())
			if (f.containsFire(b))
				return f;
		return null;
	}

	public State other() {
		lastBuilding = null;
		List<Building> burningSeenBuildings, extinguishableBuildings, allBurningBuildings;
		burningSeenBuildings = agent.getObserveBuilding();
		//List<Building> TubaoBuilding=new ArrayList<Building>();
		Path path,path1;
		//if(agent.getID().getValue()%3!=0 ){
			//if( agent.getTimeStep()%15==1 && agent.getBurningBuildings().size()>10){
		
		if (agent.getTarget()!=null){//Ä¿±ê,ÖÐÐÄžøµÄµã»ò×ÔŒºÑ¡µÄ  
			//System.out.println("  agent  " + agent.getID() + "  target  " +agent.getTarget());
			Building b=agent.getTarget();
			if(burningSeenBuildings.contains(b)){//Ä¿±ê¿ÉŒû 
				agent.setTarget(null);
				//System.out.println("  agent  " + agent.getID() + "settarget  null");
				if(b.getFieryness()==1 || (b.getFieryness()==0 && b.getTemperature()>0)){//¿ÉÃð»ð
					building = b;
					return State.Extinguishing;
				}else{//È»ÉÕÖµ¹ýŽó 
					// ¿ÉŒûµÄ¿ÉÒÔÃð»ðµÄ·¿ÎÝ
					
					extinguishableBuildings = new ArrayList<Building>();
					Boolean hasLargeBuildings=false;
			      
					if (!burningSeenBuildings.isEmpty())
						for (Building burningBuilding : burningSeenBuildings) {
							if (agent.canExtinguish(burningBuilding))
								if (burningBuilding.isFierynessDefined())
									if (burningBuilding.getFieryness()==1
											) {
										if(burningBuilding.getTotalArea()>1500){//Žó·œÎÝ,ÃðÖÜÎ§
											for (Building burningBuilding1 : burningSeenBuildings) {
												if(!burningBuilding1.equals(burningBuilding) && 
														burningBuilding1.getTotalArea()>1000){
													hasLargeBuildings=true;
													for(Building heating:burningSeenBuildings){
														
														if(heating.getTotalArea()<1000 && 
																heating.isFierynessDefined() &&  heating.getFieryness()<3){
															extinguishableBuildings.add(heating);
														}
														if(heating.isFierynessDefined() && heating.getFieryness()==0){
															extinguishableBuildings.add(heating);
														}
													}
												}
											}
											if(!hasLargeBuildings && burningBuilding.getTotalArea()<2000)
										extinguishableBuildings.add(burningBuilding);
										}else{
											extinguishableBuildings.add(burningBuilding);
										}
									}
						}

					if (!extinguishableBuildings.isEmpty()) {
						Area position;

						position = (Area) agent.getMeAsHuman().getPosition(getModel());
						if (position instanceof Building) {
							Building positionBuilding;

							positionBuilding = (Building) position;
							if (extinguishableBuildings.contains(positionBuilding) 
									) {//14.6.26
								building = positionBuilding;
								return State.Extinguishing;
							}
						}
						BurningBuildingComparator comperator;

						comperator = new BurningBuildingComparator(getModel(),
								agent.getTimeStep());
//						Collections.sort(extinguishableBuildings,
//								new BuildingFirenessComparator());
						Collections.sort(extinguishableBuildings,
								comperator);
						building = extinguishableBuildings.get(0);
						if(agent.canExtinguish(building)){
						return State.Extinguishing;
						}
					}
					allBurningBuildings = agent.getHeatingAndBurningBuildings(true);
					List<Building> newlyBurn=new ArrayList<Building>();
					for(Building bb:allBurningBuildings){
						if(bb.getFieryness()==1 && !newlyBurn.contains(bb)){
							newlyBurn.add(bb);
						}
					}
					if (newlyBurn.isEmpty()) {
						return State.Inactive;
					}
					Collections.sort(newlyBurn,
							new DistanceComparator(agent.getMeAsHuman(), agent.getModel()));
					/*
					 * System.out.println("  time  " + agent.getTimeStep() + "   id  " +
					 * agent.getID() + "   building2  " + allBurningBuildings);
					 */
					path = getSearch().getPath(agent.getMeAsHuman(), newlyBurn,
							PathType.EmptyAndSafe);
					if (path != null && path.isPassable()) {
						Area destination;
						EntityID previusId;
						Edge edge;

						if (path.size() > 1) {
							destination = path.getDestination(getModel());
							if (agent.canExtinguish((Building) destination)) {
								building = (Building) destination;
								return State.Extinguishing;
							}
							Point target, buildingCenter, position;

							previusId = path.getEntities().get(path.size() - 2);
							edge = destination.getEdgeTo(previusId);

							target = PositionLocate.getCenter(edge);
							buildingCenter = PositionLocate.getCenter(destination);
							position = PositionLocate.getExtensionPoint(buildingCenter,
									target, (int) (5 * SEUAgent.AGENT_RADIUS));
							path.setTarget(position);
						}
						this.path = path;
						if( path.getDestination(getModel()) instanceof Building){
							Building b1 =(Building)  path.getDestination(getModel());
						
						}
						return State.MovingToFire;
					} else {
						return State.Inactive;
					}
				
				}
			}else{//Ä¿±ê²»¿ÉŒû ÒÆ¶¯ 
				path = getSearch().getPath(agent.getMeAsHuman(), b,
						PathType.EmptyAndSafe);
				if (path != null && path.isPassable()) {
					Area destination;
					EntityID previusId;
					Edge edge;

					if (path.size() > 1) {
						destination = path.getDestination(getModel());
//						if (agent.canExtinguish((Building) destination)) {
//							building = (Building) destination;
//							return State.Extinguishing;
//						}
						Point target, buildingCenter, position;

						previusId = path.getEntities().get(path.size() - 2);
						edge = destination.getEdgeTo(previusId);

						target = PositionLocate.getCenter(edge);
						buildingCenter = PositionLocate.getCenter(destination);
						position = PositionLocate.getExtensionPoint(buildingCenter,
								target, (int) (5 * SEUAgent.AGENT_RADIUS));
						path.setTarget(position);
					}
					this.path = path;
					if( path.getDestination(getModel()) instanceof Building){
						Building b1 =(Building)  path.getDestination(getModel());
					
					}
					return State.MovingToFire;
			}else if(path.hasInfiniteCost()){
				agent.setTarget(null);
				if(path!=null && path.isPassable()){
				ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
						path.getStart(), path.getDestination(),
						ClearPathReason.ExtinguishFire);
				agent.sendMessage(message, MessagePriority.High);
				return State.Inactive;
				}
				  
			}
				return State.Inactive;
			}
		}else{//ÎÞÄ¿±ê

			// ¿ÉŒûµÄ¿ÉÒÔÃð»ðµÄ·¿ÎÝ
			
			// getBurningBuildingsFromChangeSet(false,
			// noInferno);
			extinguishableBuildings = new ArrayList<Building>();
			Boolean hasLargeBuildings=false;
	      
			if (!burningSeenBuildings.isEmpty())
				for (Building burningBuilding : burningSeenBuildings) {
					if (agent.canExtinguish(burningBuilding))
						if (burningBuilding.isFierynessDefined())
							if (burningBuilding.getFieryness() > 0
									&& burningBuilding.getFieryness() <= 3) {
								if(burningBuilding.getTotalArea()>1500){//Žó·œÎÝ,ÃðÖÜÎ§
									for (Building burningBuilding1 : burningSeenBuildings) {
										if(!burningBuilding1.equals(burningBuilding) && 
												burningBuilding1.getTotalArea()>1000){
											hasLargeBuildings=true;
											try{
											for(Building heating:burningSeenBuildings){
//												SEUBuilding sb=model.getSEUBuilding(heating.getID());
//												if(heating.isTemperatureDefined() && heating.getTemperature()>0
//														&& heating.getTemperature()<sb.getIgnitionPoint()){
												if(heating.getTotalArea()<1000 && 
														heating.isFierynessDefined() &&  heating.getFieryness()<3){
													extinguishableBuildings.add(heating);
												}
												if(heating.isFierynessDefined() && heating.getFieryness()==0){
													extinguishableBuildings.add(heating);
												}
											}
											}catch(Exception e){}
										}
									}
									if(!hasLargeBuildings && burningBuilding.getTotalArea()<2000)
								extinguishableBuildings.add(burningBuilding);
								}else{
								extinguishableBuildings.add(burningBuilding);
								}
							}
				}
			if(agent.getTimeStep()>30 && agent.getTimeStep()<80){
			if( agent.getModel().getTotalArea()>250000 && agent.getModel().getTotalArea()<500000 ){//paris area 273562
			//if(extinguishableBuildings.isEmpty() && !agent.hasReachableBuildings()){//no reachable burningbuildings
			if(extinguishableBuildings.isEmpty() && agent.getBurningBuildings().isEmpty()){//no reachable burningbuildings
			for (Building burningBuilding : burningSeenBuildings) {
				if(burningBuilding.getStandardURN()==StandardEntityURN.POLICE_OFFICE ||
						burningBuilding.getStandardURN()==StandardEntityURN.FIRE_STATION ||
								burningBuilding.getStandardURN()==StandardEntityURN.AMBULANCE_CENTRE ||
						burningBuilding.getStandardURN()==StandardEntityURN.REFUGE)
					continue;
				if (agent.canExtinguish(burningBuilding))
					if (burningBuilding.isFierynessDefined())
						if (!(burningBuilding instanceof Refuge) && burningBuilding.getFieryness() <= 3) {//gai
							extinguishableBuildings.add(burningBuilding);
						}
			}
			}
			}
			
			if(agent.getModel().getTotalArea()>500000 ){
				if(extinguishableBuildings.isEmpty() && agent.hasReachableBuildings()){//no reachable burningbuildings
					//if(extinguishableBuildings.isEmpty() && agent.getBurningBuildings().isEmpty()){//no reachable burningbuildings
					for (Building burningBuilding : burningSeenBuildings) {
						if(burningBuilding.getStandardURN()==StandardEntityURN.POLICE_OFFICE ||
								burningBuilding.getStandardURN()==StandardEntityURN.FIRE_STATION ||
										burningBuilding.getStandardURN()==StandardEntityURN.AMBULANCE_CENTRE ||
								burningBuilding.getStandardURN()==StandardEntityURN.REFUGE)
							continue;
						if (agent.canExtinguish(burningBuilding))
							if (burningBuilding.isFierynessDefined())
								if (!(burningBuilding instanceof Refuge) && burningBuilding.getFieryness() <= 3) {//gai
									extinguishableBuildings.add(burningBuilding);
								}
					}
					}
			}
			}
			if (!extinguishableBuildings.isEmpty()) {
				
				Area position;

				position = (Area) agent.getMeAsHuman().getPosition(getModel());
				if (position instanceof Building) {
					Building positionBuilding;

					positionBuilding = (Building) position;
					if (extinguishableBuildings.contains(positionBuilding)
							) {
						building = positionBuilding;
						return State.Extinguishing;
					}
				}
				BurningBuildingComparator comperator;

				comperator = new BurningBuildingComparator(getModel(),
						agent.getTimeStep());
				Collections.sort(extinguishableBuildings,
						new BuildingFirenessComparator());
//				Collections.sort(extinguishableBuildings,
//						comperator);
				building = extinguishableBuildings.get(0);
				if(agent.canExtinguish(building)){
				return State.Extinguishing;
				}
			}
			allBurningBuildings = agent.getHeatingAndBurningBuildings(true);
			if (allBurningBuildings.isEmpty()) {
				return State.Inactive;
			}
			Collections.sort(allBurningBuildings,
					new DistanceComparator(agent.getMeAsHuman(), agent.getModel()));
			/*
			 * System.out.println("  time  " + agent.getTimeStep() + "   id  " +
			 * agent.getID() + "   building2  " + allBurningBuildings);
			 */
			path = getSearch().getPath(agent.getMeAsHuman(), allBurningBuildings,
					PathType.EmptyAndSafe);
			if (path != null && path.isPassable()) {
				Area destination;
				EntityID previusId;
				Edge edge;

				if (path.size() > 1) {
					destination = path.getDestination(getModel());
					if (agent.canExtinguish((Building) destination)) {
						building = (Building) destination;
						return State.Extinguishing;
					}
					Point target, buildingCenter, position;

					previusId = path.getEntities().get(path.size() - 2);
					edge = destination.getEdgeTo(previusId);

					target = PositionLocate.getCenter(edge);
					buildingCenter = PositionLocate.getCenter(destination);
					position = PositionLocate.getExtensionPoint(buildingCenter,
							target, (int) (5 * SEUAgent.AGENT_RADIUS));
					path.setTarget(position);
				}
				this.path = path;
				if( path.getDestination(getModel()) instanceof Building){
					Building b =(Building)  path.getDestination(getModel());
				
				}
				return State.MovingToFire;
			} else if(path.hasInfiniteCost()){

				
				//if(extinguishableBuildings.isEmpty() && !agent.hasReachableBuildings()){//no reachable burningbuildings
				
				if(path!=null && path.isPassable()){
					EntityID roadid=null;
						Area b =  path.getDestination(getModel());
						float x=b.getLocation(model).first();
						float y=b.getLocation(model).second();
						Collection<StandardEntity>st=model.getObjectsInRange((int)x, (int)y, 10000);
					ok:
						for(StandardEntity e :st){
						if(e instanceof Road){
							Road r=(Road) e;
						if(r.isBlockadesDefined() && !r.getBlockades().isEmpty()){
							List<EntityID> entities=r.getNeighbours();
							
							for (EntityID next : entities){
								StandardEntity e1=model.getEntity(next);
								if(e1 instanceof Building){
									Building B=(Building) e1;
									if(B.isFierynessDefined()
											){
										
										continue ok;
									}
								}
							}
							roadid =r.getID();
							break;
						}
						}
					}
					if(roadid!=null){
				ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
						path.getStart(), roadid,
						ClearPathReason.ExtinguishFire);
				agent.sendMessage(message, MessagePriority.High);
					}
				return State.Inactive;
				}
				  
			}
			return State.Inactive;
		}
		
		
	}

	public State getExpectedState() {
		State s = State.Inactive;
		
		if (s != State.Inactive) {
//			System.out.println("time  " + agent.getTimeStep() + "   id  "
//					+ agent.getID() + " xxx  " + building);
			return s;
		}
		s = other();
		return s;

	}

	

	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return super.toString() + path;
	}

}
