package seu.agent.BasicTask;

import java.util.List;
import java.util.Random;



import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import seu.agent.SEUAgent;
import seu.message.MessagePriority;
import seu.message.Type.AgentIsBuriedMessage;
import seu.message.Type.AgentIsStuckMessage;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;

public class IsStuckOrBuriedCallHelpTask extends
		BasicTask<SEUAgent<? extends StandardEntity>> {

	public IsStuckOrBuriedCallHelpTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
	}

	@Override
	public boolean shouldExecute() {
		//System.out.println(agent.getID()+" SaveMyselfTask    shouldExecute");
		
		if (agent.isBuried()) {
			// 智能体被埋，且被埋的房屋入口处有路障 ，这里发送两条消息
			Area area = (Area) agent.location();

			if (area instanceof Building) {
				Building b = (Building) area;
				if (agent.getEntranceRoad(b) != null) {
					Blockade blockade = agent.getClosestBlockadeInRoad(agent
							.getEntranceRoad(b));

					if (blockade != null) {
						ClearPathIsNeededMessage agentIsStuckMessage = new ClearPathIsNeededMessage(
								agent.getEntranceRoad(b).getID(), agent
										.getEntranceRoad(b).getID(),
								ClearPathReason.StuckInBuilding);
						agent.sendMessage(agentIsStuckMessage,
								MessagePriority.High);
					}
					if (agent.getTimeStep() % 3 == 0) {
						AgentIsBuriedMessage agentIsBuriedMessage = new AgentIsBuriedMessage(
								agent.location().getID().getValue(),
								agent.transidoldtonew(agent.getMeAsHuman()
										.getID().getValue()),
								agent.getTimeStep(), agent.getMeAsHuman()
										.getHP(), agent.getMeAsHuman()
										.getBuriedness(), agent.getMeAsHuman()
										.getDamage());
						agent.sendMessage(agentIsBuriedMessage,
								MessagePriority.High);
					}
				} else {
					AgentIsBuriedMessage agentIsBuriedMessage = new AgentIsBuriedMessage(
							agent.location().getID().getValue(),
							agent.transidoldtonew(agent.getMeAsHuman().getID()
									.getValue()), agent.getTimeStep(), agent
									.getMeAsHuman().getHP(), agent
									.getMeAsHuman().getBuriedness(), agent
									.getMeAsHuman().getDamage());
					agent.sendMessage(agentIsBuriedMessage,
							MessagePriority.High);

				}
				;
			}

			state = State.BuriedResting;
			return true;
		} else if (agent.isStuck(agent.getMeAsHuman(), false)||agent.isStuck(agent.getMeAsHuman(), true)) {
			AgentIsStuckMessage agentIsStuckMessage = new AgentIsStuckMessage(
					agent.location().getID(),agent.getTimeStep());
			agent.sendMessage(agentIsStuckMessage, MessagePriority.High);
			// System.out.println(agent.toString() + "in " + agent.getTimeStep()
			// + "send message" + agentIsStuckMessage);
			state = State.StuckResting;
			if (agent.getMeAsHuman().getStandardURN() == StandardEntityURN.AMBULANCE_TEAM) {
				Random random;
				int n;
				random = agent.getRandomSource();
				n = random.nextInt(2);
				if (n == 0) {
					return true;
				} else {
					return false;
				}
			}
			return false;
		} else {
			
                 if(agent.location()instanceof Building){
                	 boolean isBlocked=true;
                	 List<Area> entrances=getModel().getEnterences((Building)agent.location());
                	 for(Area area:entrances){
                		 if(!area.isBlockadesDefined()||area.getBlockades().size()==0){
                			 isBlocked=false;             			 
                		 }
                	 }
                	 if(isBlocked){
                		 AgentIsStuckMessage agentIsStuckMessage = new AgentIsStuckMessage(
          						agent.location().getID(),agent.getTimeStep());
          				 agent.sendMessage(agentIsStuckMessage, MessagePriority.High);
          				// System.out.println(agent.toString() + "in " + agent.getTimeStep()
          				// + "send message" + agentIsStuckMessage);
          				 state = State.StuckResting;
                	 }              	 
                 }
//			if(agent.lastPosition==agent.currentPostion&&agent.lastPosition==agent.latestPosition){
//				if(agent.me() instanceof AmbulanceTeam){
//					
//				}
//			}
			// 智能体被堵在房屋里，但是没有Buriedness
			// 这里仍然需要发送被堵的消息
			
			return false;
		}
	}

	@Override
	public void execute() {
//		if(agent.getID().getValue()==327290976)
//		System.out.println(agent.getID()+" SaveMyselfTask    execute");
		agent.sendRest();
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}
}
