package seu.agent.BasicTask;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.agent.Police.SEUPoliceForce;
import seu.object.Exploration;
import seu.utilities.DistanceComparator;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class PFPartitionRoadExplorationTask extends
		BasicTask<SEUAgent<? extends StandardEntity>> {

	private final Exploration<Road> exploration;
	Path path;
	boolean isAddNeighbour;

	public PFPartitionRoadExplorationTask(SEUPoliceForce agent) {
		super(agent);
		exploration = new Exploration<Road>(agent.getModel());
		exploration.addEntitiesToExplore(agent.getRoadsInPartition());
		Collections.sort(exploration.getUnexploredEntities(),
				new DistanceComparator(agent.getMeAsHuman(), agent.getModel()));
		isAddNeighbour = false;
	}

	@Override
	public boolean shouldExecute() {

		if ((state == State.Inactive || state == State.Exploring)
				&& !isExplorationCompeted()) {
			// exploration = agent.getExploration();
			List<Road> roads = exploration.getUnexploredEntities();
			if (roads.isEmpty())
				return false;
			// System.out.println(agent + " before remove" + buildings.size());
			removeExploredEntity(roads);
			if (roads.isEmpty())
				return false;
			// System.out.println(agent + " after remove" + buildings.size());
			// List<Building> safeBuildings = buildings;
			// roads.removeAll(agent.getTravelMemory().getUnreachableLocations());
			// if (roads.isEmpty()) {
			// return false;
			// }
			Collections.sort(roads, new DistanceComparator(
					agent.getMeAsHuman(), agent.getModel()));
			Path path = agent.getSearch().getPath(agent.getMeAsHuman(), roads,
					PathType.Shortest);

			if (path == null) {

				agent.getTravelMemory().addUnreachableLocations(roads,
						agent.getTimeStep());
				return false;
			} else {
				this.path = path;
				state = State.Exploring;
				return true;
			}
		} else {
			return false;
		}
	}

	private void removeExploredEntity(List<Road> roads) {
		// TODO Auto-generated method stub
		List<Road> temp = new ArrayList<Road>();
		temp.addAll(roads);
		// System.out.println(agent + "unexploredBuilidngs"
		// + agent.getUnexploredBuildings().size());
		for (Road b : temp) {
			if (agent.getPositionHistory().getReachedArea()
					.contains(b.getID().getValue())) {
				System.out.println("remove" + b);
				roads.remove(b);
				exploration.addToExplorationHistory(b);
			}
		}
	}

	@Override
	public void execute() {
		agent.sendMove(path);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
		path = null;
	}

	private boolean isExplorationCompeted() {
		if (exploration.isExplorationCompeted() && isAddNeighbour == false) {
			isAddNeighbour = true;
			exploration.addEntitiesToExplore(agent
					.getRoadsInNeighbourPartition());
			return false;
		}
		return exploration.isExplorationCompeted();
	}
}
