package seu.agent.BasicTask;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class RandomWalkTask extends
		BasicTask<SEUAgent<? extends StandardEntity>> {

	private static final int RANDOM_WALK_LENGTH = 8;
	Path path;

	public RandomWalkTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
	}

	@Override
	public boolean shouldExecute() {
		 
		//System.out.println(agent.getTimeStep()+"   "+agent.getID()+"   ÖŽÐÐ"+"RandomWalkTask"+"ÈÎÎñ");
		try{
		if (state == State.Inactive || state == State.ExploringRandom) {
			Path path = randomWalk();		
			if (path.size() > 0) {			
				Area randomTarget = (Area) getModel().getEntity(path.getDestination());
				path = getSearch().getPath(agent.getMeAsHuman(), randomTarget,PathType.Shortest);
				if (path != null) {
					state = State.ExploringRandom;  //yuan
					this.path = path;
					//System.out.println(agent.getTimeStep()+"   "+agent.getID()+"   ÖŽÐÐ"+"RandomWalkTask"+"ÈÎÎñ");
					return true;
				}
			}
		}
		}catch(Exception e){System.out.println("shouldExecute random"+agent.getClass());}
		state = State.Inactive ;  //yuan
		return false;	
	}

	@Override
	public void execute() {
//		if(agent.getID().getValue()==327290976)
//			System.out.println(agent.getID()+"   "+agent.getTimeStep()+"    RandomWalk  execute");
		if( state == State.ExploringRandom)
		agent.sendMove(path);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
		//path = null;
	}

	protected Path randomWalk() {
		Path path = new Path();	
		Set<StandardEntity> seen = new HashSet<StandardEntity>();
		StandardEntity current = agent.location();
		try{
		for (int i = 0; i < RANDOM_WALK_LENGTH; ++i) {
			path.add(current.getID());
			seen.add(current);
			List<StandardEntity> neighbours = new ArrayList<StandardEntity>(agent.getSearch().findNeighbours(current));
			Collections.shuffle(neighbours, agent.getRandomSource());
			boolean found = false;
			for (StandardEntity next : neighbours) {//Ö»×ßµÀÂ·
				if (seen.contains(next)) {
					continue;
				}
				if (next instanceof Building) {
					continue;
				}
				current = next;
				found = true;
				break;
			}
			if (!found) {//°²È«µÄ·¿ÎÝÒ²¿É×ß
				for (StandardEntity next : neighbours) {
					if (seen.contains(next)) {
						continue;
					}
					if (next instanceof Building) {
						if(((Building)next).isTemperatureDefined()&&((Building)next).getTemperature()<50){
							current = next;
							found = true;
							break;
						}else{
							continue;
						}			
					}				
				}
				if (!found) {//ÈÎÒâÇøÓò¶Œ¿É×ß
					for (StandardEntity next : neighbours) {
						if (seen.contains(next)) {
							continue;
						}
						current = next;
						found = true;
						break;				
					}				
				}				
			}
		}
		}catch(Exception e){System.out.println(" randomWalk"+ agent.getName());
		}
		return path;
	}

}