package seu.agent.BasicTask;

import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.agent.Firebrigade.SEUFireBrigade;
import seu.agent.Police.SEUPoliceForce;
import seu.message.MessagePriority;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.object.SEUWorldModel;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;


public class RunAwayFromGasStationTask extends BasicTask<SEUAgent<? extends StandardEntity>> {
	//niu13.10.15
	Path path;
	
	
	protected SEUWorldModel world;
	public RunAwayFromGasStationTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
		
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
		path=null;
	}

	@Override
	public boolean shouldExecute() {
		if(agent.getMeAsHuman() instanceof FireBrigade && ((FireBrigade) agent.getMeAsHuman()).getWater()>1000){
			return false;
		}
			Path path;
			path = agent.getPathToRefuge();
			// if (35380 == agent.getID().getValue())
			// System.err.println("1" + path);
			if (path == null) {
				ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
						path.getStart(), path.getDestination(),
						ClearPathReason.SaveMySelf);

				agent.sendMessage(message, MessagePriority.High);
			}
			if (agent instanceof SEUPoliceForce) {
				if (path != null) {
					this.path = path;
					state = State.SavingMyself;
					return true;
				} else {
					return false;
				}
			}
			if (path != null && path.isPassable()) {
				this.path = path;
				state = State.SavingMyself;
				return true;
			} else if (path.hasInfiniteCost()) {
				path = agent.getPathToRefuge(PathType.Shortest);
				// if (35380 == agent.getID().getValue())
				// System.err.println("2" + path);
				if (path != null && path.isPassable()) {
					ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
							path.getStart(), path.getDestination(),
							ClearPathReason.SaveMySelf);
					agent.sendMessage(message, MessagePriority.High);
				}
			}
		

		// System.err.println("No Path Found in " + agent.getTimeStep());

		return false;
	}


	@Override
	public void execute() {
		agent.sendMove(path);
		System.out.println("run away GS ");
	}

	
	
	
	
}
