  package seu.agent.BasicTask;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.Ambulance.SEUAmbulanceTeam;
import seu.message.MessagePriority;
import seu.message.Type.CivilianIsSavedOrDeadMessage;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.object.BuriedHumanComparator;
import seu.utilities.CivDistanceComparator;
import seu.utilities.CostComparator;
import seu.utilities.DistanceComparator;
import seu.utilities.EntityComparator;
import seu.utilities.EntityIdComparator;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class SaveCivAndAgentTask extends AmbulanceTeamTask {          //救市民和智能体任务

	private final List<SaveHuman> saveHumanTasks;         //要救的人
	 public boolean isEmpty(){                //yuan_r
	    	return saveHumanTasks.isEmpty();
	    }

	 
	 int SixthDamage=0;/////wan
	   int FifthDamage=0;//////wan
		int ForthDamage=0;    //////wan
		int ThirdDamage=0;         ////wan
		int SecondDamage=0;    ///wan 
		int FirstDamage=0;      ////wan
		
		
	// 被忽略的任务和已完成救援的人
	private final List<EntityID> savedAndRemovedHumans;

	// 已经救援的人
	private final List<EntityID> savedHumansInSendUnload;
	// private final List<EntityID> savedhumansInSendRescue;

	// 上一周期的Buriedness
	int lastBuriedness = 0;

	// 本周期的Buriedness
	int currentBuriedness = 0;

	public List<EntityID> getSavedHumans() {        //获得被忽略的任务和已完成救援的人
		return savedAndRemovedHumans;
	}

	// 当前周期的目标
	Human currentHuman;
	// 上周期的目标
	Human lastHuman;

	public Human getCurrentHuman() {
		return currentHuman;
	}
    int starttime;
	Path path;
	boolean isAgents;
	boolean isPathRequested;

	public SaveCivAndAgentTask(SEUAmbulanceTeam agent, boolean isAgents) {
		super(agent);
		saveHumanTasks = new ArrayList<SaveHuman>();

		savedHumansInSendUnload = new ArrayList<EntityID>();
		savedAndRemovedHumans = new ArrayList<EntityID>();
		// savedhumansInSendRescue = new ArrayList<EntityID>();
		this.isAgents = isAgents;
	}

	@Override
	public void taskDone() {
		if (state != State.MovingToRefuge) {
			state = State.Inactive;
		}
	}

	
                      	// 判断该Human是否不被需要被救援
	public boolean isHumanNeeded2BRescued(Human h) {         
		if (agent.getDeadHumans().contains(h.getID())   
				|| savedHumansInSendUnload.contains(h.getID())
				// || (savedhumansInSendRescue.contains(h.getID()))
				|| savedAndRemovedHumans.contains(h.getID()))
			return true;
		else
			return false;
	}

	/**
	 * @param h是任务目标进行判断的Human
	 * @return 判断结果，该消息产生的任务Human是否应该救
	 */
	public boolean isMessageTaskNeedToDo(Human h) {
		if (h.isPositionDefined())
			if (agent.getModel().getEntity(h.getPosition()) instanceof Refuge)
				return false;
		if (h.isBuriednessDefined())
			if (h.getBuriedness() == 0)
				return false;
		
		if(state == State.MovingToRefuge)       return false; ////// wan 14.02
	/*	if (h.isBuriednessDefined())            
			if (h.getBuriedness() == 0)
			{
				if(h.isDamageDefined())
					if(h.getDamage()>)
				return false;
			}
	*/		
		return true;
	}

	// 从任务列表中给任务
	public void giveTaskFromTaskLists() {
		/*Collections.sort(saveHumanTasks,                                //yuan_r
				new CivDistanceComparator(agent.location(), agent.getModel()));*/
		Collections.sort(saveHumanTasks,  new CostComparator()  );
		currentHuman = null;
		for (SaveHuman sh : saveHumanTasks) {
			if (!isHumanNeeded2BRescued(sh.human)
					&& isMessageTaskNeedToDo(sh.human)                         
			// && sh.human.isPositionDefined()
			) {
				currentHuman = sh.human;
				break;
			}
		}
	}

	@Override
	public boolean shouldExecute() { 
	//	System.out.println(agent.getID()+"  SaveCivAndAgentTask    shouldExecute"+isAgents);
		State expectedMove;
		Path path;
		// 移除无法看到的任务，任务目标不在指定地点，可能被其他AT救回Refuge
		removeInvalidTasks();
		expectedMove = getExpectedMove();

		for (EntityID id : savedHumansInSendUnload) {
			removeSaveTask(id);
		}

		for (EntityID id : agent.getDeadHumans()) {
			removeSaveTask(id);
		}

		removeSaveTask(agent.getID());

		needToRescueHumanInTasks();
		// System.out.println("time   " + agent.getTimeStep() + "  id  "
		// + agent.getID() + "   saveHumanTasks  " + saveHumanTasks);
		if (currentHuman != null) {
			if (expectedMove == State.MovingToHuman
					&& isHumanNeeded2BRescued(currentHuman)) {
				giveTaskFromTaskLists();
				if (currentHuman == null) {
					state = State.Inactive;
					return false;
				}

			}
		} else {
			giveTaskFromTaskLists();
			if (currentHuman == null) {
				state = State.Inactive;
				return false;
			}
		
		}

		// 估算死亡时间
		int deltaBuriedness;
		// 最大救援人数
		int maxATs = Integer.MIN_VALUE;
		// 最短死亡时间
		int minDT = Integer.MAX_VALUE;
		// 救援所需周期数
		int rescueCycles;

		double deltaDamage;                                         ////// wan 14.02           
		
		if (currentHuman != null && lastHuman == currentHuman
				&& currentHuman.isBuriednessDefined()) {

			lastBuriedness = currentBuriedness;
			currentBuriedness = currentHuman.getBuriedness();
			deltaBuriedness = lastBuriedness - currentBuriedness;

			if(SixthDamage==0){       //对所有进行初始化     
				FirstDamage=currentHuman.getDamage();    
				SecondDamage=FirstDamage;
				ThirdDamage=SecondDamage;
				ForthDamage=ThirdDamage;
				FifthDamage=ForthDamage;
				SixthDamage=FifthDamage;
				 
			}
			                                                                //循环向后赋值
			SixthDamage=FifthDamage;
			FifthDamage=ForthDamage;
			ForthDamage=ThirdDamage;
			ThirdDamage=SecondDamage;
			SecondDamage=FirstDamage;
			FirstDamage=currentHuman.getDamage();     /////wan
			deltaDamage=(FirstDamage+SecondDamage+ThirdDamage-ForthDamage-FifthDamage-SixthDamage)/9.000;
			
			
			if (deltaBuriedness > 0) {

				int deadTime = Integer.MAX_VALUE;

				// 最大救援人数
				if (maxATs < deltaBuriedness)
					maxATs = deltaBuriedness;          //由被埋值减小量获得当前最大救援人数

				rescueCycles = currentHuman.getBuriedness() / maxATs;

				if (currentHuman.isHPDefined()
						&& currentHuman.isDamageDefined()) {
					if (currentHuman.getDamage() != 0)
					//	deadTime = currentHuman.getHP()
							//	/ currentHuman.getDamage();
						
						deadTime=(int) (( currentHuman.getHP()-currentHuman.getDamage())/deltaDamage);
					   deadTime = Math.min(deadTime,agent.gettimeforfire(currentHuman)) ; //// wan
				}
				//deadTime = deadTime - 5;
				
				deadTime = (int) (deadTime -agent.getNearestdistorefuge(currentHuman)/31445.392);
				
//				if (agent.getTimeStep() > 200)
//					deadTime = 300;
				// 最短死亡时间
				if (deadTime < minDT) {
					minDT = deadTime;
				}

				// 如果所需要救援周期数大于最短死亡时间，则该智能体必然死亡
				if (rescueCycles > deadTime) {
					// 放弃无法救援的人
					// System.err.println("Remove" + currentHuman
					// + " estimated 2 B Dead");

					savedAndRemovedHumans.add(currentHuman.getID());

					CivilianIsSavedOrDeadMessage mesage = new CivilianIsSavedOrDeadMessage(
							currentHuman.getID());
					agent.sendMessage(mesage, MessagePriority.High);

					giveTaskFromTaskLists();

					if (currentHuman == null) {
						state = State.Inactive;
						return false;
					}
				}

			}
		}

		
		
		lastHuman = currentHuman;
		if(expectedMove == State.Inactive)   {               ///wan
			state=State.Inactive;
			return false;
		}

		if (expectedMove == State.MovingToHuman) {

			List<Area> buildingsandroadswithhuman;                   /// ////wan
			buildingsandroadswithhuman=getBuildingsandRoadswithHuman();  /////wan
			Collections.sort(buildingsandroadswithhuman,new DistanceComparator(agent.getMeAsHuman(),agent.getSEUWorldModel()));   ///14.2wan	
			if (!buildingsandroadswithhuman.isEmpty()) {
				path = getSearch().getPath(agent.getMeAsHuman(),
						buildingsandroadswithhuman, PathType.EmptyAndSafe);
				if (path != null) {
					if (path.isPassable()) {

						this.path = path;

						state = expectedMove;
						return true;
					} else if (path.hasInfiniteCost()) {
						path = getSearch().getPath(agent.getMeAsHuman(),
								buildingsandroadswithhuman, PathType.Shortest);
						if (path != null) {
							if (!path.isEmpty()) {
								requestPathTo(path.getDestination(),
										ClearPathReason.SaveHuman);
								state = State.Inactive;
								return false;
							} else {
								state = State.Inactive;
								return false;
							}
						} else {
							state = State.Inactive;             ////wan
							return false;
						}
					} else {
						state = State.Inactive;
						return false;
					}
				} else {
					state = State.Inactive;
					return false;
				}
			} else {
				state = State.Inactive;
				return false;
			}
		} else if (expectedMove == State.RescuingHuman) {
			state = expectedMove;
			return true;
		} else if (expectedMove == State.LoadingHuman) {
			state = expectedMove;

			return true;
		} else if (expectedMove == State.MovingToRefuge) {
			if(agent.hasnoRefuge()){//niu13.10.16 没reguge
				path=agent.getPathToSafePlace();
			}else{
			path = agent.getPathToRefuge1111();  ///wan
			}
			if (path != null) {
				if (path.isPassable()) {

					this.path = path;

					state = expectedMove;
					return true;
				} else if (path.hasInfiniteCost()) {

					path = agent.getPathToRefuge(PathType.Shortest);
					if (path != null && path.isPassable()) {
						requestPathTo(path.getDestination(),
								ClearPathReason.MoveHumanToRefuge);
						state = State.Inactive;
						return false;
					} else {
						state = State.Inactive;
						return false;
					}
				} else {
					state = State.Inactive;
					return false;
				}
			} else {
				state = State.Inactive;
				return false;
			}
		} else if (expectedMove == State.UnloadingHuman) {
			state = expectedMove;
			return true;
		} else {
			state = State.Inactive;
			return false;
		}

	}

	@Override
	public void execute() {
		//System.out.println(agent.getID()+"  SaveCivAndAgentTask   Execute"+isAgents);
		if (state == State.Inactive) {
		}
		if (state == State.MovingToHuman) {
			agent.sendMove(path);
		}
		if (state == State.RescuingHuman) {
			agent.sendRescue(currentHuman);
			// if (!savedhumansInSendRescue.contains(currentHuman.getID())) {
			// savedhumansInSendRescue.add(currentHuman.getID());
			// }
		}
		if (state == State.LoadingHuman) {
			CivilianIsSavedOrDeadMessage mesage = new CivilianIsSavedOrDeadMessage(
					currentHuman.getID());
			agent.sendMessage(mesage, MessagePriority.Medium);

			agent.sendLoad(currentHuman);
		}
		if (state == State.MovingToRefuge) {
			agent.sendMove(path);
		}
		if (state == State.UnloadingHuman) {

			agent.sendUnload();

			if (!savedAndRemovedHumans.contains(currentHuman.getID()))
				savedAndRemovedHumans.add(currentHuman.getID());

			if (!savedHumansInSendUnload.contains(currentHuman.getID())) {
				savedHumansInSendUnload.add(currentHuman.getID());

			}

		}
	}

	protected State getExpectedMove() {       //获得接下来的动作状态
		Civilian civilian;
		Human human;

		if (!isAgents) {  //市民
			civilian = getLoadedCivilian();           //yuan_n
			if (civilian != null) {
				currentHuman = civilian;
				if(agent.hasnoRefuge()&& (agent.location().getID() .equals(agent.getSafePlace().get(0).getID()))){        //wan
					return State.UnloadingHuman;
				} 
				if(civilian.isDamageDefined()&&civilian.getDamage()!=0
						&&civilian.isHPDefined()){
					int deadtime =civilian.getHP()/civilian.getDamage();
					if(deadtime<3) return State.UnloadingHuman;
				}
				
				
				
				if (agent.isInRefuge()) {
					return State.UnloadingHuman;
				} else {
					return State.MovingToRefuge;
				}
				
			}
		}
		
		
		human = getHumanToLoad();                       //wan
		if (human != null) {
			if (human instanceof Civilian) {                
				civilian = (Civilian) human;
				if (shouldLoadRescuedCivilian(civilian)) {
					currentHuman = civilian;
					starttime=agent.getTimeStep();
			        return   State.LoadingHuman;
				}else{                                  ///      wan在救援后一个人装载   其他的人迅速做其他任务
					 
					removeSaveTask(human.getID());  ///  不能是currenthuman   不能因在路上的走动的市民减去当前的任务   human是当今的任务 
					 giveTaskFromTaskLists();       ///   wan   给currentHuman赋值
					
		            }
			}else{
				
				 
				if (shouldLoadRescuedAgent(human)) {
					currentHuman = human;
					starttime=agent.getTimeStep();
			        return   State.LoadingHuman;
				}else{                                  ///      wan在救援后一个人装载   其他的人迅速做其他任务
					 
					removeSaveTask(human.getID());  ///  不能是currenthuman   不能因在路上的走动的市民减去当前的任务   human是当今的任务 
					 giveTaskFromTaskLists();       ///   wan   给currentHuman赋值
					
		            }
		
				
			}
		}
//		human = getHumanToLoad();
//		if (human != null) {
//			if (human instanceof Civilian) {
//				civilian = (Civilian) human;
//				if (shouldLoadRescuedCivilian(civilian)) {
//					currentHuman = civilian;
//					starttime=agent.getTimeStep();
//					return State.LoadingHuman;
//				} else {
//				}
//			} else {
//				removeSaveTask(human.getID());      //yuan_q 不是市民则移除任务
//			}
//		}

		human = getHumanToRescue();        ////wan
		if (human != null) {
			currentHuman = human;
			return State.RescuingHuman;
		}
		
		  if(!saveHumanTasks.isEmpty())     //wan
			  return State.MovingToHuman;
		  
		  
		  return State.Inactive;

		//return State.MovingToHuman;
	}

	public boolean hasTaskForHuman(Human human) {       //任务中是否包含human
		for (SaveHuman task : saveHumanTasks) {
			if (task.getHuman(getModel()).equals(human)) {
				return true;
			}
		}
		return false;
	}

	public void addSaveTask(SaveHuman saveHumanTask) {
		Human human;
		StandardEntity location;

		human = saveHumanTask.getHuman(getModel());
		location = saveHumanTask.getLocationOfHuman();

		// 解决抛出异常问题
		if (null != location) {
			human.setPosition(location.getID());
		}

		
		if (!hasTaskForHuman(human)
				&& !savedAndRemovedHumans.contains(human.getID())
				&&( (!(location instanceof Refuge
						)&&human.getStandardURN() == StandardEntityURN.CIVILIAN) 
						||(human.getStandardURN() != StandardEntityURN.CIVILIAN))
						                                       ///wan  对于在refuge里的智能体要救助 
				&& (location instanceof Building||location instanceof Road)) {   // wan14.02.21      
		 
			// if (!saveHumanTasks.contains(saveHumanTask))
			// saveHumanTasks.add(saveHumanTask);
			// printSaveHumanTask(saveHumanTask);
			for (SaveHuman s : saveHumanTasks) {
				if (s.human.getID().getValue() == saveHumanTask.human.getID()
						.getValue()) {
					return;
				}
			}
			saveHumanTasks.add(saveHumanTask);
		}
	}

	public void removeSaveTask(EntityID humanId) {         //移除要救的人
		// System.out.println("Cvilian " + humanId.getValue());
		// System.out.println(saveHumanTasks_.toString());
		SaveHuman saveHumanTask = null;

		for (SaveHuman next : saveHumanTasks) {
			if (next.getHuman(getModel()).getID().getValue() == humanId
					.getValue()) {
				saveHumanTask = next;
			}
		}
		if (saveHumanTask != null) {
			removeSaveTask(saveHumanTask);

		}
		// System.out.println(saveHumanTasks.toString());
	}

	public void removeSaveTask(SaveHuman task) {        //将要救的人移除
		if (task != null) {
			// System.out.println("time  " + agent.getTimeStep() + "  id  "
			// + agent + "  task" + task + "  " + task.getHumanId());
			saveHumanTasks.remove(task);
			savedAndRemovedHumans.add(task.getHumanId());
		}
		// System.out.println(saveHumanTasks.toString());
	}

	
	public boolean shouldLoadRescuedCivilian(Civilian civilian){           ////重新定义、
//		
//		boolean IsinTasks=false;        
//		for(SaveHuman savehuman: saveHumanTasks){       ///如果不在自己的任务列表里
//			if(savehuman.getHumanId().equals(civilian.getID()))
//				IsinTasks=true;
//		}
//		if(IsinTasks) {
//			System.out.println("IsinTasks");
//			return false;
//		}
		
		if(currentHuman==null){              //////wan
			//System.out.println("currentHuman==null");
			return false;
		}else if(!currentHuman.getID().equals(civilian.getID())) {
			//System.out.println("不是当前的任务");
			return false;
		}
		
		if(civilian.isDamageDefined()&&civilian.getDamage()!=0
				&&civilian.isHPDefined()){
			int deadtime =civilian.getHP()/civilian.getDamage();
			if(deadtime<3) return false;
		}
		
		List<Human> HereAgents;         
		EntityID positionId;
		StandardEntity position;
		positionId = civilian.getPosition();
		position = getModel().getEntity(positionId);
		 
		if( position instanceof Road&&(agent.hasnoRefuge()))        return false;
                                                            ///////////////wan
		
//		if(civilian.isHPDefined()&&civilian.getHP()==10000)  
//			{
//			System.out.println("HP()==10000");
//			return false;
//			}
		
		 HereAgents = new ArrayList<Human>(agent.foundAgents); 
		 HereAgents.add(agent.getMeAsHuman());        /////把自己添加进去
		 List<EntityID> EntityIDs;  
		 EntityIDs=new ArrayList<EntityID>(); 
		 for(Human  man: HereAgents){ 
		
			 if(man.getStandardURN() == StandardEntityURN.AMBULANCE_TEAM&&
					 man.getPosition().equals(civilian.getPosition()))
				EntityIDs.add(man.getID()); 
			   	 
		}
		 
		 
		Collections.sort(	EntityIDs,	new EntityIdComparator( )); ///////////////wan
		
		if(agent.getID().getValue()==EntityIDs.get(0).getValue())
			return true;///////////////wan

		
		return false;
		
	}
	public boolean shouldLoadRescuedAgent(Human human){           ////重新定义、
//		
//		boolean IsinTasks=false;        
//		for(SaveHuman savehuman: saveHumanTasks){       ///如果不在自己的任务列表里
//			if(savehuman.getHumanId().equals(civilian.getID()))
//				IsinTasks=true;
//		}
//		if(IsinTasks) {
//			System.out.println("IsinTasks");
//			return false;
//		}
		
		if(currentHuman==null){              //////wan
			//System.out.println("currentHuman==null");
			return false;
		}else if(!currentHuman.getID().equals(human.getID())) {
			//System.out.println("不是当前的任务");
			return false;
		}
		
		List<Human> HereAgents;         
		EntityID positionId;
		StandardEntity position;
		positionId = human.getPosition();
		position = getModel().getEntity(positionId);
		 
		if( position instanceof Road&&(agent.hasnoRefuge()))        return false;
                                                            ///////////////wan
		
//		if(civilian.isHPDefined()&&civilian.getHP()==10000)  
//			{
//			System.out.println("HP()==10000");
//			return false;
//			}
		
		 HereAgents = new ArrayList<Human>(agent.foundAgents); 
		 HereAgents.add(agent.getMeAsHuman());        /////把自己添加进去
		 if(human.getStandardURN()==StandardEntityURN.AMBULANCE_TEAM)
			 HereAgents.remove(human);
		 List<EntityID> EntityIDs;  
		 EntityIDs=new ArrayList<EntityID>(); 
		 for(Human  man: HereAgents){ 
		
			 if(man.getStandardURN() == StandardEntityURN.AMBULANCE_TEAM&&
					 man.getPosition().equals(human.getPosition()))
				EntityIDs.add(man.getID()); 
			   	 
		}
		 
		 
		Collections.sort(	EntityIDs,	new EntityIdComparator( )); ///////////////wan
		
		if(agent.getID().getValue()==EntityIDs.get(0).getValue())
			return true;///////////////wan

		
		return false;
		
	}
 
	private void requestPathTo(EntityID target, ClearPathReason reason) {   //请求清理到目标的路径
		StandardEntity location;
		ClearPathIsNeededMessage message;

		location = agent.location();
		message = new ClearPathIsNeededMessage(location.getID(), target, reason);
		agent.sendMessage(message, MessagePriority.High);
	}

	private Civilian getLoadedCivilian() {          //获得已经装载的市民
		List<Civilian> civilians;

		civilians = agent.getCiviliansAround();
		for (Civilian civilian : civilians) {
			if (civilian.isPositionDefined()) {
				EntityID position;

				position = civilian.getPosition();
				if (position.equals(agent.getID())) {      
					return civilian;
				}
			}
		}
		if (state == State.LoadingHuman) {         
			if (currentHuman != null) {
				if (currentHuman instanceof Civilian) {
					Civilian civilian;

					civilian = (Civilian) currentHuman;
					if (agent.canSee(civilian.getID())) {
						return civilian;
					}
				}
			}
		}
		return null;
	}

	private Human getHumanToLoad() {      //得到要装载的人类包括市民和智能体
		List<? extends Human> humans;

		if (isAgents) {
			humans = agent.getFoundAgents();
		} else {
			humans = agent.getCiviliansAround();
		}
		for (Human human : humans) {
			if (human.isPositionDefined()) {
				EntityID positionId;
				StandardEntity position;

				positionId = human.getPosition();
				position = getModel().getEntity(positionId);
				if (!(position instanceof Refuge)) {
					if (positionId.equals(agent.getMeAsHuman().getPosition())) {
						if (position instanceof Building||position instanceof Road) {        /// wan 
							if (human.isBuriednessDefined()) {
								if (human.getBuriedness() == 0) {
									if (human.isHPDefined()) {
										if (human.getHP() > 0) {          //yuan_n 大于救援值
											return human;
										}
									}
								}
							}
						}
					}
				}
			}
		}
		return null;
	}

	private Human getHumanToRescue() {          //选择要救助的受伤最小的人
		List<? extends Human> humansAround;
		List<Human> humans;

		humans = new ArrayList<Human>();

		if (isAgents) {
			humansAround = agent.getFoundAgents();
		} else {
			humansAround = agent.getCiviliansAround();
		}
		for (Human human : humansAround) {
			
					
			if (human.isPositionDefined()) {
				EntityID positionId;
				StandardEntity position;

				positionId = human.getPosition();
				position = getModel().getEntity(positionId);
				if (position instanceof Building||position instanceof Road) { // wan 14.02.20
					if (positionId.equals(agent.getMeAsHuman().getPosition())) {
						if (!(position instanceof Refuge)) { 
								if (human.getBuriedness() > 0) {
									if (human.isHPDefined()) {                  
										if (human.isBuriednessDefined()) {
										if (human.getHP() > 0) {
 											if (agent.canSee(human.getID())) {
 												if(position instanceof Building){
 													Building building =(Building) position;
 													if((building.isFierynessDefined()&&(
 															building.getFieryness()==2||
 															building.getFieryness()==3||
 															building.getFieryness()==1))||
 															(building.isTemperatureDefined()&&
 																	building.getTemperature()>60)){
 														
 													continue;
 													
 												}
 												}
  													
 											 humans.add(human);
											}else {
												   removeSaveTask(human.getID());
											}
										} else {

										}
									} else {
									}
								} else {
								}
							} else {
							}
						} else {
						}
					} else {
					}
				} else {
				}
			}
	     
		}
			
		if (humans.isEmpty()) {
			return null;
		} else {
			BuriedHumanComparator comparator;
			comparator = new BuriedHumanComparator();     

			Collections.sort(humans, comparator);
 		return humans.get(0);
		}
	}
	public SaveHuman getSaveHuman(Human human){ //////wan
		for (SaveHuman task : saveHumanTasks) {
			if(task.getHumanId()==human.getID()) return task;
		}
		return null;
		
		
	}
	public List<SaveHuman> getsaveHumanTasks(){             ///////wan 
		return  saveHumanTasks;
		
		
	}
	public List<Area> getBuildingsandRoadswithHuman() {  ///返回任务中人的位置所在
		List<Area> areas;
		areas = new ArrayList<Area>();
		for (SaveHuman task : saveHumanTasks) {
			StandardEntity position;
			
			if (!savedAndRemovedHumans.contains(task.getHumanId())) {
				position = task.getLocationOfHuman();
				if (position != null && position instanceof Road)   //
				{
					Road road=(Road) position;
					areas.add(road);
				}
				
				if (position != null &&( position instanceof Building)) {
					Building building;
					building = (Building) position;
					if (!building.isOnFire()
							&& building.getFierynessEnum() != Fieryness.BURNT_OUT) {            
						 areas.add(building);
					}  
					}
				}  
				}
	 
		 return areas;
	}
 
	// 閸掋倖鏌囨禒璇插閸掓銆冩稉顓濇崲閸斺剝妲搁崥锔芥箒閺侊拷	
	private void needToRescueHumanInTasks() {    //// 整理一下需要拯救的人
		Human human = null;

		List<SaveHuman> copysavehuman;
		copysavehuman = new ArrayList<SaveHuman>();
		for (SaveHuman p1 : saveHumanTasks)
			copysavehuman.add(p1);
		for (SaveHuman pp : copysavehuman) {
			human = pp.human;
			if (human.isPositionDefined()) {
				EntityID positionId;
				StandardEntity position;

				positionId = human.getPosition();
				position = getModel().getEntity(positionId);
				if (!(position instanceof Building|| position instanceof Road)) // wan 14.02.20
					removeSaveTask(human.getID());
				if (position instanceof Refuge&&(!isAgents))   //////wan  在refuge里可能AT掩埋，没有受伤
					removeSaveTask(human.getID());
				if (human.isBuriednessDefined()
					 &&human.getBuriedness() == 0)
						removeSaveTask(human.getID());
				if (human.isHPDefined()&&human.getHP() == 0)
					removeSaveTask(human.getID());
 
				 
					
			}
		}

	}

	public void removeInvalidTasks() {      //除去死亡或者被救的个体
		List<SaveHuman> temp;
		Area area;
		area = (Area) agent.getMeAsHuman().getPosition(getModel());
		temp = new ArrayList<SaveHuman>(saveHumanTasks);
		if (area instanceof Building||area instanceof Road) {             ///wan 14.02.21
			for (SaveHuman task : temp) {
				
				if(agent.hasnoRefuge()&&task.getHuman(agent.getModel()).getBuriedness()==0&&area instanceof Road) 
					removeSaveTask(task);       ///////wan
				 
				
				if (area.equals(task.getLocationOfHuman())) {
					if (!agent.canSee(task.getHuman(getModel()).getID())) {
						// System.out.println("time  "+agent.getTimeStep()+"   id   "+agent+"  area  "+area
						// +"  target   "+task.getHumanId()
						// +"  targetlocation "+task.getLocationOfHuman());
						CivilianIsSavedOrDeadMessage mesage = new CivilianIsSavedOrDeadMessage(
								task.human.getID());
						// system.out.println("  time  ")
						agent.sendMessage(mesage, MessagePriority.Medium);
						removeSaveTask(task);
					}
				}
				
			}
		}
	}
}