 package seu.agent.BasicTask;

import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.worldmodel.EntityID;
import seu.object.SEUWorldModel;

@SuppressWarnings("serial")
public class SaveHuman extends Task {
	Human human;
	StandardEntity location;
	int deathTime;
     
     double cost;
	public SaveHuman(Human human, StandardEntity location, int deathTime  ,double cost) {
		setHumanAndLocation(human, location, deathTime, cost);
	}

	public StandardEntity getLocationOfHuman() {
		return location;
	}

	public Human getHuman(SEUWorldModel model) {
		if (model == null) {
			return human;
		} else {
			Human h;

			h = model.getEntity(human.getID(), Human.class);
			if (h != null) {
				return h;
			} else {
				return human;
			}
		}
	}

	public EntityID getHumanId() {
		if (human == null) {
			return null;
		} else {
			return human.getID();
		}
	}

	public int getDeathTime() {
		return deathTime;
	}

	public void setHumanAndLocation(Human c, StandardEntity l, int d, double o ) {
		this.human = c;
		this.location = l;
		this.deathTime = d;
         
         this.cost=o;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final SaveHuman other = (SaveHuman) obj;
		if (this.human != other.human
				&& (this.human == null || !this.human.equals(other.human))) {
			return false;
		}
		return true;
	}

	@Override
	public int hashCode() {
		int hash = 3;
		hash = 37 * hash + (this.human != null ? this.human.hashCode() : 0);
		return hash;
	}

	/**
	 * Checks whether the given object is equal to itself or not
	 * 
	 * @param obj
	 *            Given object
	 * @return Returns true if objects are equal.
	 */

	@Override
	public State getState() {
		return State.WillSaveHuman;
	}
	 
 
    public double getcost(){
    	return cost;
    }
    public void setcost(double c){
    	cost=c;
    }
	@Override
	public String toString() {
		return "SaveTask(" + human + ", " + location + ")";
	}

}
