package seu.agent.BasicTask;

import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.agent.Police.SEUPoliceForce;
import seu.message.MessagePriority;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class SaveMyselfTask extends
		BasicTask<SEUAgent<? extends StandardEntity>> {
	private static final int MIN_DAMAGE_GO_TO_REFUGE = 1;
	Path path;

	public SaveMyselfTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
	}

	@Override
	public boolean shouldExecute() {
		//System.out.println(agent.getID()+" SaveMyselfTask    shouldExecute");
		if ((state == State.Inactive || state == State.SavingMyself || state == State.MovingToHydrant)//niu
				&& shouldGoToRefuge()) {
			Path path,path1;
			if(agent.hasnoRefuge()){//niu13.10.16 没reguge
				return false;
			}
	          path = agent.getPathToRefuge();
			
			// if (35380 == agent.getID().getValue())
			// System.err.println("1" + path);
			if (path == null) {
				
				path1 = agent.getPathToRefuge(PathType.Shortest);
				if(path1!=null){
				ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
						path1.getStart(), path1.getDestination(),
						ClearPathReason.SaveMySelf);

				agent.sendMessage(message, MessagePriority.High);
				}
			}
			if (agent instanceof SEUPoliceForce) {
				if (path != null) {
					this.path = path;
					state = State.SavingMyself;
					return true;
				} else {
					return false;
				}
			}
			if (path != null && path.isPassable()) {
				this.path = path;
				state = State.SavingMyself;
				return true;
			} else if (path != null && path.hasInfiniteCost()) {
				path = agent.getPathToRefuge(PathType.Shortest);
				// if (35380 == agent.getID().getValue())
				// System.err.println("2" + path);
				if (path != null && path.isPassable()) {
					ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
							path.getStart(), path.getDestination(),
							ClearPathReason.SaveMySelf);
					agent.sendMessage(message, MessagePriority.High);
				}
			}
		}

		// System.err.println("No Path Found in " + agent.getTimeStep());

		return false;
	}

	@Override
	public void execute() {
//		if(agent.getID().getValue()==327290976)
//		System.out.println(agent.getID()+" SaveMyselfTask     Execute");
		agent.sendMove(path);
		//System.out.println("savemyself  "+"id "+agent.getID());
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
		path = null;
	}

	public boolean shouldGoToRefuge() {
		Human me = agent.getMeAsHuman();
		if (me.isDamageDefined()) {
			return me.getDamage() > MIN_DAMAGE_GO_TO_REFUGE;
		}
		return false;
	}
}
