package seu.agent.Firebrigade;
import seu.agent.Firebrigade.Cluster;

import java.awt.Point;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.EnumSet;
import java.util.List;
import java.util.Random;

import rescuecore2.messages.Command;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Hydrant;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityConstants;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent;
import seu.agent.Firebrigade.ClusterAnalysis;
import seu.agent.Firebrigade.DataPoint;
import seu.agent.BasicTask.BasicTask;
import seu.agent.BasicTask.CheckGasStationTask;
import seu.agent.BasicTask.ExplorationTask;
import seu.agent.BasicTask.ExplorationoutofpartionTask;
import seu.agent.BasicTask.ExploreinpartionTask;
import seu.agent.BasicTask.ExtinguishDangerousBuildingTask;
import seu.agent.BasicTask.ExtinguishFireTask;
import seu.agent.BasicTask.ExtinguishImportantBuildingsTask;
import seu.agent.BasicTask.ExtinguishInfernoFireTask;
import seu.agent.BasicTask.IsStuckOrBuriedCallHelpTask;
import seu.agent.BasicTask.PartitionExplorationTask;
import seu.agent.BasicTask.RandomWalkTask;
import seu.agent.BasicTask.SaveMyselfTask;
import seu.agent.BasicTask.State;
import seu.agent.BasicTask.StuckInRoadTask;
import seu.agent.BasicTask.WaterRefillTask;
import seu.assignment.HungarianAssignment;
import seu.message.CommunicationCondition;
import seu.message.MessagePriority;
import seu.message.Type.AgentPositionMessage;
import seu.message.Type.AssignFiredBuildingMessage;
import seu.message.Type.AssignGasStationMessage;
import seu.message.Type.AssignImportantBuildingsMessage;
import seu.message.Type.BuildingIsBurningMessage;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.message.Type.GasStationIsBurningMessage;//niu
import seu.message.Type.BuildingCloseToGasStationIsBurningMessage;//niu
import seu.message.Type.BuildingIsExploreMessage_fb;
import seu.message.Type.BuildingIsExploredMessage;
import seu.message.Type.BuildingMaybeMessage;
import seu.message.Type.ExtinguishFireTaskMessage;
import seu.message.Type.ImportantBuildingsMessage;
import seu.message.Type.Message;
import seu.message.Type.MessageCount;
import seu.message.Type.MessageType;
import seu.object.SEUWorldModel;
import seu.object.Building.BuildingInfo;
import seu.object.Building.BurningBuildingComparator;
import seu.object.Building.SEUBuilding;
import seu.utilities.DistanceComparator;
import seu.utilities.FireSite;
import seu.utilities.Path;
import seu.utilities.Geometry.PositionLocate;
import seu.utilities.Search.Cost.PathType;
import sun.management.resources.agent;
  
/**
 * SEU's Fire Brigade
 */
public class SEUFireBrigade extends SEUAgent<FireBrigade> {

	private static final String MAX_WATER_KEY = "fire.tank.maximum";
	private static final String MAX_DISTANCE_KEY = "fire.extinguish.max-distance";
	private static final String MAX_POWER_KEY = "fire.extinguish.max-sum";
	int maxWater; 
	private int maxDistance;
	private int maxPower;
	private static final int MIN_TOTAL_AREA_TO_CALL_HELP = 150;
	public GasStation targetGasStation;//NIU
	List<DataPoint> dpoints = new ArrayList<DataPoint>();//niuwei聚类用
	List<point> tubaodian=new ArrayList<point>();
	List<Building> tubaobuilding=new ArrayList<Building>();
	Building target;//niu 标定中心分配的点 
	Boolean ActLikeCentre=false;
	
	List<Building>importantBuildings=new ArrayList<Building>();
	protected List<EntityID> buildings=new ArrayList<EntityID>();
	//protected List<EntityID> agents=new ArrayList<EntityID>();
	protected List<FireBrigade> agents=new ArrayList<FireBrigade>();
	protected List<EntityID> locations=new ArrayList<EntityID>();
	protected List<Fieryness> fierynesses=new ArrayList<Fieryness>();
	double[][] costMatrix;
	// private ExtinguishFireTask extinguishFireTask;
	public SEUFireBrigade() {
		super();
	}

	/**
	 * Returns the agents number as string.
	 * 
	 * @return Agents number
	 */
	@Override
	public String toString() {
		return "SEU Fire Brigade " + getNo() + " " + super.toString();
	}

	/**
	 * Called after agent is connected to kernel
	 */
	@Override
	protected void postConnect() {
		super.postConnect();
		world.indexClass(StandardEntityURN.BUILDING, StandardEntityURN.REFUGE);
		world.indexClass(StandardEntityURN.BUILDING, StandardEntityURN.GAS_STATION);
		maxDistance = config.getIntValue(MAX_DISTANCE_KEY);
		maxPower = config.getIntValue(MAX_POWER_KEY);
		maxWater= config.getIntValue(MAX_WATER_KEY);
	}

	@Override
	protected EnumSet<StandardEntityURN> getRequestedEntityURNsEnum() {
		return EnumSet.of(StandardEntityURN.FIRE_BRIGADE);
	}

	/**
	 * Searches the burning buildings from the world model
	 * 
	 * @param sort
	 *            If this boolean is set to true, returning list will contain
	 *            the burning buildings according to distance.
	 * @return The list of burning buildings in the world model
	 */
	public List<Building> getBurningBuildingsInPartions(){//突包算法,只算分区内及周围分区.省去聚类过程
		Collection<Building> e = world.getEntitiesOfType(Building.class,
				StandardEntityURN.BUILDING);
		List<Building> result = new ArrayList<Building>();
		for (Building b : e) {
			if(b.isOnFire()){
			SEUBuilding seubuilding=world.getSEUBuilding(b.getID());
			if(b.getFieryness()>0 && b.getFieryness()<3){
				//if( seubuilding.getEstimatedFieryness()>0 && seubuilding.getEstimatedFieryness()<3) {//仿真
				if (isInMyPartition(b) || isInNeighborPartition(b) ) {
					if(!result.contains(b))
					result.add(b);
				} 
				
				
			}
		}
		}
	
		return result;
	}
	public List<Building> getBurningBuildingsSorted() {
		return getBurningBuildings(true, false);
	}

	public List<Building> getBurningBuildings() {
		return getBurningBuildings(false, false);
	}

	public List<Building> getBurningBuildings(boolean noInferno) {
		return getBurningBuildings(false, noInferno);
	}

	public List<Building> getBurningBuildings(boolean sort, boolean noInferno) {
		
		Collection<Building> e = world.getEntitiesOfType(Building.class,
				StandardEntityURN.BUILDING);
		List<Building> result = new ArrayList<Building>();
		for (Building b : e) {
			SEUBuilding seubuilding=world.getSEUBuilding(b.getID());
			if (b.isOnFire()){
				if( seubuilding.getEstimatedFieryness()>0 && seubuilding.getEstimatedFieryness()<3) {//仿真
               //if(b.getFieryness()>0 && b.getFieryness()<3){
				//if(inFireCentr(b)){//niu13.10.13
                	//System.out.println( "ignore buildings in the centre");
				//	continue;
				//}
				if (isInMyPartition(b) || isInNeighborPartition(b)) {
					result.add(b);
				} else {
					
					if (doesNeedHelp(b)) {
						result.add(b);
					}
				}
				
				
			}
		}
		}
		if (noInferno) {
			result = removeInfono(result);
		}
		// Sort by distance
		if (sort) {
			Collections.sort(result, new DistanceComparator(location(), world));
		}
		
		return result;
	}

	protected void processMessage(MessageCount message) {
		int counter = message.getCounter();
		MessageCount reply = new MessageCount(counter + 1);
		sendMessage(reply, MessagePriority.High);
	}

	@Override
	protected void thinkAndAct() {
	
	}
	
	@Override
	protected void think(int time, ChangeSet changed, Collection<Command> heard){//niu
		super.think(time, changed, heard);
		
		if(timeStep==startTime){
		Collection<StandardEntity> fireStation = world
				.getEntitiesOfType(StandardEntityURN.FIRE_STATION);
		//if(fireStation.isEmpty()){//无中心,ID最大做代理中心 
			Collection<StandardEntity> fbs = world
					.getEntitiesOfType(StandardEntityURN.FIRE_BRIGADE);
			EntityID maxFB=this.getID();
			for(StandardEntity fb:fbs ){
				if(fb.getID().getValue()>maxFB.getValue()){
					maxFB=fb.getID();
				}
			}
			if(maxFB.equals(getID())){
				ActLikeCentre=true;
				//System.out.println("actlikecentre  "+ getID());
			}
		//}
		}
		 
		if(getTimeStep()%10==0 
				&&  getBurningBuildingsInPartions().size()>10
				 && !ActLikeCentre){
			buildings.clear();
			agents.clear();
			//locations.clear();
			fierynesses.clear();
			
			importantBuildings=getTubaoBuilding();
			if(getCommCondition() == CommunicationCondition.Good ||
					getCommCondition() == CommunicationCondition.Medium
					){
				try{
			for(Building b:importantBuildings){
				//发消息,中心匈牙利
				
				//System.out.println(getID()+"time  "+timeStep+"importantbuildings   "+ b.getID());
				SEUBuilding sb=world.getSEUBuilding(b.getID());
				EntityID location=getLocation(getTimeStep());
				if(b.isFierynessDefined()){
				ImportantBuildingsMessage message=new ImportantBuildingsMessage(
						b.getID(), getID(),location,b.getFieryness(),
						 getTimeStep());
				sendMessage(message,
						MessagePriority.High);
				//System.out.println("send  ImportantBuildingsMessage "+message.getAgentId()+" bid" +message.getBuildingId());
				}
			}
				}catch(Exception e){}
			}else{ 
				//无通信,自己选一个目标 
				System.out.println("no connection");
				agents=getNearbyTeamAgents();
				List<EntityID> bids=new ArrayList<EntityID>();
				for(Building b:importantBuildings){
					EntityID bid=b.getID();
					if(!bids.contains(bid)){
						bids.add(bid);
					}
				}
				if(!agents.isEmpty()){
					System.out.println("have teams");
				costMatrix = makingCostMatrix(bids, agents);//花費矩阵
				 int[] assignment = computeVectorAssignments(costMatrix);
				 try{
				 for(int i=0;i<assignment.length;i++){
					//输出对应关系反了？
								 EntityID agentID=null;	
								 EntityID buildingID=null;
								 if(assignment[i]!=-1 && assignment[i]<agents.size()){
								  agentID=agents.get(assignment[i]).getID();	
								  buildingID=bids.get(i);
								 }
						
								 if(agentID!=null && buildingID!=null){
								if(agentID.getValue()==getID().getValue()){
									System.out.println("set target");
									Building b=(Building)world.getEntity(buildingID);
									setTarget(b);
								}
								 }
							 }
				 }catch(Exception e){}
				}else{
					//无通信,自己随机选一个目标
					System.out.println("no teams randomselect");
				Random rand=new Random();
				int randNum=rand.nextInt(importantBuildings.size());
				setTarget(importantBuildings.get(randNum));
				}
				
			}
		}
		
		if(ActLikeCentre){
			agents=getAllFirebrigades();
		if(timeStep%10==2 && !buildings.isEmpty() ){

		costMatrix = makingCostMatrix(buildings, agents);//花費矩阵
		 int[] assignment = computeVectorAssignments(costMatrix);//与房屋列表对应的FB烈表 
		
		 for(int i=0;i<assignment.length;i++){
//输出对应关系反了？
			
			 AssignImportantBuildingsMessage message=new AssignImportantBuildingsMessage (
					 buildings.get(assignment[i]),transidoldtonew(agents.get(i).getID().getValue()),timeStep);
			
			 //System.out.println("send AssignImportantBuildingsMessage!!!   bID "+
			// message.getBuildingId()+" AID "+	agents.get(i).getID()); 
			 sendMessage(message, MessagePriority.High);
			 
		 }
		
		}
		}
	
	}
	

    public int[] computeVectorAssignments(double[][] costMatrix) {
        HungarianAssignment hungarianAssignment = new HungarianAssignment(costMatrix);
        int[] temp = hungarianAssignment.execute();
        
        int[] result = null;
        List<Integer> tempList = new ArrayList<Integer>();

        if (temp != null) {
            for (int i : temp) {
                if (i != -1) {
                	
                    tempList.add(i);
                }
            }

            result = new int[tempList.size()];
            System.out.println("temp length "+temp.length+"tempList.size() ??"+tempList.size()
            		+"agents length"+agents.size()+"buildings length"+buildings.size()); 
            try{
            for(int i=0;i<tempList.size();i++){
            	
            	result[i]=tempList.get(i);
            	//System.out.println("shishenme ??  "+"  i="+i+" templist i="+tempList.get(i)+" bid "+buildings.get(tempList.get(i))+" aid "+agents.get(i)); 
            }
            }catch(Exception e){}
//            try{
//            for(int i = 0; i < temp.length; i++){
//                if(temp[i] != -1){
//                	System.out.println("shishenme ??  "+"  i="+i+"temp[i]="+temp[i]+" bid "+buildings.get(temp[i])+" aid "+agents.get(i)); 
//                    result[i] = temp[i];   //shuzuyuejie MRL: result[temp[i]] =i 什么意思
//                }
//            }
//            }catch(Exception e){}

        }
//对应于智能体列表的房屋序号列表（如第1个智能体分配给第x个房屋）
        return result;
       

    }
	 public double[][] makingCostMatrix( List<EntityID> buildings,  List<FireBrigade> agents) {
	        int n = agents.size();
	        int m = buildings.size();
	       // System.out.println("huafei");
	        double[][] costMatrix = new double[n][m];
	        
	        Fieryness f=StandardEntityConstants.Fieryness.HEATING;
	        try{
	        for (int i = 0; i < n; i++) {
	        	StandardEntity location=agents.get(i).getPosition(world);
	            for (int j = 0; j < m; j++) {
	            	
	                double distance=model.getDistance(location.getID(), buildings.get(j))/1000;
	                Building b=(Building)world.getEntity(buildings.get(j));
	                
	                int centerX=(int)world.getBounds().getCenterX();
	    			int centerY=(int)world.getBounds().getCenterY();
	    			double distance1=world.distance(centerX, centerY, b.getX(),b.getY())/1000;//distance from the center of the map
	                
	    			int dis = Integer.MAX_VALUE;
	    			
	    			for (GasStation h : this.getAllGasStations()) {
	    				if(!GasStationBurned.contains(h)){
	    				int temp = world.getDistance(b.getID(), h.getID());
	    				if (temp < dis) {
	    					dis = temp;
	    					
	    				}
	    				}
	    			}
	    			dis=dis/1000;
	    			
	    			double buildingimportance=b.getTotalArea()*(fierynesses.get(j).equals(f) ? 100:10);
	    			if(dis>15 && dis<50){
	    				//System.out.println("cost"+" near gas ");
	    				buildingimportance=buildingimportance*100;
	    				if( dis<30){
	    					buildingimportance=buildingimportance*100;
	    				}
	    			}
	                costMatrix[i][j] = buildingimportance/distance1/distance;
	                //System.out.println("cost"+i+"  "+j+costMatrix[i][j]);
	            }
	        }
	        }catch(Exception e){
	        	
	        }


	        return costMatrix;
	    }
	protected boolean goToFirePartition() {
		if (state == State.GoingToFirePartition) {
			return false;
		}
		return false;
	}

	public List<FireSite> getFire() {
		return fire;
	}
	public Building getTarget() {
		return target;
	}
	public Building setTarget(Building building) {
		target=building;
		return target;
	}

	public List<Building> getTubaoBuilding(){//niu 14.2.27凸包
		//System.out.println("time"+timeStep+"tubaokeishi!!!   ");
		
		tubaodian.clear();
		//if(timeStep%5==1){
		tubaobuilding.clear();
		//}
		//System.out.println("time"+timeStep+"diaoyongjulei!!   ");
		/*
		List<Cluster> FireClusters= getFireClusters();
		//System.out.println("time"+timeStep+"juleiwancheng!!   ");
		if(!( FireClusters.isEmpty())){
		for(Cluster c:FireClusters){//每个类
			//System.out.println("time"+timeStep+"gejuleifenbiejisuan!!!   ");
			List<point> fire = new ArrayList<point>();
			List<DataPoint> DataPoints= c.getDataPoints();
			for(DataPoint d: DataPoints){//单个类中的所有点
				float x=world.getEntity(d.getbuildingid()).getLocation(world).first();
				float y=world.getEntity(d.getbuildingid()).getLocation(world).second();
				point p=new point();
				p.x=x;
				p.y=y;
				fire.add(p);
				//System.out.println("tubaodian:   "+p.getX()+" "+ p.getY());
			}
			//for(TubaoPoint t :fire){
			//	System.out.println("tubaodian??????:   "+t.getX()+" "+ t.getY());
			//}
			
			Tubao tu=new Tubao(fire);//这两据有问题？？niu 14。3。18
			List<point> tubao1=tu.getTubaoPoint();//调用凸包算法
			for(point tp:tubao1){//加到tubaodian列表
				//System.out.println("tubaodian:   "+tp.x+tp.y);
				tubaodian.add(tp);
			}
		}
		}else{
			return null;
		}*/
		
		List<Building>  allBurningBuildingsInPartions;
		allBurningBuildingsInPartions = getBurningBuildingsInPartions();
		//System.out.println(timeStep+"  " +getID()+"tubaodiangeshu:   "+allBurningBuildingsInPartions.size());
		List<point> fire = new ArrayList<point>();
		for(Building b: allBurningBuildingsInPartions){
			//if(b.getFieryness()<=3){//niu14.3.27 
				float x=b.getLocation(world).first();
				float y=b.getLocation(world).second();
				point p=new point();
				p.x=x;
				p.y=y;
				fire.add(p);
				//System.out.println("tubaodian:   "+p.x+" "+ p.y);
			//}
			}
					
			Tubao tu=new Tubao(fire);
			List<point> tubao1=tu.getTubaoPoint();//调用凸包算法
			for(point tp:tubao1){//加到tubaodian列表
				//System.out.println("tubaodian!!!!!:   "+tp.x+tp.y);
				tubaodian.add(tp);
			}
		
		for(point tp: tubaodian){//图包房屋没有？？？
			//System.out.println("suantubaofangwu   ");
			Double centerX=world.getBounds().getCenterX();
			Double centerY=world.getBounds().getCenterY();
//			if(Math.abs(tp.x-centerX)>world.getMapWidth()*7/16 || 
//					Math.abs(tp.y-centerY)>world.getMapHeight()*7/16){//niu delete points at the boarder of the map
//				continue;
//			}
			
			Collection<StandardEntity>st=world.getObjectsInRange((int)tp.x, (int)tp.y, 10000);
			for(StandardEntity e:st){
				if(e instanceof Building){
					SEUBuilding sb=world.getSEUBuilding(e.getID());
					
					if(((SEUBuilding) sb).getEstimatedFieryness()==1){
					//if(((Building) e).isFierynessDefined() && ((Building) e).getFieryness()<3){
					//System.out.println("tubaofangwu   "+e.getID());
						
					tubaobuilding.add((Building)e);
					break;
					}
				}
					}
		}
			/*
			for(point td:tubaodian){
				int dis=100000;
				Building nb = null;
				
			  for(Building b:allBurningBuildings){
				if(b.isFierynessDefined() && b.getFieryness()<3){
					BuildingInfo buildinginfo=world.getBuildingInfo(b.getID());
					//BuildingInfo bi=new BuildingInfo(b);
					 
					if(getTimeStep()-buildinginfo.getLastUpdateTime()<10){// niu 防止房屋信息延迟的影想
						//System.out.println("gengxinshijian   "+ buildinginfo.getLastUpdateTime());
				 int dis1=world.distance((int)td.x, (int)td.y,
						b.getLocation(world).first(), b.getLocation(world).second());
				if(dis1<dis){
					dis=dis1;
					nb=b;
				}
				}
				}
			}
			  if(nb!=null && !tubaobuilding.contains(nb)){
				 // System.out.println("tubaofangwu   "+nb.getID());
			  tubaobuilding.add(nb);
			  }
			} 
		*/
		//System.out.println(timeStep+""+ getID()+"tubaodaxiao" + tubaobuilding.size()   );
		return tubaobuilding;
	}
	
	
	public List<Cluster> getFireClusters(){
	//if (timeStep>30&&timeStep % 10 == 1) { //niu 14.2.25 火点聚类
		// System.out.println("time"+timeStep+"FB  "+getID()+"ClusterAnalysis() dpoints"+dpoints);
		dpoints.clear();
		List<Building>  allBurningBuildings;
		allBurningBuildings = getBurningBuildings();//wj  yuanlai getHeatingAndBurningBuildings
		
		for(Building b: allBurningBuildings){
		if(b.getFieryness()==1 ){
			EntityID s=b.getID();			 
		DataPoint n=new DataPoint(s);
		if(!dpoints.contains(n) && dpoints.size()<1000){
		dpoints.add(n);
		}
		}
		System.out.println("juleidianshu "+dpoints.size());
		}
		ClusterAnalysis ca=new ClusterAnalysis();
     List<Cluster> clusters=ca.startAnalysis(dpoints, 5,world);
     //shanchuxiangtonglei 14.3.14
    /*
     for(int i=0;i<clusters.size();i++){
         Cluster clusterC=clusters.get(i);
         List<DataPoint> DataPointsC=clusterC.getDataPoints();
         for(int j=0;j<clusters.size();j++){
             if(i!=j ){
                 Cluster clusterC1=clusters.get(j);
                 List<DataPoint> DataPointsC1=clusterC1.getDataPoints();
                 if(DataPointsC.size()==DataPointsC1.size()){//shumuxiangdeng
                 if(DataPointsC.get(0).equals(DataPointsC1.get(0)) &&//shouweixiangdeng
                         DataPointsC.get(DataPointsC.size()-1).equals(DataPointsC1.get(DataPointsC1.size()-1))){
                     clusters.remove(j);
                     break;
                 }
               }
             }
         
         }
     }
     for(int i=0;i<clusters.size();i++){
         Cluster clusterC=clusters.get(i);
         List<DataPoint> DataPointsC=clusterC.getDataPoints();
         
         for(int j=0;j<DataPointsC.size();j++){
             for(int k=j+1;k<DataPointsC.size();k++){
                 if(DataPointsC.get(j).equals(DataPointsC.get(k))){
                     DataPointsC.remove(k);
                 }
             }
             
         }
     }
     */
     for(Cluster cl:clusters){
        
         System.out.println("------"+cl.getClusterName()+"------");
         List<DataPoint> tempDps=cl.getDataPoints();
         
         if(!(tempDps.size()<3)){                //niu 14/2/9 删除点少的类
         for(DataPoint tempdp:tempDps){
             System.out.print(tempdp.getbuildingid()+" ");
         }System.out.println(" ");
         }else{
            
             clusters.remove(cl);
         }
     }
     return clusters;
    
    //}else{
    //    return null;
    //}
    
    } 
    
    
	public List<Building> getHeatingAndBurningBuildings(boolean sort) {
		Collection<Building> e = world.getEntitiesOfType(Building.class,
				StandardEntityURN.BUILDING);
		List<Building> result = new ArrayList<Building>();
		for (Building b : e) {
			 if (b.isOnFire()) {
			SEUBuilding sb=world.getSEUBuilding(b.getID());
			
				if(sb.getEstimatedFieryness()>0 && sb.getEstimatedFieryness()<3){
					//if (b.getFieryness() > 0 && b.getFieryness() < 3) {
					//System.out.println(getID()+"  seubuilding  " + sb.getID() + "   fire  " +sb.getEstimatedFieryness());
					if (isInMyPartition(b) || isInNeighborPartition(b)
							) {
						result.add(b);
					} else {
						if (doesNeedHelp(b)) {
							result.add(b);
						}
					}
					result.add(b);
				}
			 }
		}
		if (sort) {
			Collections.sort(result, new DistanceComparator(location(), world));
		}
		return result;
	}

	public Building nextBuildingToExtinguish() {
		List<Building> burningBuildings = getBurningBuildingsSorted();
		if (burningBuildings.isEmpty()) {
			return null;
		} else {
			return burningBuildings.get(0);
		}
	}

	public Building nextNearBuildingToExtinguish() {
		List<Building> burningSeenBuildings, extinguishableBuildings;
		BurningBuildingComparator comperator;
		Building building;

		burningSeenBuildings = getBurningBuildingsFromChangeSet();
		extinguishableBuildings = new ArrayList<Building>();
		for (Building burningBuilding : burningSeenBuildings) {
			if (canExtinguish(burningBuilding)) {
				extinguishableBuildings.add(burningBuilding);
			}
		}

		if (extinguishableBuildings.isEmpty()) {
			return null;
		} else {
			comperator = new BurningBuildingComparator(world, getTimeStep());
			Collections.sort(extinguishableBuildings, comperator);
			building = extinguishableBuildings.get(0);
			return building;
		}
	}
	protected void processAssignGasStationMessage(AssignGasStationMessage message) {//niu
		EntityID agentID = transidnewtoold(message.getAgentId().getValue());
		EntityID targetGasStationID = message.getGasStationId();

		if (agentID.getValue() == this.getID().getValue()) {
			GasStation gasStation = (GasStation) world.getEntity(targetGasStationID);
			this.targetGasStation = gasStation;
			// System.out.println(this.getID().getValue() + "is assigned refuge"
			// + refuge.getID().getValue());
		}
	}
	void processExplorationMessage_fb(BuildingIsExploreMessage_fb message) {
		EntityID e = message.getBuildingId();
		StandardEntity s = world.getEntity(e);
		if (s instanceof Building) {
			Building b = (Building) s;
			if (maybebu .contains(b))
				maybebu .remove(b);
			if (nofoundbuilding.contains(b))
				nofoundbuilding.remove(b);
		}
	}

//	void processBuildingMaybeMessage(BuildingMaybeMessage message) {
//		StandardEntity s = world.getEntity(message.getLocationId());
//		if (s instanceof Building) {
//			Building b = (Building) s;
//			temp_maybebuilding.add(b);
//		}
//	}

	public boolean hasReachableBuildings(){
		List<Building>allBurningBuildings=getBurningBuildings();
		Collections.sort(allBurningBuildings,
				new DistanceComparator(getMeAsHuman(), getModel()));
		/*
		 * System.out.println("  time  " + agent.getTimeStep() + "   id  " +
		 * agent.getID() + "   building2  " + allBurningBuildings);
		 */
		Path path = getSearch().getPath(getMeAsHuman(), allBurningBuildings,
				PathType.EmptyAndSafe);
		
		if (path != null && path.isPassable()) {
			return false;
		} 
		return true;
	}
 
	
	@Override
 	protected void processMessage(Message message) {
		if(message instanceof ImportantBuildingsMessage ){
			//System.out.println("FB hear  ImportantBuildingsMessage ");
			if(ActLikeCentre){	
			//if( timeStep-((ImportantBuildingsMessage) message).getTimeStep()<5 && timeStep%10<5){//延迟消息不处理
			ImportantBuildingsMessage importantBuildingsMessage=(ImportantBuildingsMessage) message;
			processImportantBuildingsMessage(importantBuildingsMessage);
			//}
			}
		}
		if (message instanceof AssignImportantBuildingsMessage && getTarget()==null) {
			AssignImportantBuildingsMessage assignImportantBuildingsMessage = (AssignImportantBuildingsMessage) message;
			processAssignImportantBuildingsMessage(assignImportantBuildingsMessage);
		}
		
		if (message instanceof BuildingIsExploredMessage) {
			BuildingIsExploredMessage explorationMessage = (BuildingIsExploredMessage) message;
			processExplorationMessage(explorationMessage);
			//System.out.println("BuildingIsExploredMessage");
		}
//		if (message instanceof BuildingMaybeMessage) {
//			BuildingMaybeMessage buildingmaybeMessage = (BuildingMaybeMessage) message;
//			processBuildingMaybeMessage(buildingmaybeMessage);
//		}
//		if (message instanceof AssignGasStationMessage) {//niu
//			AssignGasStationMessage assignGasStationMessage = (AssignGasStationMessage) message;
//			processAssignGasStationMessage(assignGasStationMessage);
//		}	
		
		if (message instanceof BuildingIsBurningMessage) {
			//System.out.println("FB hear  BuildingsburningMessage ");
			BuildingIsBurningMessage buildingIsBurningMessage = (BuildingIsBurningMessage) message;
			processBuildingIsBurningMessage(buildingIsBurningMessage);
			//System.out.println("buildingIsBurningMessage");
		}
		if (message instanceof BuildingIsExploreMessage_fb) {
			// if (nofoundbuilding.contains(arg0))
			BuildingIsExploreMessage_fb explorationMessage = (BuildingIsExploreMessage_fb) message;
			processExplorationMessage_fb(explorationMessage);
		}
		if (message instanceof GasStationIsBurningMessage) {//niu
			GasStationIsBurningMessage gasStationIsBurningMessage = (GasStationIsBurningMessage) message;
			processGasStationIsBurningMessage(gasStationIsBurningMessage);
		}
		if (message instanceof BuildingCloseToGasStationIsBurningMessage) {//niu
			BuildingCloseToGasStationIsBurningMessage buildingCloseToGasStationIsBurningMessage = (BuildingCloseToGasStationIsBurningMessage) message;
			//int dis=world.getDistance(getID(),((BuildingCloseToGasStationIsBurningMessage) message).getBuildingId());
			
			processBuildingIsBurningMessage(buildingCloseToGasStationIsBurningMessage);
			
		}
		if (message instanceof ExtinguishFireTaskMessage) {
			ExtinguishFireTaskMessage extinguishFireTaskMessage = (ExtinguishFireTaskMessage) message;
			processExtinguishFireTaskMessage(extinguishFireTaskMessage);
		}
		if (message instanceof AgentPositionMessage) {
			AgentPositionMessage agentPositionMessage = (AgentPositionMessage) message;
			processAgentPositionMessage(agentPositionMessage);
		}
		
	}
	
	protected void processImportantBuildingsMessage(ImportantBuildingsMessage message){//buchuli chaoshi?
		//jia ru lie biao
		//System.out.println(timeStep+"FB process  ImportantBuildingsMessage "+getID());
		EntityID buildingID=message.getBuildingId();	
		int fieryness=message.getFieryness();
		EntityID agentID=transidnewtoold(message.getAgentId().getValue());
		EntityID locationID=message.getLocationId();

		//System.out.println("agentID"+ agentID+"add agent ");
		if(!buildings.contains(buildingID)){
			
			buildings.add(buildingID);
			fierynesses.add(StandardEntityConstants.Fieryness.values()[fieryness]);
		}
//		if(!agents.contains(agentID)){
//			System.out.println("agentID"+ agentID+"add agent "+message.getAgentId());
//			agents.add(agentID);             
//			locations.add(locationID);
//		}
	}
	
	// 响应中心任务
	protected void processAssignImportantBuildingsMessage(
			AssignImportantBuildingsMessage message) {
		if(getTarget()==null){
			
		if( transidnewtoold(message.getAgentId().getValue()).getValue()==
				getID().getValue()){//trans id gos wrong?
			//if( message.getAgentId().getValue()==getID().getValue()){
			Building b=(Building)model.getEntity(message.getBuildingId());
			setTarget(b);
//			System.out.println( "processAssignImportantBuildingsMessage" 
//			+" bid "+message.getBuildingId()+" aid "+transidnewtoold(message.getAgentId().getValue()));
		}
		}
	}
	@SuppressWarnings("unused")
	protected void processExtinguishFireTaskMessage(
			ExtinguishFireTaskMessage message) {

		EntityID targetBuildingID = new EntityID(message.getBuildingId());
		Building targetBuilding = (Building) world.getEntity(targetBuildingID);

		int agentID = transidnewtoold(message.getAgentId().getValue())
				.getValue();
		if (me().getID().getValue() == agentID) {
		}
	}

	// 是否具有救火能力
	// 自己距离房屋的距离大于30米
	// 自己的水量大于0
	public boolean canExtinguish(Building building) {
		int distance;
		boolean canExtinguish;

		if (building == null) {
			return false;
		}
		if(inFireCentr(building)){//niu13.10.13
			//System.out.println( "ignore buildings in the centre");
			return false;
		}
		distance = world.getDistance(me(), building);
		canExtinguish = distance <= maxDistance && canSee(building.getID())&& me().getWater() > 0 
				&& building.getFieryness()!=5;//niu
		return canExtinguish;
	}

	@Override
	protected boolean canRescue() {
		return false;
	}

	@SuppressWarnings({ "rawtypes" })
	@Override
	public List<BasicTask> getAgentTasks() {

//		int maxWater;
//		maxWater = config.getIntValue(MAX_WATER_KEY);

		List<BasicTask> tasks;
		tasks = new ArrayList<BasicTask>();
		
//if(timeStep%10==1){
//	System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
//	tubaobuilding.clear();
//	    tubaobuilding=getTubaoBuilding();
//		tasks.add(new ExtinguishImportantBuildingsTask(this, tubaobuilding));
//}		
		tasks.add(new ExtinguishFireTask(this, false));
		tasks.add(new IsStuckOrBuriedCallHelpTask(this));
		// tasks.add(new ExtinguishFromRefugeTask(this));
		tasks.add(new SaveMyselfTask(this));
		tasks.add(new StuckInRoadTask(this));
		tasks.add(new WaterRefillTask(this, maxWater, 0));
		// tasks.add(new Extinguishtask(this, true));
		// ExtinguishFireTask 灭firenss为1、2的房屋
		
		// ExtinguishInfernoFireTask 灭fireness为1、2、3的房屋
		
		//tasks.add(new CheckGasStationTask(this));
		tasks.add(new ExtinguishInfernoFireTask(this, false));
		tasks.add(new ExtinguishDangerousBuildingTask(this));
		tasks.add(new WaterRefillTask(this, maxWater, maxWater / 2));
//		tasks.add(new ExplorationTask(this));
		tasks.add(new PartitionExplorationTask(this));
	//	tasks.add(new ExploreinpartionTask(this));  /// /wan14.3
	//	tasks.add(new ExplorationoutofpartionTask(this));/////  wan 
		tasks.add(new RandomWalkTask(this));
		return tasks;
	}
	
	// Send Extinguish
	public void sendExtinguish(Building building) {
		 //niu14.4.18          MRL水量古计法
             int waterPower = calculateWaterPower(world, building); 
             //System.out.println(waterPower);
             sendExtinguish(timeStep,  building.getID(), waterPower);
//         
//		if (me().getWater() < maxPower) {
//			sendExtinguish(timeStep, building.getID(), me().getWater());
//			return;
//		}
//		sendExtinguish(timeStep, building.getID(), maxPower);
	}
	 public  int calculateWaterPower(SEUWorldModel world, Building building) {//niu
		 return Math.min(me().getWater(), Math.min(maxPower, Math.max(500, waterNeededToExtinguish(building))));
	    }
	 public int waterNeededToExtinguish(Building building) {//niu
		
	        return getWaterNeeded(building.getGroundArea(), building.getFloors(),
	                building.getBuildingCode(), building.getTemperature(), 20);     //MRL溫度是用火方真器算的
	 }
	 public static int getWaterNeeded(int groundArea, int floors, int buildingCode, double temperature, double finalTemperature) {//niu
	        int waterNeeded = 0;
	        double currentTemperature = temperature;
	        int step = 500;
	        while (true) {
	            currentTemperature = waterCooling(groundArea, floors, buildingCode, currentTemperature, step);
	            waterNeeded += step;
	            if (currentTemperature <= finalTemperature){
	                break;
	            }
	        }
	        
	        return waterNeeded;
	    }
	 private static double waterCooling(int groundArea, int floors, int buildingCode, double temperature, int water) {//niu
	        if (water > 0) {
	            double effect = water * 20;
	            return (getBuildingEnergy(buildingCode, groundArea, floors, temperature) - effect) / getBuildingCapacity(buildingCode, groundArea, floors);
	        } else
	            throw new RuntimeException("WTF water=" + water);
	    }
	 protected static double getBuildingEnergy(int buildingCode, int groundArea, int floors, double temperature) {//niu
	        return temperature * getBuildingCapacity(buildingCode, groundArea, floors);
	    }
	    protected static double getBuildingCapacity(int buildingCode, int groundArea, int floors) {//niu
	        double thermoCapacity;
	        switch (buildingCode) {
	            case 0:
	                //wooden
	                thermoCapacity = 1.1;
	                break;
	            case 1:
	                //steel
	                thermoCapacity = 1.0;
	                break;
	            default:
	                //concrete
	                thermoCapacity = 1.5;
	                break;
	        }
	        return thermoCapacity * groundArea * floors * 7;
	    }
	    
	public boolean doesNeedHelp(Building building) {
		if (building.isFierynessDefined() && building.isTotalAreaDefined()) {

			if ((building.getFierynessEnum() == Fieryness.INFERNO || world
					.getTotalBurningArea(building) > MIN_TOTAL_AREA_TO_CALL_HELP||
					building.getImportance()>1)) {//niu

				// System.out.println("Needs help building " +
				// building.getID().getValue());

				return true;
			}
		}
		return false;

	}
	public boolean inFireCentr(Building building) {
		if (building.isFierynessDefined() && building.isTotalAreaDefined()) {

			boolean NeighboursAre4=false;
			int i=0;
			BuildingInfo buildingInfo = new BuildingInfo(building);
			List<Building> neighbours = buildingInfo.getNeighbours(world);
			for (Building next : neighbours) {
				if (next.isOnFire()&& next.getFieryness()>1) {
					i++;

				}
			}
			if(i>=4){NeighboursAre4=true;}
			if (timeStep<150 && building.getFieryness()==3 &&
					world.getTotalBurningArea(building) >1500 &&
					NeighboursAre4
					) {

				return true;
			}
		}
		return false;

	}
	@Override
	public List<MessageType> getMessagesToListen() {
		List<MessageType> types;

		types = new ArrayList<MessageType>();
		types.add(MessageType.ImportantBuildingsMessage);//niu 
		types.add(MessageType.BuildingIsBurningMessage);
		types.add(MessageType.AssignImportantBuildingsMessage );//niu 分配消息
		types.add(MessageType.AssignFiredBuildingMessage );//niu 分配消息
		//types.add(MessageType.GasStationIsBurningMessage);//niu
		types.add(MessageType.BuildingCloseToGasStationIsBurningMessage);//niu
		types.add(MessageType.AgentPositionMessage);//niu
		//types.add(MessageType.AssignGasStationMessage);//niu
		//types.add(MessageType.GasStationIsExtinguishedMessage);
		types.add(MessageType.BuildingIsExtinguishedMessage);
		types.add(MessageType.BuildingIsExploredMessage);
		types.add(MessageType.BuildingIsExploreMessage_fb);
		return types;
	}

	public int getMaxDistance() {
		return maxDistance;
	}
	
	
}
