package seu.agent.Path;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.agent.Police.PoliceTaskPriority;
import seu.message.Type.InformTeamSavingCivilianMessage;
import seu.message.Type.TrackedSavingCivilianMessage;
import seu.object.SEUWorldModel;

public class AmbulanceTeamPathManager {
	private List<TrackedSavingCivilianMessage> trackedMessages;
	private List<RequiredClearPath> requiredClearPaths;

	public AmbulanceTeamPathManager() {
		trackedMessages = new ArrayList<TrackedSavingCivilianMessage>();
		requiredClearPaths = new ArrayList<RequiredClearPath>();
	}

	public void addMessage(InformTeamSavingCivilianMessage message, int timeStep) {
		TrackedSavingCivilianMessage tmessage = new TrackedSavingCivilianMessage(
				message, null, timeStep);
		trackedMessages.add(tmessage);
	}

	public void updateState(SEUWorldModel world, int timeStep) {

		requiredClearPaths.clear();
		for (TrackedSavingCivilianMessage next : trackedMessages) {
			EntityID start = next.getMessage().getBuildingId();
			int durationToClear = next.getMessage().getBuriedness();
			RequiredClearPath requiredPath = new RequiredClearPath(start, null,
					durationToClear, PoliceTaskPriority.Ignore);
			requiredClearPaths.add(requiredPath);
		}
		clearTrackedMessage(timeStep);

	}

	public List<RequiredClearPath> getDesiredPaths() {
		return requiredClearPaths;
	}

	private void clearTrackedMessage(int timeStep) {
		trackedMessages.clear();
	}

}
