 package seu.agent.Police;

import java.awt.Point;
import java.awt.Polygon;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.EnumSet;
import java.util.HashMap;
import java.util.List;
import java.util.PriorityQueue;

import rescuecore2.messages.Command;
import rescuecore2.misc.geometry.Line2D;
import rescuecore2.misc.geometry.Point2D;
import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityConstants;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;
import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent;
import seu.agent.BasicTask.AssignAgentTask;
import seu.agent.BasicTask.BasicTask;
import seu.agent.BasicTask.CheckATAfterShock;
import seu.agent.BasicTask.CheckAfterShock;
import seu.agent.BasicTask.CheckRefugeTask;
import seu.agent.BasicTask.ClearBlockedRoadToFireTask;
import seu.agent.BasicTask.ClearBlockedRoadToGasStationTask;
import seu.agent.BasicTask.ClearBlockedRoadToRefugeTask;
import seu.agent.BasicTask.ClearEntranceTask;
import seu.agent.BasicTask.ClearMainRoadTask;
import seu.agent.BasicTask.ClearNearBlockadeTask;
import seu.agent.BasicTask.ClearOnBlockadeTask;
import seu.agent.BasicTask.ClearPath;
import seu.agent.BasicTask.ClearPathTask;
import seu.agent.BasicTask.ClearRaodToFireTask;
import seu.agent.BasicTask.ExplorationoutofpartionTask;
import seu.agent.BasicTask.ExploreinpartionTask;
import seu.agent.BasicTask.IsStuckOrBuriedCallHelpTask;
import seu.agent.BasicTask.PFPartitionExplorationTask;
import seu.agent.BasicTask.PFStuckInBuildingTask;
import seu.agent.BasicTask.PFStuckInRoadTask;
import seu.agent.BasicTask.PartitionExplorationTask;
import seu.agent.BasicTask.RandomWalkTask;
import seu.agent.BasicTask.SaveMyselfTask;
import seu.agent.BasicTask.SaveNearStuckAgentTask;
import seu.agent.command.seuClear;
import seu.assignment.HungarianAssignment;
import seu.message.CommunicationCondition;
import seu.message.MessagePriority;
import seu.message.Type.AgentIsBuriedMessage;
import seu.message.Type.AgentIsStuckMessage;
import seu.message.Type.AgentPositionMessage;
import seu.message.Type.AssignFiredBuildingMessage;
import seu.message.Type.AssignGasStationMessage;
import seu.message.Type.AssignImportantBuildingsMessage;
import seu.message.Type.AssignRefugeMessage;
import seu.message.Type.BuildingIsExploreMessage_pf;
import seu.message.Type.BuildingIsExploredMessage;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.message.Type.Message;
import seu.message.Type.MessageCount;
import seu.message.Type.MessageType;
import seu.message.Type.RoadIsClearedMessage;
import seu.object.SEUWorldModel;
import seu.object.Partition.EntityInPartition;
import seu.object.Partition.PartitionMap;
import seu.object.Road.MultiBlockDistanceComparator;
import seu.object.Road.PathBlockState;
import seu.object.Road.RoadUtilities;
import seu.utilities.ACAMainRoad;
import seu.utilities.DistanceComparator;
import seu.utilities.Path;
import seu.utilities.Geometry.DistanceUtilities;
import seu.utilities.Geometry.PositionLocate;
import seu.utilities.Search.Cost.PathType;
import seu.utils.geo.mathTools;

/**
 * SEU's Police Office
 */
public class SEUPoliceForce extends SEUAgent<PoliceForce> {

	// 清障距离
	private static final String DISTANCE_KEY = "clear.repair.distance";
	public List<Human> humansinrange;
	private ClearPathTask clearPathTask;            //yuan
	private ClearPathTask clearAgentIsStuckTask;    //yuan
	private int distance;
	public boolean isDone = false;
	public boolean taskDone = false;
	public boolean isSelected = false;
	public boolean existPO = false;
	public int numOfRefuge;
	public int numOfGasStation;//niu
	public int numOfFire;//niu
	public int numOfPF;
	public Refuge targetRefuge;
	public GasStation targetGasStation;//NIU
	public Building targetFire;//NIU
	public EntityID targetBuilding = null;
	public ArrayList<StandardEntity> PF = new ArrayList<StandardEntity>();
	public ArrayList<StandardEntity> refuge = new ArrayList<StandardEntity>();
	public ArrayList<StandardEntity> gasStation = new ArrayList<StandardEntity>();//niu
	public ArrayList<StandardEntity> Fire= new ArrayList<StandardEntity>();//niu
	public ArrayList<Integer> refugeSort = new ArrayList<Integer>();
	public ArrayList<Integer> gasStationSort = new ArrayList<Integer>();//niu
	public ArrayList<Integer> FireSort = new ArrayList<Integer>();//niu
	public ArrayList<Integer> PFSort = new ArrayList<Integer>();
	public HashMap<Integer, Integer> clearedBlockade = new HashMap<Integer, Integer>();
	public HashMap<Integer, Integer> numOfClear = new HashMap<Integer, Integer>();
	public ArrayList<Integer> PFTarget = new ArrayList<Integer>();
	private FunctionType functionType;
	private int numOfQuartions = 0;
	public int numOfTeamMember;
	public ArrayList<Path> mainRoad;
    public List<Blockade> observableBlockade=new ArrayList<Blockade>();             //yuan
	
	public SEUPoliceForce() {
		super();

	}

	@Override
	public String toString() {
		return "SEU Police Force # " + getNo() + " " + super.toString();
	}

	@Override
	protected void postConnect() {
		distance = config.getIntValue(DISTANCE_KEY);
		clearRate=config.getIntValue(CLEAR_RATE_KEY);
		clearRad=config.getIntValue(CLEAR_RADIUS_KEY);
		clearMin=1000*1000*clearRate/clearRad;
		super.postConnect();
		findMainRoad();
	}

	public void findMainRoad() {
		aca = new ACAMainRoad(this);
		mainRoad = aca.getCriticalPath();
//		for(Path mainroads:mainRoad){
//			List<EntityID>  IDs = mainroads.getEntities();
//			System.out.println("road "+mainroads.getEntities());
//			for(EntityID id :IDs){
//				System.out.print(id.getValue()+",");
//			}
//			
//		}
		// System.out.println(aca.getCriticalPath());
		// System.out.println(this.location());
		for (StandardEntity e : world
				.getEntitiesOfType(StandardEntityURN.POLICE_FORCE)) {
			Human h = (Human) e;
			// System.out.println(h.toString() + " " + h.getPosition());
		}
	}

	@Override
	protected EnumSet<StandardEntityURN> getRequestedEntityURNsEnum() {
		return EnumSet.of(StandardEntityURN.POLICE_FORCE);
	}

//	public void dividePF() {
//		numOfTeamMember = world.getTeam().size();
//		// TODO Auto-generated method stub
//		ArrayList<EntityID> tempPF = new ArrayList<EntityID>();
//		for (StandardEntity e : getWorldModel().getEntitiesOfType(
//				StandardEntityURN.POLICE_FORCE)) {
//			tempPF.add(e.getID());
//		}
//		// System.err.println(getNo() + "numOfTeamMember" + numOfTeamMember);
//		if (numOfTeamMember <= 6) {// 分区PF
//			functionType = FunctionType.dynamicQuartations;
//			numOfQuartions = numOfTeamMember;
//		} else if (numOfTeamMember <= 14) {// 6个静态PF+连通PF-》6个静态PF+1/2动态PF
//			numOfQuartions = 6;
//			if (this.getNo() < 6) {
//				functionType = FunctionType.staticQuartations;
//
//			} else if (this.getNo() < 6 + 8) {
//				functionType = FunctionType.connectQuartations;
//
//			} else {
//				functionType = FunctionType.dynamicQuartations;
//
//			}
//		} else {// 1/2静态PF+连通PFPF+动态PF
//			numOfQuartions = numOfTeamMember / 2;
//			if (this.getNo() < numOfTeamMember / 2) {
//				functionType = FunctionType.staticQuartations;
//			} else if (this.getNo() < numOfTeamMember / 2 + 8) {
//				functionType = FunctionType.connectQuartations;
//			} else {
//				functionType = FunctionType.dynamicQuartations;
//			}
//		}
//		// System.out.println(this.toString() + functionType +
//		// "numOfQuratitions"
//		// + numOfQuartions);
//	}
//
//	@Override
//	public void assignQuartations() {
//		// TODO Auto-generated method stub
//		// super.assignQuartations();
//		dividePF();
//		ArrayList<EntityID> team = new ArrayList<EntityID>();
//		for (int i = 0; i < numOfQuartions; i++)
//			team.add(world.getTeam().get(i));
//		world.getPartitionModel().assignPartitionsToTeam(team);
//		//List<EntityID> OnePF=new ArrayList();
//		//OnePF.add(this.getID());
////		if (this.getNo() >= numOfQuartions) {                            //wkk
////			world.getPartitionModel().getPartitionAssignements()
////			.put(world.getPartitionModel().getPartitionGroups().
////			get(getNo()% (world.getPartitionModel().getPartitionGroups().size())),OnePF);
////
////		}
//		if (this.getNo() >= numOfQuartions) {                  //yuan_r
//			System.out.println(getNo()+"  "+world.getPartitionModel().getPartitionGroups().size());
//			world.getPartitionModel()
//			.getPartitionAssignements()
//			.put(this.getID(),world.getPartitionModel().getPartitionGroups().get(getNo()
//							% (world.getPartitionModel().getPartitionGroups().size())));
//        }
//		List<EntityInPartition> regions = getAssignedPartitions();
//		// System.out.println(this.toString() + " " + functionType + " "
//		// + regions.size());
//		for (EntityInPartition region : regions) {
//			getExploration().addEntitiesToExplore(region.getBuildings());
//		}
//
//	}

	@Override
	public PartitionMap getNeighbourAssignedPartitinMap() {
		if (world == null) {
			return null;
		} else {
			return world.getPartitionModel().getPartitionGroups()
					.get((this.getNo() + 1) % numOfQuartions);
		}
	}

	public List<Road> getBlockedRoads() {
		List<Road> targets = new ArrayList<Road>();
		for (StandardEntity next : world
				.getEntitiesOfType(StandardEntityURN.ROAD)) {
			Road r = (Road) next;
			if (r.isBlockadesDefined() && !r.getBlockades().isEmpty()) {
				targets.add(r);
			}
		}
		Collections.sort(targets, new DistanceComparator(location(), world));
		return targets;
	}

	public List<Blockade> getBlockades() {
		List<Road> roads;
		List<Blockade> blockades;

		roads = world.getEntitiesOfType(Road.class, StandardEntityURN.ROAD);
		blockades = new ArrayList<Blockade>();
		for (Road road : roads) {
			if (road.isBlockadesDefined()) {
				List<EntityID> blockadeIds;

				blockadeIds = road.getBlockades();
				for (EntityID id : blockadeIds) {
					Blockade blockade;

					blockade = world.getEntity(id, Blockade.class);
					blockades.add(blockade);
				}
			}
		}
		return blockades;
	}

	public boolean isBuildingEntrance(EntityID entityId) {//此函数从未被调用
		Area area = (Area) world.getEntity(entityId);
		List<EntityID> neighbors = area.getNeighbours();
		for (EntityID next : neighbors) {
			StandardEntity entity = world.getEntity(next);
			if (entity instanceof Building) {
				// System.out.println("Building entrance : " +
				// entityId.getValue() + " building: " + next.getValue());
				return true;
			}
		}
		return false;
	}

	public Area getAreaToClear() {
		Area area = (Area) location();
		List<EntityID> neighbors = area.getNeighbours();
		for (EntityID next : neighbors) {
			StandardEntity entity = model.getEntity(next);
			if (entity instanceof Road) {
				Area neighborRoad = (Area) entity;
				PathBlockState pbs;

				pbs = RoadUtilities.getPathBlockState(getMeAsHuman(),
						neighborRoad, world);
				if (pbs == PathBlockState.FirstPartIsBlocked) {
				
					return area;
				} else if (pbs == PathBlockState.SecondPartIsBlocked) {
					return neighborRoad;
				}
			}
		}
		return null;
	}

	public Blockade getTargetBlockade(Area area, int maxDistance) {
		if (!area.isBlockadesDefined()) {
			return null;
		}
		List<EntityID> ids = area.getBlockades();
		Point agentPoint;
		// Find the first blockade that is in range.

		agentPoint = PositionLocate.getPosition(getMeAsHuman(), world);
		// int x = me().getX();
		// int y = me().getY();
		for (EntityID next : ids) {
			Blockade b = (Blockade) model.getEntity(next);
			double d;

			d = DistanceUtilities.getDistanceToBlock(b, agentPoint);
			if (maxDistance < 0 || d < maxDistance) {
				return b;
			}
		}
		return null;
	}

	public Path getTargetBlockadeAtLocation() {

		return null;
	}

	protected void processMessage(MessageCount message) {
		int counter = message.getCounter();
		MessageCount reply = new MessageCount(counter + 1);
		sendMessage(reply, MessagePriority.High);
	}

	@Override
	protected void thinkAndAct() {
	}

	public boolean isOnBlockedRoad() {
		StandardEntity location = location();
		if (location instanceof Road) {
			Road r = (Road) location;
			if (r.isBlockadesDefined() && r.getBlockades().size() > 0) {
				return true;
			}
		}
		return false;
	}

	void processBuildingIsExploreMessage_pf(BuildingIsExploreMessage_pf message) {
		EntityID e = message.getBuildingId();
		StandardEntity s = world.getEntity(e);
		if (s instanceof Building) {
			Building b = (Building) s;
			if (nofoundbuilding.contains(b))
				nofoundbuilding.remove(b);
		}
	}

	@Override
	protected void processMessage(Message message) {
		if (message instanceof BuildingIsExploredMessage) {
			BuildingIsExploredMessage explorationMessage = (BuildingIsExploredMessage) message;
			processExplorationMessage(explorationMessage);
		}
		if (message instanceof BuildingIsExploreMessage_pf) {
			BuildingIsExploreMessage_pf p1 = (BuildingIsExploreMessage_pf) message;
			processBuildingIsExploreMessage_pf(p1);

		}

		if (message instanceof ClearPathIsNeededMessage) {
			ClearPathIsNeededMessage clearPathMessage = (ClearPathIsNeededMessage) message;
			processClearPathMessage(clearPathMessage);
		}
		if (message instanceof AgentIsStuckMessage) {
			AgentIsStuckMessage agentIsStuckMessage = (AgentIsStuckMessage) message;
			processAgentIsStuckMessage(agentIsStuckMessage);
		}
		if (message instanceof AssignRefugeMessage) {
			AssignRefugeMessage assignRefugeMessage = (AssignRefugeMessage) message;
			processAssignRefugeMessage(assignRefugeMessage);
		}
		if (message instanceof AssignGasStationMessage) {//niu
			AssignGasStationMessage assignGasStationMessage = (AssignGasStationMessage) message;
			processAssignGasStationMessage(assignGasStationMessage);
			System.out.println(timeStep+"  "+getID()+"AssignGasStationMessage" );
		}
		if (message instanceof RoadIsClearedMessage) {
			RoadIsClearedMessage roadIsClearMessage = (RoadIsClearedMessage) message;
			processRoadIsClearMessageMessage(roadIsClearMessage);
		}
		if (message instanceof AssignFiredBuildingMessage) {
			AssignFiredBuildingMessage assignBuildingMessage = (AssignFiredBuildingMessage) message;
			processAssignFiredBuildingMessage(assignBuildingMessage);
		}
		if (message instanceof BuildingIsExploredMessage) {
			BuildingIsExploredMessage buildingIsExploredMessage = (BuildingIsExploredMessage) message;
			processBuildingIsExploredMessage(buildingIsExploredMessage);
		}
//		if (message instanceof AssignImportantBuildingsMessage ) {  //niu
//			AssignImportantBuildingsMessage assignImportantBuildingsMessage = (AssignImportantBuildingsMessage) message;
//			processAssignImportantBuildingsMessage(assignImportantBuildingsMessage);
//			//System.out.println(timeStep+"  "+getID()+"AssignImportantBuildingsMessage" );
//		}
		
		/*if (message instanceof BuildingMaybeMessage_pf) {
			BuildingMaybeMessage_pf buildingMaybeMessage_pf = (BuildingMaybeMessage_pf) message;
			processBuildingMaybeMessage_pf(buildingMaybeMessage_pf);
		}*/
	}

	private void processBuildingIsExploredMessage(
			BuildingIsExploredMessage message) {
		try {
			// TODO Auto-generated method stub
			EntityID b = message.getBuildingId();
			StandardEntity s = world.getEntity(b);
			if (s instanceof Building) {
				Building building = (Building) world.getEntity(b);
				this.getExploration().addToExplorationHistory(building);
			}
		} catch (Exception e) {
			System.err.println(this.toString() + "There is no such building");
		}
	}
	/*void processBuildingMaybeMessage_pf(BuildingMaybeMessage_pf message) {
		 
		for(int i=0;i<message.getCivilianMayInBuildingId().length;i++){
		 StandardEntity s = world.getEntity(message.getCivilianMayInBuildingId()[i]);
		
		if (s instanceof Building) {
			Building b = (Building) s;
			temp_maybebuilding.add(b);
			
		}
		}
		state =State.Exploring;
		System.err.println("pf  temp_maybebuilding "+temp_maybebuilding);//lblater
	}
	*/
	protected void processAssignFiredBuildingMessage(
			AssignFiredBuildingMessage message) {
		EntityID agentID = transidnewtoold(message.getAgentId().getValue());
		EntityID targetBuildingID = message.getBuildingId();

		if (agentID.getValue() == this.getID().getValue()) {
			this.targetBuilding = targetBuildingID;
			// System.out.println(this.getID().getValue() + "Receive"
			// + message.toString() + "in" + timeStep);
		}
	}

	protected void processRoadIsClearMessageMessage(RoadIsClearedMessage message) {
		EntityID roadID = message.getRoadId();
		//System.out.println(" processRoadIsClearMessageMessage");
		PriorityQueue<ClearPath> clearPathQueue = clearPathTask
				.getClearPathQueue();
		PriorityQueue<ClearPath> clearPathQueue2 = clearAgentIsStuckTask
				.getClearPathQueue();
		Collection<ClearPath> removeClearPath = new ArrayList<ClearPath>();
		PFTarget.add(roadID.getValue());
		if (clearPathQueue != null && !clearPathQueue.isEmpty()) {
			for (ClearPath cp : clearPathQueue) {
				if (cp.getRoadIdStart().getValue() == roadID.getValue()) {
					// clearPathQueue.remove(cp);
					removeClearPath.add(cp);
					// System.err.println(this.getTimeStep() + "---"
					// + this.toString() + "Receive" + message + cp);
				}
			}
			clearPathQueue.removeAll(removeClearPath);
		}
		removeClearPath.clear();
		if (clearAgentIsStuckTask != null && !clearPathQueue.isEmpty()) {
			// System.err.println(this.toString() + "before remove"
			// + clearPathQueue2.size());
			for (ClearPath cp : clearPathQueue2) {
				if (cp.getRoadIdStart().getValue() == roadID.getValue()) {
					// clearPathQueue.remove(cp);
					removeClearPath.add(cp);
					// System.err.println(this.getTimeStep() + "---"
					// + this.toString() + "Receive" + message + cp);
				}
			}
			clearPathQueue2.removeAll(removeClearPath);
			// System.err.println(this.toString() + "after remove"
			// + clearPathQueue2.size());

		}

	}

	protected void processAssignRefugeMessage(AssignRefugeMessage message) {
		EntityID agentID = transidnewtoold(message.getAgentId().getValue());
		EntityID targetRefugeID = message.getRefugeId();

		if (agentID.getValue() == this.getID().getValue()) {
			Refuge refuge = (Refuge) world.getEntity(targetRefugeID);
			this.targetRefuge = refuge;
			// System.out.println(this.getID().getValue() + "is assigned refuge"
			// + refuge.getID().getValue());
		}
	}
	protected void processAssignGasStationMessage(AssignGasStationMessage message) {//niu
		EntityID agentID = transidnewtoold(message.getAgentId().getValue());
		EntityID targetGasStationID = message.getGasStationId();

		if (agentID.getValue() == this.getID().getValue()) {
			GasStation gasStation = (GasStation) world.getEntity(targetGasStationID);
			this.targetGasStation = gasStation;
			// System.out.println(this.getID().getValue() + "is assigned refuge"
			// + refuge.getID().getValue());
		}
	}

	protected void processAgentIsBuriedMessage(AgentIsBuriedMessage message) {
		EntityID location = new EntityID(message.getLocationId());
		StandardEntity agentLocation = world.getEntity(location);
		ClearPath cp = new ClearPath(agentLocation.getID(), location,
				ClearPathReason.StuckInBuilding);
		if (clearPathTask != null)
			clearPathTask.addClearPathTask(cp);
		//System.out.println("processAgentIsBuriedMessage");
	}

	protected void processClearPathMessage(ClearPathIsNeededMessage message) {
		if (message.getClearPathReason() == ClearPathReason.StuckInBuilding) {
			EntityID startId = message.getStartId();
			StandardEntity startEntity = world.getEntity(startId);
			EntityID finishId = message.getFinishId();
			StandardEntity finishEntity = world.getEntity(finishId);
			if (finishEntity instanceof Building) {
				Road entrance = getEntranceRoad((Building) finishEntity);
				if (entrance != null) {
					finishId = entrance.getID();
					finishEntity = world.getEntity(finishId);
				}
			}
			// System.out.println(this.getTimeStep() + "---" + this.getID()
			// + "Receive" + message);
			PriorityQueue<ClearPath> clearPathQueue = clearAgentIsStuckTask
					.getClearPathQueue();

			if (clearPathQueue != null && !clearPathQueue.isEmpty()) {
				for (ClearPath cp : clearPathQueue) {
					if (cp.getRoadIdStart().getValue() == startId.getValue()
							&& cp.getRoadIdFinish().getValue() == finishId
									.getValue()) {
						return;
					}
				}
			}
			int dis = world.getDistance(this.getID(), startId);
			if (!PFTarget.isEmpty() && PFTarget.contains(startId.getValue())) {

				// System.out.println("Same target!");
				return;
			}
			// if (this.getNo() % 3 == 0) {
			// dis = 0;
			// }
			// 如果该路径在自己负责的分区内
			int distance = 100000;
			if (this.getCommCondition() == CommunicationCondition.NoCommunication
					|| this.getCommCondition() == CommunicationCondition.Limited)
				distance *= 10;

			if (dis <= distance || isInMyPartition(startEntity)
					|| isInMyPartition(finishEntity)) {
				if (finishEntity instanceof Building) {
					Road entrance = getEntranceRoad((Building) finishEntity);
					if (entrance != null) {
						finishId = entrance.getID();
					}
				}
				PFTarget.add(startId.getValue());
				ClearPath task = new ClearPath(startId, finishId,
						message.getClearPathReason());
				clearAgentIsStuckTask.addClearPathTask(task);
				// System.out.println(this.toString() + "+++" + message);
			}
		}
//		if (!(this.getFunctionType() == FunctionType.dynamicQuartations)) {
//			return;
//		}
		EntityID startId = message.getStartId();
		StandardEntity startEntity = world.getEntity(startId);
		EntityID finishId = message.getFinishId();
		StandardEntity finishEntity = world.getEntity(finishId);
		if (finishEntity instanceof Building) {
			Road entrance = getEntranceRoad((Building) finishEntity);
			if (entrance != null) {
				finishId = entrance.getID();
				finishEntity = world.getEntity(finishId);
			}
		}
		// System.out.println(this.getTimeStep() + "---" + this.getID()
		// + "Receive" + message);
		PriorityQueue<ClearPath> clearPathQueue = clearPathTask.getClearPathQueue();
		//System.out.println("processClearPathMessage");
		if (clearPathQueue != null && !clearPathQueue.isEmpty()) {
			for (ClearPath cp : clearPathQueue) {
				if (cp.getRoadIdStart().getValue() == startId.getValue()
						&& cp.getRoadIdFinish().getValue() == finishId
								.getValue()) {
					return;
				}
			}
		}
		int dis = world.getDistance(this.getID(), startId);
		if (!PFTarget.isEmpty() && PFTarget.contains(startId.getValue())) {

			// System.out.println("Same target!");
			return;
		}
		// if (this.getNo() % 3 == 0) {
		// dis = 0;
		// }
		if (this.getTimeStep() > 150) {
			dis = 0;
		}
		// 如果该路径在自己负责的分区内

		if (dis <= 100000 || isInMyPartition(startEntity)
				|| isInMyPartition(finishEntity)) {
			if (finishEntity instanceof Building) {
				Road entrance = getEntranceRoad((Building) finishEntity);
				if (entrance != null) {
					finishId = entrance.getID();
				}
			}
			PFTarget.add(startId.getValue());
			ClearPath task = new ClearPath(startId, finishId,
					message.getClearPathReason());
			clearPathTask.addClearPathTask(task);
			// System.out.println("++++++++++++++++++++++++++++" + message);
		}
	}

	// 智能体被堵，要及时响应
	protected void processAgentIsStuckMessage(AgentIsStuckMessage message) {
		EntityID startId = message.getLocationId();
		EntityID finishId = message.getLocationId();
		StandardEntity startRoad = world.getEntity(startId);
		int dis = world.getDistance(this.getID(), startId);
		// System.out.println(message.getLocationId());
		// System.out.println(this.toString() + "In" + this.getTimeStep() +
		// "---"
		// + this.getID() + "Receive" + message);
		if (!PFTarget.isEmpty() && PFTarget.contains(finishId.getValue())) {
			// System.out.println("same target" + this.toString() + "In"
			// + this.getTimeStep() + "---" + this.getID() + "Receive"
			// + message);
			return;
		}

		// 警察相应智能体的最远距离
		PriorityQueue<ClearPath> clearPathQueue = clearAgentIsStuckTask
				.getClearPathQueue();

		if (clearPathQueue != null && !clearPathQueue.isEmpty()) {
			for (ClearPath cp : clearPathQueue) {
				if (cp.getRoadIdStart().getValue() == finishId.getValue()) {
					// System.out.println("same target" + this.toString() + "In"
					// + this.getTimeStep() + "---" + this.getID()
					// + "Receive" + message);
					return;
				}
			}
		}
		int distance = 100000;
		if (this.getCommCondition() == CommunicationCondition.NoCommunication
				|| this.getCommCondition() == CommunicationCondition.Limited)
			distance *= 10;
		if (this.getTimeStep() > 200) {
			dis = 0;
		}
		if (dis <= distance || isInMyPartition(startRoad)) {
			ClearPath task = new ClearPath(startId, finishId,
					ClearPathReason.AgentIsStuck);
			clearAgentIsStuckTask.addClearPathTask(task);
			PFTarget.add(finishId.getValue());
			// System.out.println(this.toString() + "+" + message);
		}
		// else if (isInMyPartition(startRoad)) {
		// ClearPath task = new ClearPath(startId, finishId,
		// ClearPathReason.AgentIsStuck);
		// clearPathTask.addClearPathTask(task);
		// PFTarget.add(finishId.getValue());
		// }
	}

	@Override
	protected boolean canRescue() {
		return false;
	}

	@SuppressWarnings({ "rawtypes" })
	@Override
	public List<BasicTask> getAgentTasks() {
		if (!world.getEntitiesOfType(StandardEntityURN.POLICE_OFFICE).isEmpty()) {
			existPO = true;
		}
		List<BasicTask> tasks;
		tasks = new ArrayList<BasicTask>();
		/*if(timeStep<150){
		tasks.add(new ClearMainRoadTask(this, distance, mainRoad.get(this
				.getNo() % mainRoad.size())));
		}*/
		tasks.add(new ClearBlockedRoadToRefugeTask(this, distance));//yuan
		//tasks.add(new CheckATAfterShock(this, distance));
		tasks.add(new IsStuckOrBuriedCallHelpTask(this));
		//tasks.add(new ClearOnBlockadeTask(this, distance));
		tasks.add(new SaveMyselfTask(this));
		
		//tasks.add(new ClearNearBlockadeTask(this, distance / 12));
		//tasks.add(new ClearEntranceTask(this, distance));
		tasks.add(new PFStuckInBuildingTask(this));
		tasks.add(new PFStuckInRoadTask(this));
		// 清理路障，保证能通过
		// 这两个顺序还要考虑
		// 在考虑救智能体的问题上，这里以后将尝试用中心调配的方法实现
		tasks.add(new SaveNearStuckAgentTask(this, distance));        //yuan 14.7.22

		tasks.add(new ClearBlockedRoadToGasStationTask(this, distance));//yuan
		clearAgentIsStuckTask = new ClearPathTask(this, distance, false);//yuan
		tasks.add(clearAgentIsStuckTask);
		clearPathTask = new ClearPathTask(this, distance, true);	//yuan
		tasks.add(clearPathTask);
		//tasks.add(new SaveNearStuckAgentTask(this, distance));        //yuan 14.7.22
		//if (functionType == FunctionType.connectQuartations)
		tasks.add(new ClearMainRoadTask(this, distance, mainRoad.get(this  //yuan
					.getNo() % mainRoad.size())));
		tasks.add(new AssignAgentTask(this, distance));       //yuan
		
		tasks.add(new ClearRaodToFireTask(this));
//		if(this.getTimeStep()%10==5){
//			tasks.add(new ClearBlockedRoadToFireTask(this, distance));  //yuan
//		}
		tasks.add(new PartitionExplorationTask(this));
		//tasks.add(new ExploreinpartionTask(this));  /// /wan14.3
		tasks.add(new ClearOnBlockadeTask(this, distance));
		
		tasks.add(new ClearNearBlockadeTask(this, distance / 12));
		tasks.add(new ClearEntranceTask(this, distance));
		//clearPathTask = new ClearPathTask(this, distance, true);	//yuan
		//tasks.add(clearPathTask);
		// ClearCurrentRoadBlockedTask为清理道路上的全部障碍物
		// tasks.add(new ClearCurrentRoadBlockedTask(this, distance));
		// tasks.add(new ClearNearBlockadeTask(this, distance / 12));
		// tasks.add(new ClearBlockedRoadTask(this, distance));
	
		//tasks.add(new ExplorationoutofpartionTask(this));/////
		tasks.add(new RandomWalkTask(this));
		return tasks;
	}
	
//	@Override
// 	public List<BasicTask> getAgentTasks1() {
//		List<BasicTask> tasks;
//		tasks = new ArrayList<BasicTask>();
//		System.out.println("handletasks1!!!!!!");
// 		tasks.add(new ClearBlockedRoadToFireTask(this, distance));
// 		System.out.println("save myself!!!!!!");
// 		return tasks;
// 	}
	 
	public Blockade getClosestBlockade() {
		Human human;
		List<Blockade> blockades;
		MultiBlockDistanceComparator comparator;
		Point position;
		Blockade target;

		human = getMeAsHuman();
		position = PositionLocate.getPosition(human, world);
		comparator = new MultiBlockDistanceComparator(getModel(), position);
		blockades = getBlockades();

		if (blockades.isEmpty()) {
			return null;
		}
		Collections.sort(blockades, comparator);

		target = blockades.get(0);
		return target;
	}

	public Blockade getClosestBlockadeInCurrentLocation() {
		Human human;
		Area area;
		Road road;
		Blockade target;

		human = getMeAsHuman();
		area = (Area) human.getPosition(getModel());

		if (area instanceof Road) {
			road = (Road) area;
			target = getClosestBlockadeInRoad(road);
		} else {
			target = null;
		}

		return target;
	}

	public Path getPathToClosestBlockedRoad() {
		Path path;
		List<Road> blockedRoads;
		Human human;

		human = getMeAsHuman();
		blockedRoads = getBlockedRoads();
		path = search.getPath(human, blockedRoads, PathType.Shortest);
		return path;
	}

	@Override
	public List<MessageType> getMessagesToListen() {
		List<MessageType> types;
		types = new ArrayList<MessageType>();
		types.add(MessageType.ClearPathIsNeededMessage);
		types.add(MessageType.AgentIsStuckMessage);
		types.add(MessageType.AgentIsBuriedMessage);
		types.add(MessageType.BuildingIsExploredMessage);
		types.add(MessageType.AssignRefugeMessage);
		types.add(MessageType.AssignGasStationMessage);
		types.add(MessageType.RoadIsClearedMessage);
		types.add(MessageType.BuildingIsExploreMessage_pf);
		types.add(MessageType.AssignImportantBuildingsMessage);  ///
		
	//	types.add(MessageType.BuildingMaybeMessage_pf);
		return types;
	}

	public SEUWorldModel getWorldModel() {
		return world;
	}

	@Override
	public void sendClear(EntityID targetId) {
		Blockade blockade;
		int id = targetId.getValue();
		blockade = world.getEntity(targetId, Blockade.class);
		if (blockade == null) {
			sendMove(timeStep, randomWalk());
			return;

		}
		if (clearedBlockade.containsKey(id)) {
			if (clearedBlockade.get(id) == blockade.getRepairCost()) {
				int num = numOfClear.get(id);
				num++;
				numOfClear.put(id, num);
				if (num > 5) {
					// System.out.println(this.getID().getValue() + "blockade"
					// + id + " is null I'm randmom walk");
					sendMove(timeStep, randomWalk());
					return;
				}

			}
		}
		if (!RoadUtilities.doesBlockExists(blockade, world)) {
			sendMove(timeStep, randomWalk());
			return;
		}
		Point point = PositionLocate.getPosition(this.getMeAsHuman(),
				getModel());
		int dis = DistanceUtilities.getDistanceToBlock(blockade, point);
		if (dis > distance) {
			sendMove(timeStep, randomWalk());
			return;
		}
		super.sendClear(targetId);
		
		if (!clearedBlockade.containsKey(targetId.getValue())) {
			clearedBlockade.put(id, blockade.getRepairCost());
			numOfClear.put(id, 1);
		}
		if (clearedBlockade.containsKey(targetId.getValue())) {
			if (clearedBlockade.get(id) != blockade.getRepairCost()) {
				clearedBlockade.put(id, blockade.getRepairCost());
				numOfClear.put(id, 1);
			}
		}
	}
	
	@Override
	public void sendClearArea(EntityID targetId) {//niu
		Blockade blockade;
		int id = targetId.getValue();
		blockade = world.getEntity(targetId, Blockade.class);
		if (blockade == null) {
			sendMove(timeStep, randomWalk());
			return;

		}
		if (clearedBlockade.containsKey(id)) {
			if (clearedBlockade.get(id) == blockade.getRepairCost()) {
				int num = numOfClear.get(id);
				num++;
				numOfClear.put(id, num);
				if (num > 5) {
					// System.out.println(this.getID().getValue() + "blockade"
					// + id + " is null I'm randmom walk");
					sendMove(timeStep, randomWalk());
					return;
					
				}

			}
		}
		if (!RoadUtilities.doesBlockExists(blockade, world)) {
			sendMove(timeStep, randomWalk());
			return;
		}
		Point point = PositionLocate.getPosition(this.getMeAsHuman(),
				getModel());
		int dis = DistanceUtilities.getDistanceToBlock(blockade, point);
		if (dis > distance) {
			sendMove(timeStep, randomWalk());
			return;
		}
		super.sendClearArea(targetId);
		
		if (!clearedBlockade.containsKey(targetId.getValue())) {
			clearedBlockade.put(id, blockade.getRepairCost());
			numOfClear.put(id, 1);
		}
		if (clearedBlockade.containsKey(targetId.getValue())) {
			if (clearedBlockade.get(id) != blockade.getRepairCost()) {
				clearedBlockade.put(id, blockade.getRepairCost());
				numOfClear.put(id, 1);
			}
		}
	}

	
	public FunctionType getFunctionType() {
		return functionType;
	}

	public void setFunctionType(FunctionType functionType) {
		this.functionType = functionType;
	}

	public void addAgentIsStuckTask(ClearPath cp) {
		clearAgentIsStuckTask.addClearPathTask(cp);
	}
	
    public boolean hasBlockedInCleaeArea(){
		
		return false;
	}
    
  //---ljz
	private static final String CLEAR_RADIUS_KEY = "clear.repair.rad";
	private static final String CLEAR_RATE_KEY = "clear.repair.rate";
	
	protected int clearRad;
	protected int clearRate;
	protected double clearMin;	
	private int movetry = 0;
  //---ljz
    public ClearPath targetClearPath;

    
    public void sendClearPath(ClearPath targetPath){      //yuan
//    	if(getID().getValue()==327290976)
     	//System.out.println(timeStep+"   "+getID()+"  sendClearPath");
     	try{
  	   if(targetPath==null) {
  		// if(getID().getValue()==327290976)
  		// System.out.println(timeStep+"   "+getID()+" 111111111");
  		   sendMove(timeStep, randomWalk());
  	   }
  	   targetClearPath=targetPath;
  	   StandardEntity finishEntity=world.getEntity(targetPath.getRoadIdFinish());
  	   StandardEntity startEntity=world.getEntity(targetPath.getRoadIdStart());
  	   Area finishArea=null,startArea=null;
  	   if(finishEntity instanceof Building){	  
  		   finishArea=getEntranceRoad((Building)finishEntity);
  		   if(finishArea==null){
//  			 if(getID().getValue()==327290976)
  			 // System.out.println(timeStep+"   "+getID()+"   finishEntity is Building");		 
  			  //targetClearPath.setRoadIds(entranceRoad.getID(),targetPath.getRoadIdStart());
  			  Collection<StandardEntity> entitiesInRange=model.getObjectsInRange((int)finishEntity.getLocation(world).first(), 
  					  (int)finishEntity.getLocation(world).second(), 100000);		  
  			  List<Area> areaInRange=new ArrayList<Area>();
  			  for(StandardEntity next:entitiesInRange){
  				  if(next instanceof Road){
  					  areaInRange.add((Area)next);
  				  }
  			  }
  			  DistanceComparator comparator=new DistanceComparator(finishEntity,world);
			  Collections.sort(areaInRange, comparator);
  			  if(!areaInRange.isEmpty()){
  				  
  				 finishArea=areaInRange.get(0);
  			  }else{
  				finishArea=(Area)finishEntity;
  			  }
  			 
  		   }
  	   }else{
  		  finishArea=(Area)finishEntity;
  	   }	  
 	   if(startEntity instanceof Building){		  
 		   startArea=getEntranceRoad((Building)startEntity);
 		   if(startArea==null){
 			 // if(getID().getValue()==327290976)
 			   //System.out.println(timeStep+"   "+getID()+"   startEntity is Building");
 			  //targetClearPath.setRoadIds(targetPath.getRoadIdStart(), entranceRoad.getID());
 			   Collection<StandardEntity> entitiesInRange=model.getObjectsInRange((int)startEntity.getLocation(world).first(), 
 	 					  (int)startEntity.getLocation(world).second(), 100000);
 	 		   List<Area> areaInRange=new ArrayList<Area>();
 	 		   for(StandardEntity next:entitiesInRange){
 	 			   if(next instanceof Road){
 	 				   areaInRange.add((Area)next);
 	 			   }
 	 		   }
 	 		 DistanceComparator comparator=new DistanceComparator(startEntity,world);
			  Collections.sort(areaInRange, comparator);
 	 		   if(!areaInRange.isEmpty()){
 	 			  startArea=areaInRange.get(0);
 	 		   }else{
 	 			 startArea=(Area)startEntity;
 	 		   }
 	 			  
 		   }
 	   }else{
 		   startArea=(Area)startEntity;
 	   }
 	   targetClearPath.setRoadIds(startArea.getID(),finishArea.getID());
 	  //if(getID().getValue()==327290976)
 	   //System.out.println(timeStep+"   finishEntity is Building1");		
  	   //Blockade targetBlockade;	  
  	   if(isOnStartLocation()) targetClearPath.setHasBeenAtStart(true);
  	   Path movePath=getMovePath();
  	// if(getID().getValue()==327290976)  
    	//   System.out.println(timeStep+"  1111111111111");
  	   //Area desarea=getdesArea();
  	   Blockade targetBlockade;
//  	   if(currentPostion instanceof Building&&me().isBuriednessDefined()&&me().getBuriedness()==0){
//  		
  	   //if(getID().getValue()==327290976)  
  	   //System.out.println(timeStep+"  moveOutBuilding");
// 		   sendMove(movePath);		   
// 	   }
  	 //System.out.println(timeStep+"   finishEntity is Building2");		
  	   if (timeStep >= 4 && getMeAsHuman().getHP() > 0) {
  		 double d = getModel().distance(lastPosition.getLocation(getSEUWorldModel()), 
  	 			   currentPostion.getLocation(getSEUWorldModel()));
  		//if(getID().getValue()==327290976) 
  		 //System.out.println("d="+d+",clearRate="+clearRate+",clearRad="+clearRad+",clearMin="+clearMin);
  		   //可修改参数：clearMin，movetry
  		   if (d <clearMin*0.8||currentPostion.equals(lastPosition)) {
  			  movetry++;
  		   }
  	   } 	  
 	   if(movetry<=2){//没有被卡住
 		   if(isOnStartLocation()||isOnGoalLocation()){//qidian
 			   targetBlockade=getClosestBlockadeInCurrentLocation();
 			   if(targetBlockade!=null){
 				//  if(getID().getValue()==327290976)
 				   //System.out.println(timeStep+"   "+getID()+"  isOnStartLocation||isOnGoalLocation");
 				   movetry=0;
 				  Point agentPoint = PositionLocate.getPosition(getMeAsHuman(),getModel());
 				 //System.out.println(DistanceUtilities.getDistanceToBlock(targetBlockade, agentPoint) +"  ----juli----  "+distance);
 					if (DistanceUtilities.getDistanceToBlock(targetBlockade, agentPoint) < distance*0.95) {
 						//System.out.println(timeStep+"   "+getID()+"  isOnStartLocation||isOnGoalLocation     sendClearArea");
 						 sendClearArea(targetBlockade.getID());
 					}else {
 						Path path = getPathToBlock(targetBlockade);
 						//System.out.println(timeStep+"   "+getID()+"  isOnStartLocation||isOnGoalLocation        sendMove");
 						sendMove(path);
 					}
 				  
 			   }else{
 				   if(isOnGoalLocation()){
 					 // if(getID().getValue()==327290976)
 					   //System.out.println(timeStep+"   "+getID()+"  Completed");
 					   targetClearPath.setIsCompleted(true);
 				   }
 				   if(isOnStartLocation()){
 					 // if(getID().getValue()==327290976)
 					   //System.out.println(timeStep+"   "+getID()+"  onstart and move");
 					   sendMove(movePath);
 				   }
 			   }
 		   }else{//guocheng
 		   if(movePath==null||movePath.isEmpty())
 			{
 			    sendMove(timeStep, randomWalk());
 			  // if(getID().getValue()==327290976)
 			    //System.out.println(timeStep+","+me().getID()+"NO　PATH");
 				return;
 			}
 		   
 		    List<EntityID> clearpath = movePath.getEntities();
 		 //  if(getID().getValue()==327290976)
 		   // System.out.println("all EID:size="+clearpath.size()+","+clearpath);
 		   
 		    EntityID next = clearpath.get(1);
 		    Area nextArea = world.getEntity(next, Area.class);
 		    Point2D myPoint = new Point2D(me().getLocation(world).first(), me().getLocation(world).second());
 		    Edge edge2next = currentPostion.getEdgeTo(nextArea.getID());
 		    Point2D nextACenter = new Point2D((edge2next.getStartX() + edge2next.getEndX())/2.0,
 					(edge2next.getStartY() + edge2next.getEndY())/2.0) ;//相交边的中点
 		    Line2D me2nextAC = new Line2D(myPoint,nextACenter);
 		     //获取清障的两条边界。
             // List<Line2D> clearLine = mathTools.clearAreaLine(myPoint.getX(), myPoint.getY(),
             // 		me2nextAC.getEndPoint().getX(),me2nextAC.getEndPoint().getY(), clearRad);
 		    
 			//me2nextAC = mathTools.clipLine(me2nextAC, distance+clearRad);					           
 			//Line2D checkLine = mathTools.clipLine(me2nextAC, mathTools.getLineLength(me2nextAC)*0.9);
 		    me2nextAC = mathTools.clipLine(me2nextAC, distance);	//yuan
 		    Line2D checkLine = mathTools.clipLine(me2nextAC, mathTools.getLineLength(me2nextAC)*0.9);//yuan
 		   //if(getID().getValue()==327290976)
 			//System.out.println(timeStep+","+me().getID()+"进入清障判断"+"  "+nextACenter.getX()+","+nextACenter.getY());
 			List<EntityID> blks1 = nextArea.getBlockades();
 			List<EntityID> blks2 = currentPostion.getBlockades();
             // TODO: BLKS 在加上当前area的路障
             // if(currentPostion.isBlockadesDefined()&&currentPostion.getBlockades().size()>0){
             // 	blks.addAll(currentPostion.getBlockades());}
 			List<Point2D> intersections1 = new ArrayList<Point2D>();
 			List<Polygon> blockadePolygon=new ArrayList<Polygon>();
 			Point co = new Point((int)checkLine.getOrigin().getX(),(int)checkLine.getOrigin().getY());
 			Point ce = new Point((int)checkLine.getEndPoint().getX(),(int)checkLine.getEndPoint().getY());
 			Polygon blkPoly = new Polygon();
 			if(!(blks1==null||blks1.isEmpty()))
 			for(EntityID id :blks1)
 			{
 				Blockade blk = world.getEntity(id, Blockade.class);
 				blkPoly = mathTools.getPolygon(blk.getApexes());	
 				//blockadePolygon.add(blkPoly);
                 //这一段好像有问题？不知道用addall是不是把交点加进来了。
                 //问题应该是线和blk的外形重叠了。
                 // intersections1.addAll(mathTools.intersections(blkPoly, clearLine.get(0)));
                 // intersections1.addAll(mathTools.intersections(blkPoly, clearLine.get(1)));
 				intersections1.addAll(mathTools.intersections(blkPoly, checkLine));
 				
 			}
 			if(!(blks2==null||blks2.isEmpty()))
 			for(EntityID id :blks2)
 			{
 				Blockade blk = world.getEntity(id, Blockade.class);
 				blkPoly = mathTools.getPolygon(blk.getApexes());
 				blockadePolygon.add(blkPoly);
 				intersections1.addAll(mathTools.intersections(blkPoly, checkLine));				
 			}
 			//自己和下一个区域的所有障碍物都不包含自己所在的点
 			if(intersections1.isEmpty()&&!isPolygonContainPoint(blockadePolygon,co)&&!isPolygonContainPoint(blockadePolygon,ce)){//移动
// 				if(!observableRefuge.isEmpty()){//µ±²»ÐèÒªÇåÀíÂ·Ÿ¶Ê±
//					 EntityID refugeBlockade=getRefugeBlockade();
//					 if(refugeBlockade!=null){
//						 super.sendClear(refugeBlockade);
//						 System.out.println(timeStep+","+me().getID()+"clearObservableRefuge");
//					 }else{
//					      sendMove(movePath);
//			              //TODO:SENDMOVE ¹ßÐÔ
//					      //System.out.println(timeStep+","+me().getID()+"moveµœpathµÄÏÂÒ»Î»ÖÃ£¬»òÕßline"+",TRY: "+movetry);
//				     }	
//				}else{
//					sendMove(movePath);
//		              //TODO:SENDMOVE ¹ßÐÔ
 				//if(getID().getValue()==327290976)
			    //System.out.println(timeStep+","+me().getID()+"moveµœpathµÄÏÂÒ»Î»ÖÃ£¬»òÕßline"+",TRY: "+movetry);
//				}
 				sendMove(movePath);
 			
 			}else{//清障
 			  
 				//if(getID().getValue()==327290976)
 					//System.out.println(timeStep+","+me().getID()+"SENDCLEARAREA");
 			   //System.out.println(timeStep+","+me().getID()+",int size: "+intersections1.size()+",TRY: "+movetry);
 			   Point2D clearPoint = me2nextAC.getEndPoint();
                // TODO: 判断任务结束
                // if(currentPostion.equals(desarea)){
                //taskDone();
                //}
                //不知道下面这行能不能行。
 			  //if(getID().getValue()==327290976)
 			  // System.out.println(timeStep+"  "+clearPoint.getX()+","+clearPoint.getY());
 			   movetry=0;
 			    seuClear command = new seuClear(timeStep, (int)clearPoint.getX(), (int)clearPoint.getY());
 				commands.put(timeStep, command);
 			   super.sendClear(timeStep,(int)clearPoint.getX(),(int)clearPoint.getY());
 			   //super.sendClearArea(timeStep,(int)nextACenter.getX(),(int)nextACenter.getY());
 			}
 		   }
 	   }else{//被卡住
 			//System.out.println(timeStep+","+currentPostion.getID()+"moveFAILED!!!");
             //进入该块，说明：既没有交点，本区和下一区又没有路障交点，但是却2个周期没动，
              //所以一定是附近有路障堵住了,只能清理最近的路障，
 		  //targetBlockade=getStuckBlockade(getMeAsHuman(),false);
 		  //if(targetBlockade==null) targetBlockade=getStuckBlockade(getMeAsHuman(),true);
 			targetBlockade=getClosestBlockade();             //yuan 14.7.22
 			if(targetBlockade!=null){
 				//if(getID().getValue()==327290976)
 				//System.out.println(timeStep+"   "+getID()+"  moveFAILED!!! and clear");
 				movetry=0;
 				sendClearArea(targetBlockade.getID());
 			}else{
 				//if(getID().getValue()==327290976)
 				//System.out.println(timeStep+"   "+getID()+"  moveFAILED!!! and move");
 				sendMove(movePath);
 			}
 	   }
     }catch(Exception e){
    	 System.out.println(getID()+"--------clear Move Path have error---------");     }
     }
    
    protected Path getPathToFinishRoad() {
		Path path;
		Road finishRoad = (Road) getModel().getEntity(
				targetClearPath.getRoadIdFinish());
		path = getSearch().getPath(getMeAsHuman(), finishRoad,
				PathType.Shortest);
		if (path != null && !path.isEmpty()) {
			return path;
		}
		return null;
	}
    
    protected Path getPathToStartRoad() {
		Path path;
		Road startRoad = (Road) getModel().getEntity(
				targetClearPath.getRoadIdStart());
		path = getSearch().getPath(getMeAsHuman(), startRoad,
				PathType.Shortest);
		if (path != null && !path.isEmpty()) {
			return path;
		}
		// System.out.println(currentClearPathTask_.getRoadIdStart().getValue());
		return null;
	}
    
    private boolean isOnGoalLocation() {
		return location().getID().getValue() == targetClearPath.getRoadIdFinish().getValue();
	}

	private boolean isOnStartLocation() {
		return location().getID().getValue() == targetClearPath.getRoadIdStart().getValue();
	}

	private Path getMovePath(){       //yuan 7.13
//		if(getID().getValue()==327290976)
//			System.out.println("getmovepath ");	
		Path movePath;
		if(targetClearPath.hasBeenAtStart()) movePath=getPathToFinishRoad();
		else movePath=getPathToStartRoad();
		StandardEntity s =world.getEntity(movePath.getStart());
//		if(s instanceof Building)
//		System.out.println(getTimeStep()+"   "+getID()+"   "+movePath.getStart()+"startisbuid ");	
		StandardEntity d =world.getEntity(movePath.getDestination());
//		if(d instanceof Building)
//		System.out.println(getTimeStep()+"   "+getID()+"   "+movePath.getDestination()+"desisbuid ");	

//		if(movePath!=null&&movePath.size()>=3){	
//			int moveStep=7;//ŽýÕå×Ã
//			if(moveStep>movePath.size()-1){
//				moveStep=movePath.size()-1;
//			}
//			if(getID().getValue()==327290976)  
//		    	   System.out.println(timeStep+"  3333333333b  "+moveStep);
//			for(int i=1;i<moveStep;i++){
//				Area area=(Area)world.getEntity(movePath.getEntities().get(i));				
//				if(area instanceof Road){
//					boolean isEntrance=false;
//					for(Edge edge:area.getEdges()){
//						if(edge!=null&&edge.isPassable()){
//							Area area1=(Area)world.getEntity(edge.getNeighbour());
//							if(area1!=null&&area1 instanceof Building){
//								isEntrance=true;
//								break;
//							}
//						}
//					}
//					if(getID().getValue()==327290976)  
//				    	   System.out.println(timeStep+"  222222      "+i);
//					if(isEntrance){
//						if(getID().getValue()==327290976)
//						System.out.println("-----------------move entrance from path ");
//						
//						Area upArea=(Area)world.getEntity(movePath.getEntities().get(i-1));	
//						if(getID().getValue()==327290976)  
//					    	   System.out.println(timeStep+"  33333333  QIAN");
//						Edge edge1=upArea.getEdgeTo(movePath.getEntities().get(i+1));
//						if(getID().getValue()==327290976)  
//					    	   System.out.println(timeStep+"  3333333  HOU");
//					
//						if(edge1!=null&&edge1.isPassable()){
//							if(getID().getValue()==327290976)  
//						    	   System.out.println(timeStep+"  444444  QIAN");
//						
//							movePath.remove(i);
//							if(getID().getValue()==327290976)  
//						    	   System.out.println(timeStep+"  444444 HOU");
//					}
//				}				
//			}
//		 }
//		}
//		if(getID().getValue()==327290976)  
//	    	   System.out.println(timeStep+"  22222222222");
		return movePath;
	}
	
	private Area getdesArea(){
		Area desArea;
		if(targetClearPath.hasBeenAtStart()) desArea=(Area)world.getEntity(targetClearPath.getRoadIdFinish());
		else desArea=(Area)world.getEntity(targetClearPath.getRoadIdStart());
		return desArea;
	}
	
	public int numOfMainRoad;//ljz
	public ArrayList<EntityID> MainRoadStr = new ArrayList<EntityID>();//ljz
	public ArrayList<Integer> MainRoadStrSort = new ArrayList<Integer>();//ljz

	public Area targetArea;//wujie
	
	
	public EntityID getClosestMainRoadStr() {//ljz
		int dis = Integer.MAX_VALUE;
		EntityID target = null;
		for (Path r : mainRoad) {
			int temp = world.getDistance(getID(), r.getStart());
			if (temp < dis) {
				dis = temp;
				target = r.getStart();
			}
		}
		return target;
	}
	
	public boolean isPolygonContainPoint(List<Polygon> blockadePolygon,Point point){
		if(blockadePolygon==null) return false;
		else{
			for(Polygon next:blockadePolygon){
				if(next.contains(point)) return true;
			}
		}
		return false;
	}
	public List<Human> getHumansInRange() {//wujie
		if(humansinrange!=null){
			humansinrange.clear();
		if(!(getFoundAgents()==null)){
			humansinrange.addAll(foundAgents);
		}
		if(!(getCiviliansAround()==null)){
			humansinrange.addAll(civiliansAround);
		}
		}
		if(humansinrange!=null){
		for(Human h:humansinrange){
			if(!isStuck(h, true)&&!isStuckInBuilding(h)){
				humansinrange.remove(h);
			}
			Path p=getPathTo(h.getPosition(),PathType.Shortest);
			if(p.size()>3){
				humansinrange.remove(h);
			}
		}
		}
		return humansinrange;
	}
	
	
	Boolean ActLikeCentre=false;
	protected List<PoliceForce> agents=new ArrayList<PoliceForce>();
	private PriorityQueue<ClearPath> clearPathTaskQueue1;
	private List<EntityID>pathStart=new ArrayList<EntityID>();
	private List<ClearPathReason>crs=new ArrayList<ClearPathReason>();
	double[][] costMatrix;
	StandardEntity target;//niu 标定中心分配的点
	
	
	public StandardEntity targetAT;
	public boolean ATisDone;
	public List<AmbulanceTeam> ClearedAT;
//	@Override
//	protected void think(int time, ChangeSet changed, Collection<Command> heard){//niu
//		super.think(time, changed, heard);
//		
//
//		if(timeStep==startTime){
//		Collection<StandardEntity> fireStation = world
//				.getEntitiesOfType(StandardEntityURN.FIRE_STATION);
//		//if(fireStation.isEmpty()){//无中心,ID最大做代理中心 
//			Collection<StandardEntity> fbs = world
//					.getEntitiesOfType(StandardEntityURN.POLICE_FORCE);
//			EntityID maxPF=this.getID();
//			for(StandardEntity fb:fbs ){
//				if(fb.getID().getValue()>maxPF.getValue()){
//					maxPF=fb.getID();
//				}
//			}
//			if(maxPF.equals(getID())){
//				ActLikeCentre=true;
//				//System.out.println("actlikecentre  PF"+ getID());
//			}
//		//}
//		}
//		
//		if(getTimeStep()%10==0 && ActLikeCentre){
//			if(getCommCondition() != CommunicationCondition.NoCommunication &&
//					getCommCondition() != CommunicationCondition.Limited
//					){
//				System.out.println("TIME%10  PF");
//					agents=getAllPoliceForce();
//					clearPathTaskQueue1 = clearPathTask.getClearPathQueue();//?
//					pathStart.clear();
//				if( !clearPathTaskQueue1.isEmpty() ){
//					System.out.println("CLEAR QUEUE NOT NULL  PF");
//					for(ClearPath cp:clearPathTaskQueue1){
//						EntityID eid=cp.getRoadIdStart();
//						ClearPathReason cr=cp.getClearPathReason();
//						if(!pathStart.contains(eid)){
//							pathStart.add(eid);
//							crs.add(cr);
//						}
//					}
//				costMatrix = makingCostMatrix(pathStart, agents);//花費矩阵
//				 int[] assignment = computeVectorAssignments(costMatrix);//与房屋列表对应的FB烈表 
//				
//				 for(int i=0;i<assignment.length;i++){
//		//输出对应关系反了？
//					//借用 AssignImportantBuildingsMessage
//					 AssignImportantBuildingsMessage message=new AssignImportantBuildingsMessage (
//							 pathStart.get(assignment[i]),transidoldtonew(agents.get(i).getID().getValue()),timeStep);
//					
////					 System.out.println("pf !!!!!! send AssignImportantBuildingsMessage!!!   bID "+
////					 message.getBuildingId()+" AID "+	agents.get(i).getID()); 
//					 sendMessage(message, MessagePriority.High);
//					 
//				 }
//				
//				}
//				
//				
//			}
//		}
//			
//	
//		
//	}
    public int[] computeVectorAssignments(double[][] costMatrix) {
        HungarianAssignment hungarianAssignment = new HungarianAssignment(costMatrix);
        int[] temp = hungarianAssignment.execute();
        
        int[] result = null;
        List<Integer> tempList = new ArrayList<Integer>();

        if (temp != null) {
            for (int i : temp) {
                if (i != -1) {
                	
                    tempList.add(i);
                }
            }

            result = new int[tempList.size()];
            
            try{
            for(int i=0;i<tempList.size();i++){
            	
            	result[i]=tempList.get(i);
            	//System.out.println("shishenme ??  "+"  i="+i+" templist i="+tempList.get(i)+" bid "+buildings.get(tempList.get(i))+" aid "+agents.get(i)); 
            }
            }catch(Exception e){}

        }
//对应于智能体列表的房屋序号列表（如第1个智能体分配给第x个房屋）
        return result;
       
    }
	 public double[][] makingCostMatrix( List<EntityID> entitiyids,  List<PoliceForce> agents) {
	        int n = agents.size();
	        int m = entitiyids.size();
	        System.out.println("huafei  PF");
	        double[][] costMatrix = new double[n][m];
	        
	        Fieryness f=StandardEntityConstants.Fieryness.HEATING;
	        for (int i = 0; i < n; i++) {
	        	StandardEntity location=agents.get(i).getPosition(world);
	            for (int j = 0; j < m; j++) {
	            	
	                double distance=model.getDistance(location.getID(), entitiyids.get(j))/1000;
	                StandardEntity se=world.getEntity(entitiyids.get(j));
	                ClearPathReason r=crs.get(j);
//	                int centerX=(int)world.getBounds().getCenterX();
//	    			int centerY=(int)world.getBounds().getCenterY();
//	    			double distance1=world.distance(centerX, centerY, b.getX(),b.getY())/1000;//distance from the center of the map
//	                
//	    			int dis = Integer.MAX_VALUE;
//	    			
//	    			for (GasStation h : this.getAllGasStations()) {
//	    				if(!GasStationBurned.contains(h)){
//	    				int temp = world.getDistance(b.getID(), h.getID());
//	    				if (temp < dis) {
//	    					dis = temp;
//	    					
//	    				}
//	    				}
//	    			}
//	    			dis=dis/1000;
	    			
	    			double entityimportance=getRankPoints(r);
	                costMatrix[i][j] = entityimportance/distance;
	                //System.out.println("cost"+i+"  "+j+costMatrix[i][j]);
	            }
	        }


	        return costMatrix;
	    }
	 private int getRankPoints(ClearPathReason clearPathReason){
		 int rank=0;
		 switch (clearPathReason) {
		 case RefugeIsBlocked:
			 rank=300;
			 break;
		 case GasStationIsBlocked:
		 	
		 	rank=100;
			 break;
		 case AgentIsStuck:
			 
			 rank=250;
			 break;
		 case StuckInBuilding:
			 
			 rank=250;
			 break;
		 case  SaveMySelf:
			 
			 rank=200;
			 break;
		 case SaveHuman:
			 
			 rank=150;
			 break;
		 case MoveHumanToRefuge:
			 
			 rank=120;
			 break;
		 case ExtinguishFire:
			 
			 rank=100;
			 break;
		 case  WaterRefill:
			 
			 rank=80;
			 break;
		 case GoToRefuge:
			 rank=50;
			 break;
		 case ExploreBuilding:
			 rank=10;
			 break;
		 case ExploreRoad:
			 rank=10;
			 break;
		 }
		 return rank;
	 }
	 
//	 protected void processAssignImportantBuildingsMessage(AssignImportantBuildingsMessage message) {
//			System.out.println( "processAssign PF clrearpath Message" );
//			if(getTarget()==null){				
//				 if( transidnewtoold(message.getAgentId().getValue()).getValue()==getID().getValue()){				
//					 StandardEntity b=model.getEntity(message.getBuildingId());
//					 setTarget(b);
//					 System.out.println( "processAssign PF clrearpath Message" 
//					 +" eid "+message.getBuildingId()+" aid "+transidnewtoold(message.getAgentId().getValue()));
//				 }
//		    }
//	}
			
	public StandardEntity getTarget(){
	    return target;
	}
			
	public StandardEntity setTarget(StandardEntity se) {
		target=se;
		return target;
	}
	
	public EntityID getRefugeBlockade(){	 //yuan7.8
		Building refuge1;
		Road refugeEntrance=null;
		Blockade blockade;
		for(EntityID next:observableRefuge){
			refuge1=(Building)world.getEntity(next);
			refugeEntrance=getEntranceRoad(refuge1);
			if(refugeEntrance!=null){
				blockade=getClosestBlockadeInRoad(refugeEntrance);
				if(blockade!=null){
					return blockade.getID();								
				}
			}
		}	
		return null;
	}
		
}