package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class AgentIsBuriedMessage extends Message {

	public AgentIsBuriedMessage() {
		super();
	}

	public AgentIsBuriedMessage(int locationId, EntityID agentId, int timeStep,
			int healtPoint, int buriedness, int damage) {
		this();
		setInteger(PropertyName.LocationId, locationId);
		setEntityId(PropertyName.AgentId, agentId);
		// setInteger(PropertyName.TimeStep, timeStep);
		setInteger(PropertyName.HealthPoint, healtPoint / 50 + 1);
		setInteger(PropertyName.Buriedness, buriedness / 5 + 1);
		setInteger(PropertyName.Damage, damage);
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.LocationId, 2));
		properties.add(new IntegerProperty(PropertyName.AgentId, 1));
		// properties.add(new IntegerProperty(PropertyName.TimeStep, 2));
		properties.add(new IntegerProperty(PropertyName.HealthPoint, 1));
		properties.add(new IntegerProperty(PropertyName.Buriedness, 1));
		properties.add(new IntegerProperty(PropertyName.Damage, 2));
		return properties;
	}

	public int getbyte() {
		return 7;
	}

	@Override
	public MessageType getType() {
		return MessageType.AgentIsBuriedMessage;
	}

	public EntityID getAgentId() {
		return getEntityId(PropertyName.AgentId);
	}

	public int getLocationId() {
		return getInteger(PropertyName.LocationId);
	}

	public int getDamage() {
		return getInteger(PropertyName.Damage);
	}

	public int getBuriedness() {
		return getInteger(PropertyName.Buriedness) * 5;
	}

	public int getHp() {
		return getInteger(PropertyName.HealthPoint) * 50;
	}

	 public int getTimeStep() {
	 return getInteger(PropertyName.TimeStep);
	 }

}
