package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class AgentPositionMessage extends Message {

	public AgentPositionMessage() {//更新位置
		super();
	}

	public AgentPositionMessage(EntityID locationId, EntityID agentId, int timeStep
			) {
		this();
		setEntityId(PropertyName.LocationId, locationId);
		setEntityId(PropertyName.AgentId, agentId);
		setInteger(PropertyName.TimeStep, timeStep);
		
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.LocationId, 2));
		properties.add(new IntegerProperty(PropertyName.AgentId, 1));
		properties.add(new IntegerProperty(PropertyName.TimeStep, 2));
		
		return properties;
	}

	public int getbyte() {
		return 5;
	}

	@Override
	public MessageType getType() {
		return MessageType.AgentPositionMessage;
	}

	public EntityID getAgentId() {
		return getEntityId(PropertyName.AgentId);
	}

	public EntityID getLocationId() {
		return getEntityId(PropertyName.LocationId);
	}

	

	 public int getTimeStep() {
	 return getInteger(PropertyName.TimeStep);
	 }

}
