package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class AssignImportantBuildingsMessage extends Message{



	public AssignImportantBuildingsMessage() {
		super();
	}

	public AssignImportantBuildingsMessage(EntityID buildingId, EntityID agentId, int timeStep) {
		this();
		setEntityId(PropertyName.BuildingId, buildingId);
		setEntityId(PropertyName.AgentId, agentId);
		
		setInteger(PropertyName.TimeStep, timeStep);
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.BuildingId, 2));
		properties.add(new IntegerProperty(PropertyName.AgentId, 1));
		
		properties.add(new IntegerProperty(PropertyName.TimeStep, 1));
		return properties;
	}

	public int getbyte() {
		return 4;
	}

	@Override
	public MessageType getType() {
		return MessageType.AssignImportantBuildingsMessage;
	}

	public EntityID getBuildingId() {
		return getEntityId(PropertyName.BuildingId);
	}
	public EntityID getAgentId() {
		return getEntityId(PropertyName.AgentId);
	}
	
	public int getTimeStep() {
		return getInteger(PropertyName.TimeStep);
	}


}
