package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class BuildingCloseToGasStationIsBurningMessage extends BuildingIsBurningMessage {//meiyong
	public BuildingCloseToGasStationIsBurningMessage() {
		super();
	}

	
	public BuildingCloseToGasStationIsBurningMessage(EntityID buildingId, int fieryness,
			int temperature,int importance, int timeStep) {
		this();
		setEntityId(PropertyName.BuildingId, buildingId);
		setInteger(PropertyName.Fieryness, fieryness);
		setInteger(PropertyName.Temperature, temperature / 5 + 1);
		setInteger(PropertyName.Importance, importance);//NIU
		setInteger(PropertyName.TimeStep, timeStep);
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.BuildingId, 2));
		properties.add(new IntegerProperty(PropertyName.Fieryness, 1));
		properties.add(new IntegerProperty(PropertyName.Temperature, 1));
		properties.add(new IntegerProperty(PropertyName.Importance, 1));//NIU
		properties.add(new IntegerProperty(PropertyName.TimeStep, 1));
		return properties;
	}

	public int getbyte() {
		return 6;
	}

	@Override
	public MessageType getType() {
		return MessageType.BuildingIsBurningMessage;
	}

	public EntityID getBuildingId() {
		return getEntityId(PropertyName.BuildingId);
	}

	public int getFieryness() {
		return getInteger(PropertyName.Fieryness);
	}

	public int getTemperature() {
		return getInteger(PropertyName.Temperature) * 5;
	}
	public int getImportance() {
		return getInteger(PropertyName.Importance);
	}
	public int getTimeStep() {
		return getInteger(PropertyName.TimeStep);
	}
}
