package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class ExtinguishFireTaskMessage extends Message {

	public ExtinguishFireTaskMessage() {
		super();
	}

	public ExtinguishFireTaskMessage(int buildingId, EntityID agentId) {
		this();
		setInteger(PropertyName.BuildingId, buildingId);
		setEntityId(PropertyName.AgentId, agentId);
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.BuildingId, 2));
		properties.add(new IntegerProperty(PropertyName.AgentId, 1));
		return properties;
	}

	public int getbyte() {
		return 3;
	}

	@Override
	public MessageType getType() {
		return MessageType.ExtinguishFireTaskMessage;
	}

	public int getBuildingId() {
		return getInteger(PropertyName.BuildingId);
	}

	public EntityID getAgentId() {
		return getEntityId(PropertyName.AgentId);
	}
}
