package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class InformTeamMessage extends Message {

	public InformTeamMessage() {
		super();
	}

	public InformTeamMessage(EntityID agentId, EntityID targetRefugeId,
			int buriedness) {
		this();
		setEntityId(PropertyName.AgentId, agentId);
		setEntityId(PropertyName.LocationId, targetRefugeId);
		setInteger(PropertyName.Buriedness, buriedness / 5 + 1);
		// setEnum(PropertyName.ClearPathReason, clearPathReson);
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.AgentId, 1));
		properties.add(new IntegerProperty(PropertyName.LocationId, 2));
		properties.add(new IntegerProperty(PropertyName.Buriedness, 1));
		// properties.add(new IntegerProperty(PropertyName.ClearPathReason, 2));
		return properties;
	}

	public int getbyte() {
		return 4;
	}

	@Override
	public MessageType getType() {
		return MessageType.InformTeamMessage;
	}

	public EntityID getAgentId() {
		return getEntityId(PropertyName.AgentId);
	}

	public EntityID getLocationId() {
		return getEntityId(PropertyName.LocationId);
	}

	public int getBuriedness() {
		return getInteger(PropertyName.Buriedness) * 5;
	}

	@Override
	public String toString() {
		return getType() + "(" + getAgentId().getValue() + ", "
				+ getLocationId().getValue() + "," + getBuriedness() + ")";
	}

}
