package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class InformTeamSavingCivilianMessage extends Message {

	public InformTeamSavingCivilianMessage() {
		super();
	}

	public InformTeamSavingCivilianMessage(int buildingId, EntityID civilianId,
			int buriedness, int timeStep) {
		this();
		setInteger(PropertyName.BuildingId, buildingId);
		setEntityId(PropertyName.CivilianId, civilianId);
		setInteger(PropertyName.Buriedness, buriedness / 5 + 1);
		// setInteger(PropertyName.TimeStep, timeStep);
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.BuildingId, 2));
		properties.add(new IntegerProperty(PropertyName.CivilianId, 1));
		properties.add(new IntegerProperty(PropertyName.Buriedness, 1));
		// properties.add(new IntegerProperty(PropertyName.TimeStep, 2));
		return properties;
	}

	public int getbyte() {
		return 4;
	}

	@Override
	public MessageType getType() {
		return MessageType.InformTeamSavingCivilianMessage;
	}

	public EntityID getBuildingId() {
		return getEntityId(PropertyName.BuildingId);
	}

	public EntityID getCivilianId() {
		return getEntityId(PropertyName.CivilianId);
	}

	public int getBuriedness() {
		return getInteger(PropertyName.Buriedness) * 5 + 1;
	}

	// public int getTimeStep() {
	// return getInteger(PropertyName.TimeStep);
	// }

}
