package seu.message.Type;

import java.util.List;

import seu.message.Property.IntegerProperty;
import seu.message.Property.PropertyName;
import seu.message.newPart.MessageCount1;
import seu.message.newPart.MessageCount10;
import seu.message.newPart.MessageCount2;
import seu.message.newPart.MessageCount3;
import seu.message.newPart.MessageCount4;
import seu.message.newPart.MessageCount5;
import seu.message.newPart.MessageCount6;
import seu.message.newPart.MessageCount7;
import seu.message.newPart.MessageCount8;
import seu.message.newPart.MessageCount9;

public enum MessageType {
	BlankMessage(BlankMessage.class), CivilianInformationMessage(
			CivilianInformationMessage.class), BuildingMaybeMessage_at(
			BuildingMaybeMessage_at.class),BuildingMaybeMessage_pf(
			BuildingMaybeMessage_pf.class), BuildingMaybeMessage(
			BuildingMaybeMessage.class), CivilianMaybeMessage(
			CivilianMaybeMessage.class), BuildingIsExploreMessage_fb(
			BuildingIsExploreMessage_fb.class), BuildingIsExploreMessage_pf(
			BuildingIsExploreMessage_pf.class), 
			BuildingIsExploreMessage_at(
					BuildingIsExploreMessage_at.class),               ///wan
					StateInformationMessage(                     
			StateInformationMessage.class), RegionAssignmentMessage(
			PartitionAssignmentMessage.class), CountMessage(MessageCount.class), BuildingIsExploredMessage(
			BuildingIsExploredMessage.class), RegionResignMessage(
			RegionResignMessage.class), InformTeamMessage(
			InformTeamMessage.class), ClearPathIsNeededMessage(
			ClearPathIsNeededMessage.class), BuildingIsBurningMessage(
			BuildingIsBurningMessage.class), GasStationIsBurningMessage(GasStationIsBurningMessage.class),//niu
			BuildingCloseToGasStationIsBurningMessage(BuildingCloseToGasStationIsBurningMessage.class),//niu
			ExtinguishFireTaskMessage(ExtinguishFireTaskMessage.class), InformTeamSavingCivilianMessage(
			InformTeamSavingCivilianMessage.class), InformTeamExtinguishingFireMessage(
			InformTeamExtinguishingFireMessage.class), AgentIsStuckMessage(
			AgentIsStuckMessage.class), BuildingIsExtinguishedMessage(
			BuildingIsExtinguishedMessage.class),GasStationIsExtinguishedMessage(//niu
			GasStationIsExtinguishedMessage.class),ImportantBuildingsMessage(ImportantBuildingsMessage.class),//niu
			AssignImportantBuildingsMessage(AssignImportantBuildingsMessage.class),//niu
			GetTaskAssignmentMessage(
			GetTaskAssignmentMessage.class), ExtinguishHelpMessage(
			ExtinguishHelpMessage.class), CivilianIsSavedOrDeadMessage(
			CivilianIsSavedOrDeadMessage.class), AgentIsBuriedMessage(
			AgentIsBuriedMessage.class), AssignRefugeMessage(
			AssignRefugeMessage.class), AssignGasStationMessage(//niu
			AssignGasStationMessage.class),RoadIsClearedMessage(
			RoadIsClearedMessage.class), AssignFiredBuildingMessage(
			AssignFiredBuildingMessage.class), HelpSaveHumanMessage(
			HelpSaveHumanMessage.class), MessageCount1(MessageCount1.class), MessageCount2(
			MessageCount2.class), MessageCount3(MessageCount3.class), MessageCount4(
			MessageCount4.class), MessageCount5(MessageCount5.class), MessageCount6(
			MessageCount6.class), MessageCount7(MessageCount7.class), MessageCount8(
			MessageCount8.class), MessageCount9(MessageCount9.class), MessageCount10(
			MessageCount10.class),AgentPositionMessage(AgentPositionMessage.class),
			

	ChannelCondition(ChannelCondition.class);

	private Class<? extends Message> messageClass;

	private static int getRequiredByteCount() {
		return 1;
	}

	private MessageType(Class<? extends Message> messageClass) {
		this.messageClass = messageClass;
	}

	public Class<? extends Message> getMessageClass() {
		return messageClass;
	}

	/**
	 * Returns a new message instance of associated type
	 * 
	 * @return message instance
	 */
	public Message newInstance() {
		Message message = null;
		try {
			message = messageClass.newInstance();
		} catch (Exception ex) {
			// LOG.fatal(message, ex);
		}
		return message;
	}

	/**
	 * Returns the messageType instance associated with the given class
	 * 
	 * @param messageClass
	 *            the class of message
	 * @return the message type
	 */
	public static MessageType getMessageType(Class<Message> messageClass) {
		for (MessageType type : MessageType.values()) {
			if (type.getMessageClass() == messageClass) {
				return type;
			}
		}
		return null;
	}

	public List<Byte> getBytes() {
		int n = ordinal();
		IntegerProperty property = getProperty();
		List<Byte> bytes = property.getBytes(n);
		return bytes;
	}

	public static MessageType getMessageType(byte[] bytes) {
		IntegerProperty property = getProperty();
		int index = property.getValue(bytes, 0);
		MessageType type;

		if (index < values().length) {
			type = values()[index];
		} else {
			type = null;
		}
		return type;
	}

	public static IntegerProperty getProperty() {
		int byteCount = getRequiredByteCount();
		IntegerProperty property = new IntegerProperty(
				PropertyName.MessageType, byteCount);
	//	System.out.println("MessageType: "+property);//输出全为： MessageType: MessageType(1)
		return property;
	}
}