    package seu.message;

import java.util.HashSet;
import java.util.List;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import seu.agent.SEUAgent;
import seu.message.Type.AgentIsBuriedMessage;
import seu.message.Type.AgentIsStuckMessage;
import seu.message.Type.BuildingIsBurningMessage;
import seu.message.Type.BuildingIsExtinguishedMessage;
import seu.message.Type.GasStationIsBurningMessage;//niu
import seu.message.Type.BuildingCloseToGasStationIsBurningMessage;//niu
import seu.message.Type.Message;
import seu.object.Building.SEUBuilding;

public class messageKeeper {     //喊话消息保存器   wan 

	private HashSet<Message> messages;
	private static int keepSteps = 10;           ////以前30
	public SEUAgent agent;
	private BuildingIsBurningMessage buildingIsBurning;
	private GasStationIsBurningMessage gasStationIsBurning;//niu
	private BuildingCloseToGasStationIsBurningMessage buildingCloseToGasStationIsBurningMessage;//niu
	private AgentIsBuriedMessage agentIsBuried;
	private AgentIsStuckMessage agentIsStuckMessage;
	private BuildingIsExtinguishedMessage buildingIsExtinguishedMessage;  ///wan
	int timer1 = 10;
	int timer2 = 10;

	public messageKeeper(SEUAgent agent1) {
		agent = agent1;
		// messages = new HashSet<Message>();
	}

	public void addMessage(Message message1) {

		// if (shouldProcessMessage(message1))
     
    	   // messages.add(message1);
		if (message1 instanceof BuildingIsBurningMessage){
			  
			buildingIsBurning = (BuildingIsBurningMessage) message1;
		 }
		// buildingIsBurning.setFieryness(1);
		if (message1 instanceof GasStationIsBurningMessage)//niu
			gasStationIsBurning = (GasStationIsBurningMessage) message1;
		if (message1 instanceof BuildingCloseToGasStationIsBurningMessage)//niu
			buildingCloseToGasStationIsBurningMessage = (BuildingCloseToGasStationIsBurningMessage) message1;
		if (message1 instanceof AgentIsBuriedMessage) {
			 
			agentIsBuried = (AgentIsBuriedMessage) message1;
		}

		if (message1 instanceof AgentIsStuckMessage){
		 
			agentIsStuckMessage = (AgentIsStuckMessage) message1;
		}
		if (message1 instanceof BuildingIsExtinguishedMessage){         //wan
			buildingIsExtinguishedMessage = (BuildingIsExtinguishedMessage) message1;
		}

	}

	public void clearOldMessages(int step) {
		/*
		 * if (messages.isEmpty()) return;
		 * 
		 * HashSet<Message> copy = new HashSet<Message>(messages);
		 * 
		 * for (Message message : copy) { if (message != null) { if (message
		 * instanceof BuildingIsBurningMessage)
		 * 
		 * if (((BuildingIsBurningMessage) message).getTimeStep() + keepSteps <
		 * step)
		 * 
		 * messages.remove(message);
		 * 
		 * 
		 * } }
		 */

		if (buildingIsBurning != null)
			if (buildingIsBurning.getTimeStep() + keepSteps < step)
				buildingIsBurning = null;

		if (agentIsBuried != null)
			if (agentIsBuried.getReceivedStep() + keepSteps < step)
				agentIsBuried = null;

		if (agentIsStuckMessage != null)
			if (agentIsStuckMessage.getReceivedStep() + keepSteps < step)
				agentIsStuckMessage = null;
		
		if (buildingIsExtinguishedMessage != null)
			if (buildingIsExtinguishedMessage.getReceivedStep() + keepSteps < step)
				buildingIsExtinguishedMessage = null;
		
 

	}

	public void clear(Building building) {

		if (buildingIsBurning != null)
			if (buildingIsBurning.getBuildingId() == building.getID())
				buildingIsBurning = null;

	}

	public boolean shouldProcessMessage(Message message) {

		if (messages.size() >= 2)
			return false;
		for (Message m : messages) {

			if (m.equals(message)) {
				System.out.println("Equals");
				return false;
			}
		}

		return true;
	}

	public void sendMessageRepeatlly() {              ////wan
		
		boolean BadCommCondition=false;
		if((agent.getCommCondition() == CommunicationCondition.NoCommunication
						|| agent.getCommCondition() == CommunicationCondition.Limited))
			BadCommCondition=true;
		boolean nocenter=false;
		if(agent.getAllFireStation().size()==0||agent.getAllAmbulanceCenter().size()==0
			||agent.getAllPoliceOffice().size()==0)
			nocenter=true;
		
		//System.out.println("CommCondition"+CommCondition);
		if (agent.isStuck(agent.getMeAsHuman(), false)) {
			AgentIsStuckMessage agentIsStuckMessage = new AgentIsStuckMessage(
					agent.location().getID(),agent.getTimeStep());
			agent.sendVoiceMessage(agentIsStuckMessage, MessagePriority.High);
			agent.sendMessage(agentIsStuckMessage, MessagePriority.High);
			//System.out.println(agent.getID()+"-------------自救喊话--11111----AgentIsStruck--------------"+agent.location().getID());
		//	return;
		}
		if (agent.isBuried()) {
			// System.err.println("BURIED!!!!!");
			AgentIsBuriedMessage agentIsBuriedMessage = new AgentIsBuriedMessage(
					agent.location().getID().getValue(),
					agent.transidoldtonew(agent.getMeAsHuman().getID()
							.getValue()), agent.getTimeStep(), agent
							.getMeAsHuman().getHP(), agent.getMeAsHuman()
							.getBuriedness(), agent.getMeAsHuman().getDamage());
			agent.sendVoiceMessage(agentIsBuriedMessage, MessagePriority.High);
			agent.sendMessage(agentIsBuriedMessage, MessagePriority.High);
			//System.out.println(agent.getID()+"-------------自救喊话--11111----AgentIsBuried--------------");
			//return;
		}

		List<Human> temp = null;
		temp = agent.getFoundAgents();   

		if (temp != null) {            
			if (!temp.isEmpty()) {
				for (Human h : temp) {
					if (h instanceof FireBrigade
							&&(BadCommCondition||nocenter)) {      ///对看到的FB喊话前首先查看仿真是否已灭     wan
						//SEUBuilding seubuilding=agent.getSEUWorldModel().getSEUBuilding(buildingIsBurning.getBuildingId());
						//if(seubuilding.getSelfBuilding().isFierynessDefined()&&seubuilding.getEstimatedFieryness()>0&&seubuilding.getEstimatedFieryness()<4){
						if(buildingIsExtinguishedMessage==null&&buildingIsBurning!=null)  {
							if(agent.getMeAsHuman() instanceof FireBrigade ) 
								agent.sendMessage(buildingIsBurning, MessagePriority.High);
							
							agent.sendVoiceMessage(buildingIsBurning,MessagePriority.High);	
						     // System.out.println(agent.getID()+"------------见到FB--22222---喊话救火-------------");
						}
						if(buildingIsExtinguishedMessage!=null&&buildingIsBurning!=null ){
							
							if(buildingIsBurning.getId()!=buildingIsExtinguishedMessage.getId()){
								if(agent.getMeAsHuman() instanceof FireBrigade ) 
									agent.sendMessage(buildingIsBurning, MessagePriority.High);
								agent.sendVoiceMessage(buildingIsBurning,MessagePriority.High);	
						    // System.out.println(agent.getID()+"------------见到FB--22222---喊话救火-------------");
							}else{
								buildingIsBurning=null;
							  }
							
							}
						
					if(buildingIsExtinguishedMessage!=null){
						if(agent.getMeAsHuman() instanceof FireBrigade ) 
							agent.sendMessage(buildingIsExtinguishedMessage, MessagePriority.High);
						agent.sendVoiceMessage(buildingIsExtinguishedMessage,MessagePriority.High);	
					  //  System.out.println(agent.getID()+"------------见到FB--22222---喊话火已经扑灭-------------");
						}  
					 
					}
					if (h instanceof AmbulanceTeam&&agentIsBuried!=null
							&&(BadCommCondition||nocenter)) {
						if(agent.getMeAsHuman() instanceof AmbulanceTeam ) 
							agent.sendMessage(agentIsBuried, MessagePriority.High);
						agent.sendVoiceMessage(agentIsBuried, MessagePriority.High);
						//System.out.println(agent.getID()+"------------见到AT--22222---agentIsBuried-------------");
					}
					if (h instanceof PoliceForce&&agentIsStuckMessage!=null
							&&(BadCommCondition||nocenter)) {
						if(agent.getMeAsHuman() instanceof PoliceForce ) 
							agent.sendMessage(agentIsStuckMessage, MessagePriority.High);
						agent.sendVoiceMessage(agentIsStuckMessage,
						MessagePriority.High);
						//System.out.println(agent.getID()+"------------见到PF--22222---agentIsStuckMessage-------------");
					}

				}
//				if (flag == -1) {
//					System.out.println("No ideal man is around!");
//					return;
//				}
//
//				if (agentIsBuried != null && flag == 1) {
//					agent.sendVoiceMessage(agentIsBuried, MessagePriority.High);
//				} else if (agentIsStuckMessage != null && flag == 2) {
//					agent.sendVoiceMessage(agentIsStuckMessage,
//							MessagePriority.High);
//				} else if (buildingIsBurning != null) {
//					agent.sendVoiceMessage(buildingIsBurning,
//							MessagePriority.High);
//
//				}

			}

		} 
		 
//			System.out.println("No one is around!");
//
//		}
		if(temp.isEmpty()||temp==null||temp.size()==0){
		if(buildingIsBurning!=null&&agent.getTimeStep()-buildingIsBurning.getReceivedStep()<=10
				&&(BadCommCondition||nocenter))
		{
			if(agent.getMeAsHuman() instanceof FireBrigade ) 
				agent.sendMessage(buildingIsBurning, MessagePriority.Medium);
			//SEUBuilding seubuilding=agent.getSEUWorldModel().getSEUBuilding(buildingIsBurning.getBuildingId());
			//if(seubuilding.getSelfBuilding().isFierynessDefined()&&seubuilding.getEstimatedFieryness()>0&&seubuilding.getEstimatedFieryness()<4){
			agent.sendVoiceMessage(buildingIsBurning,
					MessagePriority.Medium);
			////System.out.println(agent.getID()+"----------不停喊话--333333---救火-----------");	
			//}
		}

		if(buildingIsExtinguishedMessage!=null
				&&agent.getTimeStep()-buildingIsExtinguishedMessage.getReceivedStep()<=10
				&&(BadCommCondition||nocenter))
		{
			
			if(buildingIsBurning!=null&&buildingIsBurning.getId()==buildingIsExtinguishedMessage.getId()){
				buildingIsBurning=null; 
				}
			if(agent.getMeAsHuman() instanceof FireBrigade ) 
				agent.sendMessage(buildingIsExtinguishedMessage, MessagePriority.Medium);
			//SEUBuilding seubuilding=agent.getSEUWorldModel().getSEUBuilding(buildingIsBurning.getBuildingId());
			//if(seubuilding.getSelfBuilding().isFierynessDefined()&&seubuilding.getEstimatedFieryness()>0&&seubuilding.getEstimatedFieryness()<4){
			agent.sendVoiceMessage(buildingIsExtinguishedMessage,
					MessagePriority.Medium);
			//System.out.println(agent.getID()+"----------不停喊话--333333--火已经扑灭-----------");	
			//}
		}
		if(agentIsBuried!=null&&agent.getTimeStep()-agentIsBuried.getReceivedStep()<=10
				&&(BadCommCondition||nocenter))
		{
			if(agent.getMeAsHuman() instanceof AmbulanceTeam ) 
				agent.sendMessage(agentIsBuried, MessagePriority.Medium);
			agent.sendVoiceMessage(agentIsBuried,
					MessagePriority.Medium);	
			//System.out.println(agent.getID()+"----------不停喊话--333333---agentIsBuried-----------");	
		}
		
		if(agentIsStuckMessage!=null
				&&agent.getTimeStep()-agentIsStuckMessage.getReceivedStep()<=10
				&&(BadCommCondition||nocenter))
		{
			if(agent.getMeAsHuman() instanceof PoliceForce ) 
				agent.sendMessage(agentIsStuckMessage, MessagePriority.Medium);
			agent.sendVoiceMessage(agentIsStuckMessage,
					MessagePriority.Medium);	
			//System.out.println(agent.getID()+"----------不停喊话--333333---agentIsStuckMessage-----------");
		}
		}
		
		
		
		
	}

}
