package seu.object.Building;

import java.util.Comparator;

import rescuecore2.standard.entities.Building;
import seu.object.SEUWorldModel;

public class BurningBuildingComparator implements Comparator<Building> {

	public SEUWorldModel world;
	public int time;

	public BurningBuildingComparator(SEUWorldModel model, int timeStep) {
		world = model;
		time = timeStep;
	}

	public int compare(Building o1, Building o2) {
		double r1, r2;
		BuildingInfo info1, info2;
		int d;
		//gasstation importance=5
        int imp1=o1.getImportance();
        int imp2=o2.getImportance();
        if(imp1>imp2){d=1;	}
        else if(imp2>imp1){d=-1;}
        else{d = 0;}

		if (d == 0) {

			info1 = world.getBuildingInfo(o1.getID());
			info2 = world.getBuildingInfo(o2.getID());
			r1 = info1.getHeatingSpeed(time);
			r2 = info2.getHeatingSpeed(time);
			d = (int) (r1- r2);
		}
		return d;
	}

}
