package seu.utilities.Search.Cost;

import java.util.Collection;

import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.object.SEUWorldModel;
import seu.utilities.Search.Node.Node;

public class StuckAgentCostFunction extends CostFunction<Node> {
	// private final Logger LOG =
	// Logger.getLogger(StuckAgentCostFunction.class);

	SEUWorldModel world;

	public StuckAgentCostFunction(SEUWorldModel model) {
		world = model;
	}

	@Override
	public double getCost(Node current, Node next) {
		Collection<StandardEntity> humans = world.getEntitiesOfType(
				StandardEntityURN.AMBULANCE_TEAM,
				StandardEntityURN.POLICE_FORCE, StandardEntityURN.FIRE_BRIGADE,
				StandardEntityURN.CIVILIAN);
		double cost;
		EntityID commonAreaId;

		commonAreaId = current.getCommonConnection(next);
		cost = 0;
		for (StandardEntity entity : humans) {
			if(entity instanceof Human){
			Human human = (Human) entity;
			EntityID positionId;

			positionId = human.getPosition();
			if (positionId.equals(commonAreaId)) {
				cost += getMaxCost();
			}
			}
		}
		// LOG.trace("Stuck cost" + cost);
		return cost;
	}

	@Override
	public double getHeuristic(Node node, Node goal) {
		return 0;
	}

}
