package seu.utils.geo;

/**
 * 
 * @author Fun
 * 
 */
public class Line {
	private Point origin;
	private Point end;

	public Line(Point origin, Point end) {
		this.origin = origin;
		this.end = end;
	}

	public Line(int x1, int y1, int x2, int y2) {
		origin = new Point(x1, y1);
		end = new Point(x2, y2);
	}

	public Point getOrigin() {
		return this.origin;
	}

	public Point getEnd() {
		return this.end;
	}

	public void setOrigin(Point origin) {
		this.origin = origin;
	}

	public void setEnd(Point end) {
		this.end = end;
	}

	public boolean contains(Point p) {
		long ret = GeoUtils.onWhichSide(origin, end, p);
		if (ret == 0) {
			return true;
		} else {
			return false;
		}
	}

	public Point getPoint(double t) {
		return new Point(origin.x() + (int) (t * (end.x() - origin.x())), origin.y()
				+ (int) (t * (end.y() - origin.y())));
	}

	public Point getMidPoint() {
		return new Point((origin.x() + end.x()) / 2, (origin.y() + end.y()) / 2);
	}

	@Override
	public String toString() {
		return "Line [(" + origin.x() + "," + origin.y() + "), (" + end.x() + "," + end.y() + ")]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + origin.x();
		result = prime * result + origin.y();
		result = prime * result + end.x();
		result = prime * result + end.y();
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Line other = (Line) obj;
		if (!origin.equals(other.origin))
			return false;
		if (!end.equals(other.end))
			return false;
		return true;
	}
}
