package seu.utils.geo;


/**
 * 
 * @author Ivan
 * 
 */
public class Point implements IPositioning {
	private final int x, y;

	public Point(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public int x() {
		return x;
	}

	public int y() {
		return y;
	}

	public double distance(Point p) {
		return distance(p.x, p.y);
	}

	public double distance(int x, int y) {
		int dx = this.x - x;
		int dy = this.y - y;
		double rv = 1.0 * dx * dx + 1.0 * dy * dy;
		return Math.sqrt(rv);
	}

	@Override
	public String toString() {
		return "Point (" + x + "," + y + ")";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + x;
		result = prime * result + y;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Point other = (Point) obj;
		if (x != other.x)
			return false;
		if (y != other.y)
			return false;
		return true;
	}

	@Override
	public int getX() {
		return x;
	}

	@Override
	public int getY() {
		return y;
	}

}
